import { useState as ar, useEffect as Pr, useRef as fs, useMemo as Un } from "react";
const hs = {
  required: (e) => `${e.missingProperty} is required.`,
  minLength: (e) => e.limit === 1 ? "This field is required." : `Should be at least ${e.limit} characters long.`,
  maxLength: (e) => `Should not exceed ${e.limit} characters.`,
  pattern: () => "Invalid format.",
  minimum: (e) => `Should be greater than or equal to ${e.limit}.`,
  maximum: (e) => `Should be less than or equal to ${e.limit}.`,
  enum: (e) => {
    var t;
    return `${(t = e.allowedValues) == null ? void 0 : t.join(", ")} are the only allowed values.`;
  },
  type: (e) => `Should be of type ${e.type}.`,
  format: (e) => `Should be in ${e.format} format.`
}, ms = (e) => e ? e.slice(1) : null, ps = (e, t) => {
  const r = "Unknown validation error";
  try {
    const n = e, a = n.keyword, o = { ...hs, ...t }[a];
    return typeof o == "function" ? o(n.params) : e.message || r;
  } catch {
    return r;
  }
}, Zt = (e, t) => e.reduce((r, n) => {
  const a = ms(n == null ? void 0 : n.instancePath);
  return a ? {
    ...r,
    [a]: ps(n, t)
  } : r;
}, {}), qn = (e) => {
  const t = {};
  for (const r in e)
    Object.prototype.hasOwnProperty.call(e, r) && (t[r] = { value: e[r], error: "" });
  return t;
}, Mt = (e) => e == null ? "" : e ?? "", $s = (e, t) => {
  t.forEach((r) => {
    e.getKeyword(r.keyword) || e.addKeyword(r);
  });
};
var ys = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function Vr(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var Or = { exports: {} }, la = {}, Ce = {}, wt = {}, St = {}, X = {}, Et = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.regexpCode = e.getEsmExportName = e.getProperty = e.safeStringify = e.stringify = e.strConcat = e.addCodeArg = e.str = e._ = e.nil = e._Code = e.Name = e.IDENTIFIER = e._CodeOrName = void 0;
  class t {
  }
  e._CodeOrName = t, e.IDENTIFIER = /^[a-z$_][a-z$_0-9]*$/i;
  class r extends t {
    constructor(h) {
      if (super(), !e.IDENTIFIER.test(h))
        throw new Error("CodeGen: name must be a valid identifier");
      this.str = h;
    }
    toString() {
      return this.str;
    }
    emptyStr() {
      return !1;
    }
    get names() {
      return { [this.str]: 1 };
    }
  }
  e.Name = r;
  class n extends t {
    constructor(h) {
      super(), this._items = typeof h == "string" ? [h] : h;
    }
    toString() {
      return this.str;
    }
    emptyStr() {
      if (this._items.length > 1)
        return !1;
      const h = this._items[0];
      return h === "" || h === '""';
    }
    get str() {
      var h;
      return (h = this._str) !== null && h !== void 0 ? h : this._str = this._items.reduce((R, k) => `${R}${k}`, "");
    }
    get names() {
      var h;
      return (h = this._names) !== null && h !== void 0 ? h : this._names = this._items.reduce((R, k) => (k instanceof r && (R[k.str] = (R[k.str] || 0) + 1), R), {});
    }
  }
  e._Code = n, e.nil = new n("");
  function a(m, ...h) {
    const R = [m[0]];
    let k = 0;
    for (; k < h.length; )
      d(R, h[k]), R.push(m[++k]);
    return new n(R);
  }
  e._ = a;
  const o = new n("+");
  function c(m, ...h) {
    const R = [T(m[0])];
    let k = 0;
    for (; k < h.length; )
      R.push(o), d(R, h[k]), R.push(o, T(m[++k]));
    return y(R), new n(R);
  }
  e.str = c;
  function d(m, h) {
    h instanceof n ? m.push(...h._items) : h instanceof r ? m.push(h) : m.push(_(h));
  }
  e.addCodeArg = d;
  function y(m) {
    let h = 1;
    for (; h < m.length - 1; ) {
      if (m[h] === o) {
        const R = l(m[h - 1], m[h + 1]);
        if (R !== void 0) {
          m.splice(h - 1, 3, R);
          continue;
        }
        m[h++] = "+";
      }
      h++;
    }
  }
  function l(m, h) {
    if (h === '""')
      return m;
    if (m === '""')
      return h;
    if (typeof m == "string")
      return h instanceof r || m[m.length - 1] !== '"' ? void 0 : typeof h != "string" ? `${m.slice(0, -1)}${h}"` : h[0] === '"' ? m.slice(0, -1) + h.slice(1) : void 0;
    if (typeof h == "string" && h[0] === '"' && !(m instanceof r))
      return `"${m}${h.slice(1)}`;
  }
  function $(m, h) {
    return h.emptyStr() ? m : m.emptyStr() ? h : c`${m}${h}`;
  }
  e.strConcat = $;
  function _(m) {
    return typeof m == "number" || typeof m == "boolean" || m === null ? m : T(Array.isArray(m) ? m.join(",") : m);
  }
  function C(m) {
    return new n(T(m));
  }
  e.stringify = C;
  function T(m) {
    return JSON.stringify(m).replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029");
  }
  e.safeStringify = T;
  function P(m) {
    return typeof m == "string" && e.IDENTIFIER.test(m) ? new n(`.${m}`) : a`[${m}]`;
  }
  e.getProperty = P;
  function O(m) {
    if (typeof m == "string" && e.IDENTIFIER.test(m))
      return new n(`${m}`);
    throw new Error(`CodeGen: invalid export name: ${m}, use explicit $id name mapping`);
  }
  e.getEsmExportName = O;
  function g(m) {
    return new n(m.toString());
  }
  e.regexpCode = g;
})(Et);
var Nr = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.ValueScope = e.ValueScopeName = e.Scope = e.varKinds = e.UsedValueState = void 0;
  const t = Et;
  class r extends Error {
    constructor(l) {
      super(`CodeGen: "code" for ${l} not defined`), this.value = l.value;
    }
  }
  var n;
  (function(y) {
    y[y.Started = 0] = "Started", y[y.Completed = 1] = "Completed";
  })(n || (e.UsedValueState = n = {})), e.varKinds = {
    const: new t.Name("const"),
    let: new t.Name("let"),
    var: new t.Name("var")
  };
  class a {
    constructor({ prefixes: l, parent: $ } = {}) {
      this._names = {}, this._prefixes = l, this._parent = $;
    }
    toName(l) {
      return l instanceof t.Name ? l : this.name(l);
    }
    name(l) {
      return new t.Name(this._newName(l));
    }
    _newName(l) {
      const $ = this._names[l] || this._nameGroup(l);
      return `${l}${$.index++}`;
    }
    _nameGroup(l) {
      var $, _;
      if (!((_ = ($ = this._parent) === null || $ === void 0 ? void 0 : $._prefixes) === null || _ === void 0) && _.has(l) || this._prefixes && !this._prefixes.has(l))
        throw new Error(`CodeGen: prefix "${l}" is not allowed in this scope`);
      return this._names[l] = { prefix: l, index: 0 };
    }
  }
  e.Scope = a;
  class o extends t.Name {
    constructor(l, $) {
      super($), this.prefix = l;
    }
    setValue(l, { property: $, itemIndex: _ }) {
      this.value = l, this.scopePath = (0, t._)`.${new t.Name($)}[${_}]`;
    }
  }
  e.ValueScopeName = o;
  const c = (0, t._)`\n`;
  class d extends a {
    constructor(l) {
      super(l), this._values = {}, this._scope = l.scope, this.opts = { ...l, _n: l.lines ? c : t.nil };
    }
    get() {
      return this._scope;
    }
    name(l) {
      return new o(l, this._newName(l));
    }
    value(l, $) {
      var _;
      if ($.ref === void 0)
        throw new Error("CodeGen: ref must be passed in value");
      const C = this.toName(l), { prefix: T } = C, P = (_ = $.key) !== null && _ !== void 0 ? _ : $.ref;
      let O = this._values[T];
      if (O) {
        const h = O.get(P);
        if (h)
          return h;
      } else
        O = this._values[T] = /* @__PURE__ */ new Map();
      O.set(P, C);
      const g = this._scope[T] || (this._scope[T] = []), m = g.length;
      return g[m] = $.ref, C.setValue($, { property: T, itemIndex: m }), C;
    }
    getValue(l, $) {
      const _ = this._values[l];
      if (_)
        return _.get($);
    }
    scopeRefs(l, $ = this._values) {
      return this._reduceValues($, (_) => {
        if (_.scopePath === void 0)
          throw new Error(`CodeGen: name "${_}" has no value`);
        return (0, t._)`${l}${_.scopePath}`;
      });
    }
    scopeCode(l = this._values, $, _) {
      return this._reduceValues(l, (C) => {
        if (C.value === void 0)
          throw new Error(`CodeGen: name "${C}" has no value`);
        return C.value.code;
      }, $, _);
    }
    _reduceValues(l, $, _ = {}, C) {
      let T = t.nil;
      for (const P in l) {
        const O = l[P];
        if (!O)
          continue;
        const g = _[P] = _[P] || /* @__PURE__ */ new Map();
        O.forEach((m) => {
          if (g.has(m))
            return;
          g.set(m, n.Started);
          let h = $(m);
          if (h) {
            const R = this.opts.es5 ? e.varKinds.var : e.varKinds.const;
            T = (0, t._)`${T}${R} ${m} = ${h};${this.opts._n}`;
          } else if (h = C == null ? void 0 : C(m))
            T = (0, t._)`${T}${h}${this.opts._n}`;
          else
            throw new r(m);
          g.set(m, n.Completed);
        });
      }
      return T;
    }
  }
  e.ValueScope = d;
})(Nr);
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.or = e.and = e.not = e.CodeGen = e.operators = e.varKinds = e.ValueScopeName = e.ValueScope = e.Scope = e.Name = e.regexpCode = e.stringify = e.getProperty = e.nil = e.strConcat = e.str = e._ = void 0;
  const t = Et, r = Nr;
  var n = Et;
  Object.defineProperty(e, "_", { enumerable: !0, get: function() {
    return n._;
  } }), Object.defineProperty(e, "str", { enumerable: !0, get: function() {
    return n.str;
  } }), Object.defineProperty(e, "strConcat", { enumerable: !0, get: function() {
    return n.strConcat;
  } }), Object.defineProperty(e, "nil", { enumerable: !0, get: function() {
    return n.nil;
  } }), Object.defineProperty(e, "getProperty", { enumerable: !0, get: function() {
    return n.getProperty;
  } }), Object.defineProperty(e, "stringify", { enumerable: !0, get: function() {
    return n.stringify;
  } }), Object.defineProperty(e, "regexpCode", { enumerable: !0, get: function() {
    return n.regexpCode;
  } }), Object.defineProperty(e, "Name", { enumerable: !0, get: function() {
    return n.Name;
  } });
  var a = Nr;
  Object.defineProperty(e, "Scope", { enumerable: !0, get: function() {
    return a.Scope;
  } }), Object.defineProperty(e, "ValueScope", { enumerable: !0, get: function() {
    return a.ValueScope;
  } }), Object.defineProperty(e, "ValueScopeName", { enumerable: !0, get: function() {
    return a.ValueScopeName;
  } }), Object.defineProperty(e, "varKinds", { enumerable: !0, get: function() {
    return a.varKinds;
  } }), e.operators = {
    GT: new t._Code(">"),
    GTE: new t._Code(">="),
    LT: new t._Code("<"),
    LTE: new t._Code("<="),
    EQ: new t._Code("==="),
    NEQ: new t._Code("!=="),
    NOT: new t._Code("!"),
    OR: new t._Code("||"),
    AND: new t._Code("&&"),
    ADD: new t._Code("+")
  };
  class o {
    optimizeNodes() {
      return this;
    }
    optimizeNames(s, u) {
      return this;
    }
  }
  class c extends o {
    constructor(s, u, b) {
      super(), this.varKind = s, this.name = u, this.rhs = b;
    }
    render({ es5: s, _n: u }) {
      const b = s ? r.varKinds.var : this.varKind, I = this.rhs === void 0 ? "" : ` = ${this.rhs}`;
      return `${b} ${this.name}${I};` + u;
    }
    optimizeNames(s, u) {
      if (s[this.name.str])
        return this.rhs && (this.rhs = le(this.rhs, s, u)), this;
    }
    get names() {
      return this.rhs instanceof t._CodeOrName ? this.rhs.names : {};
    }
  }
  class d extends o {
    constructor(s, u, b) {
      super(), this.lhs = s, this.rhs = u, this.sideEffects = b;
    }
    render({ _n: s }) {
      return `${this.lhs} = ${this.rhs};` + s;
    }
    optimizeNames(s, u) {
      if (!(this.lhs instanceof t.Name && !s[this.lhs.str] && !this.sideEffects))
        return this.rhs = le(this.rhs, s, u), this;
    }
    get names() {
      const s = this.lhs instanceof t.Name ? {} : { ...this.lhs.names };
      return ae(s, this.rhs);
    }
  }
  class y extends d {
    constructor(s, u, b, I) {
      super(s, b, I), this.op = u;
    }
    render({ _n: s }) {
      return `${this.lhs} ${this.op}= ${this.rhs};` + s;
    }
  }
  class l extends o {
    constructor(s) {
      super(), this.label = s, this.names = {};
    }
    render({ _n: s }) {
      return `${this.label}:` + s;
    }
  }
  class $ extends o {
    constructor(s) {
      super(), this.label = s, this.names = {};
    }
    render({ _n: s }) {
      return `break${this.label ? ` ${this.label}` : ""};` + s;
    }
  }
  class _ extends o {
    constructor(s) {
      super(), this.error = s;
    }
    render({ _n: s }) {
      return `throw ${this.error};` + s;
    }
    get names() {
      return this.error.names;
    }
  }
  class C extends o {
    constructor(s) {
      super(), this.code = s;
    }
    render({ _n: s }) {
      return `${this.code};` + s;
    }
    optimizeNodes() {
      return `${this.code}` ? this : void 0;
    }
    optimizeNames(s, u) {
      return this.code = le(this.code, s, u), this;
    }
    get names() {
      return this.code instanceof t._CodeOrName ? this.code.names : {};
    }
  }
  class T extends o {
    constructor(s = []) {
      super(), this.nodes = s;
    }
    render(s) {
      return this.nodes.reduce((u, b) => u + b.render(s), "");
    }
    optimizeNodes() {
      const { nodes: s } = this;
      let u = s.length;
      for (; u--; ) {
        const b = s[u].optimizeNodes();
        Array.isArray(b) ? s.splice(u, 1, ...b) : b ? s[u] = b : s.splice(u, 1);
      }
      return s.length > 0 ? this : void 0;
    }
    optimizeNames(s, u) {
      const { nodes: b } = this;
      let I = b.length;
      for (; I--; ) {
        const j = b[I];
        j.optimizeNames(s, u) || (we(s, j.names), b.splice(I, 1));
      }
      return b.length > 0 ? this : void 0;
    }
    get names() {
      return this.nodes.reduce((s, u) => H(s, u.names), {});
    }
  }
  class P extends T {
    render(s) {
      return "{" + s._n + super.render(s) + "}" + s._n;
    }
  }
  class O extends T {
  }
  class g extends P {
  }
  g.kind = "else";
  class m extends P {
    constructor(s, u) {
      super(u), this.condition = s;
    }
    render(s) {
      let u = `if(${this.condition})` + super.render(s);
      return this.else && (u += "else " + this.else.render(s)), u;
    }
    optimizeNodes() {
      super.optimizeNodes();
      const s = this.condition;
      if (s === !0)
        return this.nodes;
      let u = this.else;
      if (u) {
        const b = u.optimizeNodes();
        u = this.else = Array.isArray(b) ? new g(b) : b;
      }
      if (u)
        return s === !1 ? u instanceof m ? u : u.nodes : this.nodes.length ? this : new m(De(s), u instanceof m ? [u] : u.nodes);
      if (!(s === !1 || !this.nodes.length))
        return this;
    }
    optimizeNames(s, u) {
      var b;
      if (this.else = (b = this.else) === null || b === void 0 ? void 0 : b.optimizeNames(s, u), !!(super.optimizeNames(s, u) || this.else))
        return this.condition = le(this.condition, s, u), this;
    }
    get names() {
      const s = super.names;
      return ae(s, this.condition), this.else && H(s, this.else.names), s;
    }
  }
  m.kind = "if";
  class h extends P {
  }
  h.kind = "for";
  class R extends h {
    constructor(s) {
      super(), this.iteration = s;
    }
    render(s) {
      return `for(${this.iteration})` + super.render(s);
    }
    optimizeNames(s, u) {
      if (super.optimizeNames(s, u))
        return this.iteration = le(this.iteration, s, u), this;
    }
    get names() {
      return H(super.names, this.iteration.names);
    }
  }
  class k extends h {
    constructor(s, u, b, I) {
      super(), this.varKind = s, this.name = u, this.from = b, this.to = I;
    }
    render(s) {
      const u = s.es5 ? r.varKinds.var : this.varKind, { name: b, from: I, to: j } = this;
      return `for(${u} ${b}=${I}; ${b}<${j}; ${b}++)` + super.render(s);
    }
    get names() {
      const s = ae(super.names, this.from);
      return ae(s, this.to);
    }
  }
  class A extends h {
    constructor(s, u, b, I) {
      super(), this.loop = s, this.varKind = u, this.name = b, this.iterable = I;
    }
    render(s) {
      return `for(${this.varKind} ${this.name} ${this.loop} ${this.iterable})` + super.render(s);
    }
    optimizeNames(s, u) {
      if (super.optimizeNames(s, u))
        return this.iterable = le(this.iterable, s, u), this;
    }
    get names() {
      return H(super.names, this.iterable.names);
    }
  }
  class B extends P {
    constructor(s, u, b) {
      super(), this.name = s, this.args = u, this.async = b;
    }
    render(s) {
      return `${this.async ? "async " : ""}function ${this.name}(${this.args})` + super.render(s);
    }
  }
  B.kind = "func";
  class te extends T {
    render(s) {
      return "return " + super.render(s);
    }
  }
  te.kind = "return";
  class K extends P {
    render(s) {
      let u = "try" + super.render(s);
      return this.catch && (u += this.catch.render(s)), this.finally && (u += this.finally.render(s)), u;
    }
    optimizeNodes() {
      var s, u;
      return super.optimizeNodes(), (s = this.catch) === null || s === void 0 || s.optimizeNodes(), (u = this.finally) === null || u === void 0 || u.optimizeNodes(), this;
    }
    optimizeNames(s, u) {
      var b, I;
      return super.optimizeNames(s, u), (b = this.catch) === null || b === void 0 || b.optimizeNames(s, u), (I = this.finally) === null || I === void 0 || I.optimizeNames(s, u), this;
    }
    get names() {
      const s = super.names;
      return this.catch && H(s, this.catch.names), this.finally && H(s, this.finally.names), s;
    }
  }
  class M extends P {
    constructor(s) {
      super(), this.error = s;
    }
    render(s) {
      return `catch(${this.error})` + super.render(s);
    }
  }
  M.kind = "catch";
  class z extends P {
    render(s) {
      return "finally" + super.render(s);
    }
  }
  z.kind = "finally";
  class Q {
    constructor(s, u = {}) {
      this._values = {}, this._blockStarts = [], this._constants = {}, this.opts = { ...u, _n: u.lines ? `
` : "" }, this._extScope = s, this._scope = new r.Scope({ parent: s }), this._nodes = [new O()];
    }
    toString() {
      return this._root.render(this.opts);
    }
    // returns unique name in the internal scope
    name(s) {
      return this._scope.name(s);
    }
    // reserves unique name in the external scope
    scopeName(s) {
      return this._extScope.name(s);
    }
    // reserves unique name in the external scope and assigns value to it
    scopeValue(s, u) {
      const b = this._extScope.value(s, u);
      return (this._values[b.prefix] || (this._values[b.prefix] = /* @__PURE__ */ new Set())).add(b), b;
    }
    getScopeValue(s, u) {
      return this._extScope.getValue(s, u);
    }
    // return code that assigns values in the external scope to the names that are used internally
    // (same names that were returned by gen.scopeName or gen.scopeValue)
    scopeRefs(s) {
      return this._extScope.scopeRefs(s, this._values);
    }
    scopeCode() {
      return this._extScope.scopeCode(this._values);
    }
    _def(s, u, b, I) {
      const j = this._scope.toName(u);
      return b !== void 0 && I && (this._constants[j.str] = b), this._leafNode(new c(s, j, b)), j;
    }
    // `const` declaration (`var` in es5 mode)
    const(s, u, b) {
      return this._def(r.varKinds.const, s, u, b);
    }
    // `let` declaration with optional assignment (`var` in es5 mode)
    let(s, u, b) {
      return this._def(r.varKinds.let, s, u, b);
    }
    // `var` declaration with optional assignment
    var(s, u, b) {
      return this._def(r.varKinds.var, s, u, b);
    }
    // assignment code
    assign(s, u, b) {
      return this._leafNode(new d(s, u, b));
    }
    // `+=` code
    add(s, u) {
      return this._leafNode(new y(s, e.operators.ADD, u));
    }
    // appends passed SafeExpr to code or executes Block
    code(s) {
      return typeof s == "function" ? s() : s !== t.nil && this._leafNode(new C(s)), this;
    }
    // returns code for object literal for the passed argument list of key-value pairs
    object(...s) {
      const u = ["{"];
      for (const [b, I] of s)
        u.length > 1 && u.push(","), u.push(b), (b !== I || this.opts.es5) && (u.push(":"), (0, t.addCodeArg)(u, I));
      return u.push("}"), new t._Code(u);
    }
    // `if` clause (or statement if `thenBody` and, optionally, `elseBody` are passed)
    if(s, u, b) {
      if (this._blockNode(new m(s)), u && b)
        this.code(u).else().code(b).endIf();
      else if (u)
        this.code(u).endIf();
      else if (b)
        throw new Error('CodeGen: "else" body without "then" body');
      return this;
    }
    // `else if` clause - invalid without `if` or after `else` clauses
    elseIf(s) {
      return this._elseNode(new m(s));
    }
    // `else` clause - only valid after `if` or `else if` clauses
    else() {
      return this._elseNode(new g());
    }
    // end `if` statement (needed if gen.if was used only with condition)
    endIf() {
      return this._endBlockNode(m, g);
    }
    _for(s, u) {
      return this._blockNode(s), u && this.code(u).endFor(), this;
    }
    // a generic `for` clause (or statement if `forBody` is passed)
    for(s, u) {
      return this._for(new R(s), u);
    }
    // `for` statement for a range of values
    forRange(s, u, b, I, j = this.opts.es5 ? r.varKinds.var : r.varKinds.let) {
      const F = this._scope.toName(s);
      return this._for(new k(j, F, u, b), () => I(F));
    }
    // `for-of` statement (in es5 mode replace with a normal for loop)
    forOf(s, u, b, I = r.varKinds.const) {
      const j = this._scope.toName(s);
      if (this.opts.es5) {
        const F = u instanceof t.Name ? u : this.var("_arr", u);
        return this.forRange("_i", 0, (0, t._)`${F}.length`, (G) => {
          this.var(j, (0, t._)`${F}[${G}]`), b(j);
        });
      }
      return this._for(new A("of", I, j, u), () => b(j));
    }
    // `for-in` statement.
    // With option `ownProperties` replaced with a `for-of` loop for object keys
    forIn(s, u, b, I = this.opts.es5 ? r.varKinds.var : r.varKinds.const) {
      if (this.opts.ownProperties)
        return this.forOf(s, (0, t._)`Object.keys(${u})`, b);
      const j = this._scope.toName(s);
      return this._for(new A("in", I, j, u), () => b(j));
    }
    // end `for` loop
    endFor() {
      return this._endBlockNode(h);
    }
    // `label` statement
    label(s) {
      return this._leafNode(new l(s));
    }
    // `break` statement
    break(s) {
      return this._leafNode(new $(s));
    }
    // `return` statement
    return(s) {
      const u = new te();
      if (this._blockNode(u), this.code(s), u.nodes.length !== 1)
        throw new Error('CodeGen: "return" should have one node');
      return this._endBlockNode(te);
    }
    // `try` statement
    try(s, u, b) {
      if (!u && !b)
        throw new Error('CodeGen: "try" without "catch" and "finally"');
      const I = new K();
      if (this._blockNode(I), this.code(s), u) {
        const j = this.name("e");
        this._currNode = I.catch = new M(j), u(j);
      }
      return b && (this._currNode = I.finally = new z(), this.code(b)), this._endBlockNode(M, z);
    }
    // `throw` statement
    throw(s) {
      return this._leafNode(new _(s));
    }
    // start self-balancing block
    block(s, u) {
      return this._blockStarts.push(this._nodes.length), s && this.code(s).endBlock(u), this;
    }
    // end the current self-balancing block
    endBlock(s) {
      const u = this._blockStarts.pop();
      if (u === void 0)
        throw new Error("CodeGen: not in self-balancing block");
      const b = this._nodes.length - u;
      if (b < 0 || s !== void 0 && b !== s)
        throw new Error(`CodeGen: wrong number of nodes: ${b} vs ${s} expected`);
      return this._nodes.length = u, this;
    }
    // `function` heading (or definition if funcBody is passed)
    func(s, u = t.nil, b, I) {
      return this._blockNode(new B(s, u, b)), I && this.code(I).endFunc(), this;
    }
    // end function definition
    endFunc() {
      return this._endBlockNode(B);
    }
    optimize(s = 1) {
      for (; s-- > 0; )
        this._root.optimizeNodes(), this._root.optimizeNames(this._root.names, this._constants);
    }
    _leafNode(s) {
      return this._currNode.nodes.push(s), this;
    }
    _blockNode(s) {
      this._currNode.nodes.push(s), this._nodes.push(s);
    }
    _endBlockNode(s, u) {
      const b = this._currNode;
      if (b instanceof s || u && b instanceof u)
        return this._nodes.pop(), this;
      throw new Error(`CodeGen: not in block "${u ? `${s.kind}/${u.kind}` : s.kind}"`);
    }
    _elseNode(s) {
      const u = this._currNode;
      if (!(u instanceof m))
        throw new Error('CodeGen: "else" without "if"');
      return this._currNode = u.else = s, this;
    }
    get _root() {
      return this._nodes[0];
    }
    get _currNode() {
      const s = this._nodes;
      return s[s.length - 1];
    }
    set _currNode(s) {
      const u = this._nodes;
      u[u.length - 1] = s;
    }
  }
  e.CodeGen = Q;
  function H(v, s) {
    for (const u in s)
      v[u] = (v[u] || 0) + (s[u] || 0);
    return v;
  }
  function ae(v, s) {
    return s instanceof t._CodeOrName ? H(v, s.names) : v;
  }
  function le(v, s, u) {
    if (v instanceof t.Name)
      return b(v);
    if (!I(v))
      return v;
    return new t._Code(v._items.reduce((j, F) => (F instanceof t.Name && (F = b(F)), F instanceof t._Code ? j.push(...F._items) : j.push(F), j), []));
    function b(j) {
      const F = u[j.str];
      return F === void 0 || s[j.str] !== 1 ? j : (delete s[j.str], F);
    }
    function I(j) {
      return j instanceof t._Code && j._items.some((F) => F instanceof t.Name && s[F.str] === 1 && u[F.str] !== void 0);
    }
  }
  function we(v, s) {
    for (const u in s)
      v[u] = (v[u] || 0) - (s[u] || 0);
  }
  function De(v) {
    return typeof v == "boolean" || typeof v == "number" || v === null ? !v : (0, t._)`!${E(v)}`;
  }
  e.not = De;
  const We = w(e.operators.AND);
  function xe(...v) {
    return v.reduce(We);
  }
  e.and = xe;
  const Ae = w(e.operators.OR);
  function D(...v) {
    return v.reduce(Ae);
  }
  e.or = D;
  function w(v) {
    return (s, u) => s === t.nil ? u : u === t.nil ? s : (0, t._)`${E(s)} ${v} ${E(u)}`;
  }
  function E(v) {
    return v instanceof t.Name ? v : (0, t._)`(${v})`;
  }
})(X);
var V = {};
Object.defineProperty(V, "__esModule", { value: !0 });
V.checkStrictMode = V.getErrorPath = V.Type = V.useFunc = V.setEvaluated = V.evaluatedPropsToName = V.mergeEvaluated = V.eachItem = V.unescapeJsonPointer = V.escapeJsonPointer = V.escapeFragment = V.unescapeFragment = V.schemaRefOrVal = V.schemaHasRulesButRef = V.schemaHasRules = V.checkUnknownRules = V.alwaysValidSchema = V.toHash = void 0;
const ne = X, vs = Et;
function _s(e) {
  const t = {};
  for (const r of e)
    t[r] = !0;
  return t;
}
V.toHash = _s;
function gs(e, t) {
  return typeof t == "boolean" ? t : Object.keys(t).length === 0 ? !0 : (fa(e, t), !ha(t, e.self.RULES.all));
}
V.alwaysValidSchema = gs;
function fa(e, t = e.schema) {
  const { opts: r, self: n } = e;
  if (!r.strictSchema || typeof t == "boolean")
    return;
  const a = n.RULES.keywords;
  for (const o in t)
    a[o] || $a(e, `unknown keyword: "${o}"`);
}
V.checkUnknownRules = fa;
function ha(e, t) {
  if (typeof e == "boolean")
    return !e;
  for (const r in e)
    if (t[r])
      return !0;
  return !1;
}
V.schemaHasRules = ha;
function ws(e, t) {
  if (typeof e == "boolean")
    return !e;
  for (const r in e)
    if (r !== "$ref" && t.all[r])
      return !0;
  return !1;
}
V.schemaHasRulesButRef = ws;
function Es({ topSchemaRef: e, schemaPath: t }, r, n, a) {
  if (!a) {
    if (typeof r == "number" || typeof r == "boolean")
      return r;
    if (typeof r == "string")
      return (0, ne._)`${r}`;
  }
  return (0, ne._)`${e}${t}${(0, ne.getProperty)(n)}`;
}
V.schemaRefOrVal = Es;
function bs(e) {
  return ma(decodeURIComponent(e));
}
V.unescapeFragment = bs;
function Ss(e) {
  return encodeURIComponent(Fr(e));
}
V.escapeFragment = Ss;
function Fr(e) {
  return typeof e == "number" ? `${e}` : e.replace(/~/g, "~0").replace(/\//g, "~1");
}
V.escapeJsonPointer = Fr;
function ma(e) {
  return e.replace(/~1/g, "/").replace(/~0/g, "~");
}
V.unescapeJsonPointer = ma;
function Ps(e, t) {
  if (Array.isArray(e))
    for (const r of e)
      t(r);
  else
    t(e);
}
V.eachItem = Ps;
function Kn({ mergeNames: e, mergeToName: t, mergeValues: r, resultToName: n }) {
  return (a, o, c, d) => {
    const y = c === void 0 ? o : c instanceof ne.Name ? (o instanceof ne.Name ? e(a, o, c) : t(a, o, c), c) : o instanceof ne.Name ? (t(a, c, o), o) : r(o, c);
    return d === ne.Name && !(y instanceof ne.Name) ? n(a, y) : y;
  };
}
V.mergeEvaluated = {
  props: Kn({
    mergeNames: (e, t, r) => e.if((0, ne._)`${r} !== true && ${t} !== undefined`, () => {
      e.if((0, ne._)`${t} === true`, () => e.assign(r, !0), () => e.assign(r, (0, ne._)`${r} || {}`).code((0, ne._)`Object.assign(${r}, ${t})`));
    }),
    mergeToName: (e, t, r) => e.if((0, ne._)`${r} !== true`, () => {
      t === !0 ? e.assign(r, !0) : (e.assign(r, (0, ne._)`${r} || {}`), zr(e, r, t));
    }),
    mergeValues: (e, t) => e === !0 ? !0 : { ...e, ...t },
    resultToName: pa
  }),
  items: Kn({
    mergeNames: (e, t, r) => e.if((0, ne._)`${r} !== true && ${t} !== undefined`, () => e.assign(r, (0, ne._)`${t} === true ? true : ${r} > ${t} ? ${r} : ${t}`)),
    mergeToName: (e, t, r) => e.if((0, ne._)`${r} !== true`, () => e.assign(r, t === !0 ? !0 : (0, ne._)`${r} > ${t} ? ${r} : ${t}`)),
    mergeValues: (e, t) => e === !0 ? !0 : Math.max(e, t),
    resultToName: (e, t) => e.var("items", t)
  })
};
function pa(e, t) {
  if (t === !0)
    return e.var("props", !0);
  const r = e.var("props", (0, ne._)`{}`);
  return t !== void 0 && zr(e, r, t), r;
}
V.evaluatedPropsToName = pa;
function zr(e, t, r) {
  Object.keys(r).forEach((n) => e.assign((0, ne._)`${t}${(0, ne.getProperty)(n)}`, !0));
}
V.setEvaluated = zr;
const Ln = {};
function Os(e, t) {
  return e.scopeValue("func", {
    ref: t,
    code: Ln[t.code] || (Ln[t.code] = new vs._Code(t.code))
  });
}
V.useFunc = Os;
var Tr;
(function(e) {
  e[e.Num = 0] = "Num", e[e.Str = 1] = "Str";
})(Tr || (V.Type = Tr = {}));
function Ns(e, t, r) {
  if (e instanceof ne.Name) {
    const n = t === Tr.Num;
    return r ? n ? (0, ne._)`"[" + ${e} + "]"` : (0, ne._)`"['" + ${e} + "']"` : n ? (0, ne._)`"/" + ${e}` : (0, ne._)`"/" + ${e}.replace(/~/g, "~0").replace(/\\//g, "~1")`;
  }
  return r ? (0, ne.getProperty)(e).toString() : "/" + Fr(e);
}
V.getErrorPath = Ns;
function $a(e, t, r = e.opts.strictSchema) {
  if (r) {
    if (t = `strict mode: ${t}`, r === !0)
      throw new Error(t);
    e.self.logger.warn(t);
  }
}
V.checkStrictMode = $a;
var ke = {};
Object.defineProperty(ke, "__esModule", { value: !0 });
const _e = X, Ts = {
  // validation function arguments
  data: new _e.Name("data"),
  // data passed to validation function
  // args passed from referencing schema
  valCxt: new _e.Name("valCxt"),
  // validation/data context - should not be used directly, it is destructured to the names below
  instancePath: new _e.Name("instancePath"),
  parentData: new _e.Name("parentData"),
  parentDataProperty: new _e.Name("parentDataProperty"),
  rootData: new _e.Name("rootData"),
  // root data - same as the data passed to the first/top validation function
  dynamicAnchors: new _e.Name("dynamicAnchors"),
  // used to support recursiveRef and dynamicRef
  // function scoped variables
  vErrors: new _e.Name("vErrors"),
  // null or array of validation errors
  errors: new _e.Name("errors"),
  // counter of validation errors
  this: new _e.Name("this"),
  // "globals"
  self: new _e.Name("self"),
  scope: new _e.Name("scope"),
  // JTD serialize/parse name for JSON string and position
  json: new _e.Name("json"),
  jsonPos: new _e.Name("jsonPos"),
  jsonLen: new _e.Name("jsonLen"),
  jsonPart: new _e.Name("jsonPart")
};
ke.default = Ts;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.extendErrors = e.resetErrorsCount = e.reportExtraError = e.reportError = e.keyword$DataError = e.keywordError = void 0;
  const t = X, r = V, n = ke;
  e.keywordError = {
    message: ({ keyword: g }) => (0, t.str)`must pass "${g}" keyword validation`
  }, e.keyword$DataError = {
    message: ({ keyword: g, schemaType: m }) => m ? (0, t.str)`"${g}" keyword must be ${m} ($data)` : (0, t.str)`"${g}" keyword is invalid ($data)`
  };
  function a(g, m = e.keywordError, h, R) {
    const { it: k } = g, { gen: A, compositeRule: B, allErrors: te } = k, K = _(g, m, h);
    R ?? (B || te) ? y(A, K) : l(k, (0, t._)`[${K}]`);
  }
  e.reportError = a;
  function o(g, m = e.keywordError, h) {
    const { it: R } = g, { gen: k, compositeRule: A, allErrors: B } = R, te = _(g, m, h);
    y(k, te), A || B || l(R, n.default.vErrors);
  }
  e.reportExtraError = o;
  function c(g, m) {
    g.assign(n.default.errors, m), g.if((0, t._)`${n.default.vErrors} !== null`, () => g.if(m, () => g.assign((0, t._)`${n.default.vErrors}.length`, m), () => g.assign(n.default.vErrors, null)));
  }
  e.resetErrorsCount = c;
  function d({ gen: g, keyword: m, schemaValue: h, data: R, errsCount: k, it: A }) {
    if (k === void 0)
      throw new Error("ajv implementation error");
    const B = g.name("err");
    g.forRange("i", k, n.default.errors, (te) => {
      g.const(B, (0, t._)`${n.default.vErrors}[${te}]`), g.if((0, t._)`${B}.instancePath === undefined`, () => g.assign((0, t._)`${B}.instancePath`, (0, t.strConcat)(n.default.instancePath, A.errorPath))), g.assign((0, t._)`${B}.schemaPath`, (0, t.str)`${A.errSchemaPath}/${m}`), A.opts.verbose && (g.assign((0, t._)`${B}.schema`, h), g.assign((0, t._)`${B}.data`, R));
    });
  }
  e.extendErrors = d;
  function y(g, m) {
    const h = g.const("err", m);
    g.if((0, t._)`${n.default.vErrors} === null`, () => g.assign(n.default.vErrors, (0, t._)`[${h}]`), (0, t._)`${n.default.vErrors}.push(${h})`), g.code((0, t._)`${n.default.errors}++`);
  }
  function l(g, m) {
    const { gen: h, validateName: R, schemaEnv: k } = g;
    k.$async ? h.throw((0, t._)`new ${g.ValidationError}(${m})`) : (h.assign((0, t._)`${R}.errors`, m), h.return(!1));
  }
  const $ = {
    keyword: new t.Name("keyword"),
    schemaPath: new t.Name("schemaPath"),
    // also used in JTD errors
    params: new t.Name("params"),
    propertyName: new t.Name("propertyName"),
    message: new t.Name("message"),
    schema: new t.Name("schema"),
    parentSchema: new t.Name("parentSchema")
  };
  function _(g, m, h) {
    const { createErrors: R } = g.it;
    return R === !1 ? (0, t._)`{}` : C(g, m, h);
  }
  function C(g, m, h = {}) {
    const { gen: R, it: k } = g, A = [
      T(k, h),
      P(g, h)
    ];
    return O(g, m, A), R.object(...A);
  }
  function T({ errorPath: g }, { instancePath: m }) {
    const h = m ? (0, t.str)`${g}${(0, r.getErrorPath)(m, r.Type.Str)}` : g;
    return [n.default.instancePath, (0, t.strConcat)(n.default.instancePath, h)];
  }
  function P({ keyword: g, it: { errSchemaPath: m } }, { schemaPath: h, parentSchema: R }) {
    let k = R ? m : (0, t.str)`${m}/${g}`;
    return h && (k = (0, t.str)`${k}${(0, r.getErrorPath)(h, r.Type.Str)}`), [$.schemaPath, k];
  }
  function O(g, { params: m, message: h }, R) {
    const { keyword: k, data: A, schemaValue: B, it: te } = g, { opts: K, propertyName: M, topSchemaRef: z, schemaPath: Q } = te;
    R.push([$.keyword, k], [$.params, typeof m == "function" ? m(g) : m || (0, t._)`{}`]), K.messages && R.push([$.message, typeof h == "function" ? h(g) : h]), K.verbose && R.push([$.schema, B], [$.parentSchema, (0, t._)`${z}${Q}`], [n.default.data, A]), M && R.push([$.propertyName, M]);
  }
})(St);
Object.defineProperty(wt, "__esModule", { value: !0 });
wt.boolOrEmptySchema = wt.topBoolOrEmptySchema = void 0;
const Cs = St, Rs = X, js = ke, Is = {
  message: "boolean schema is false"
};
function ks(e) {
  const { gen: t, schema: r, validateName: n } = e;
  r === !1 ? ya(e, !1) : typeof r == "object" && r.$async === !0 ? t.return(js.default.data) : (t.assign((0, Rs._)`${n}.errors`, null), t.return(!0));
}
wt.topBoolOrEmptySchema = ks;
function Ds(e, t) {
  const { gen: r, schema: n } = e;
  n === !1 ? (r.var(t, !1), ya(e)) : r.var(t, !0);
}
wt.boolOrEmptySchema = Ds;
function ya(e, t) {
  const { gen: r, data: n } = e, a = {
    gen: r,
    keyword: "false schema",
    data: n,
    schema: !1,
    schemaCode: !1,
    schemaValue: !1,
    params: {},
    it: e
  };
  (0, Cs.reportError)(a, Is, void 0, t);
}
var $e = {}, ct = {};
Object.defineProperty(ct, "__esModule", { value: !0 });
ct.getRules = ct.isJSONType = void 0;
const As = ["string", "number", "integer", "boolean", "null", "object", "array"], Ms = new Set(As);
function Vs(e) {
  return typeof e == "string" && Ms.has(e);
}
ct.isJSONType = Vs;
function Fs() {
  const e = {
    number: { type: "number", rules: [] },
    string: { type: "string", rules: [] },
    array: { type: "array", rules: [] },
    object: { type: "object", rules: [] }
  };
  return {
    types: { ...e, integer: !0, boolean: !0, null: !0 },
    rules: [{ rules: [] }, e.number, e.string, e.array, e.object],
    post: { rules: [] },
    all: {},
    keywords: {}
  };
}
ct.getRules = Fs;
var Ge = {};
Object.defineProperty(Ge, "__esModule", { value: !0 });
Ge.shouldUseRule = Ge.shouldUseGroup = Ge.schemaHasRulesForType = void 0;
function zs({ schema: e, self: t }, r) {
  const n = t.RULES.types[r];
  return n && n !== !0 && va(e, n);
}
Ge.schemaHasRulesForType = zs;
function va(e, t) {
  return t.rules.some((r) => _a(e, r));
}
Ge.shouldUseGroup = va;
function _a(e, t) {
  var r;
  return e[t.keyword] !== void 0 || ((r = t.definition.implements) === null || r === void 0 ? void 0 : r.some((n) => e[n] !== void 0));
}
Ge.shouldUseRule = _a;
Object.defineProperty($e, "__esModule", { value: !0 });
$e.reportTypeError = $e.checkDataTypes = $e.checkDataType = $e.coerceAndCheckDataType = $e.getJSONTypes = $e.getSchemaTypes = $e.DataType = void 0;
const Us = ct, qs = Ge, Ks = St, Y = X, ga = V;
var _t;
(function(e) {
  e[e.Correct = 0] = "Correct", e[e.Wrong = 1] = "Wrong";
})(_t || ($e.DataType = _t = {}));
function Ls(e) {
  const t = wa(e.type);
  if (t.includes("null")) {
    if (e.nullable === !1)
      throw new Error("type: null contradicts nullable: false");
  } else {
    if (!t.length && e.nullable !== void 0)
      throw new Error('"nullable" cannot be used without "type"');
    e.nullable === !0 && t.push("null");
  }
  return t;
}
$e.getSchemaTypes = Ls;
function wa(e) {
  const t = Array.isArray(e) ? e : e ? [e] : [];
  if (t.every(Us.isJSONType))
    return t;
  throw new Error("type must be JSONType or JSONType[]: " + t.join(","));
}
$e.getJSONTypes = wa;
function Hs(e, t) {
  const { gen: r, data: n, opts: a } = e, o = Gs(t, a.coerceTypes), c = t.length > 0 && !(o.length === 0 && t.length === 1 && (0, qs.schemaHasRulesForType)(e, t[0]));
  if (c) {
    const d = Ur(t, n, a.strictNumbers, _t.Wrong);
    r.if(d, () => {
      o.length ? Js(e, t, o) : qr(e);
    });
  }
  return c;
}
$e.coerceAndCheckDataType = Hs;
const Ea = /* @__PURE__ */ new Set(["string", "number", "integer", "boolean", "null"]);
function Gs(e, t) {
  return t ? e.filter((r) => Ea.has(r) || t === "array" && r === "array") : [];
}
function Js(e, t, r) {
  const { gen: n, data: a, opts: o } = e, c = n.let("dataType", (0, Y._)`typeof ${a}`), d = n.let("coerced", (0, Y._)`undefined`);
  o.coerceTypes === "array" && n.if((0, Y._)`${c} == 'object' && Array.isArray(${a}) && ${a}.length == 1`, () => n.assign(a, (0, Y._)`${a}[0]`).assign(c, (0, Y._)`typeof ${a}`).if(Ur(t, a, o.strictNumbers), () => n.assign(d, a))), n.if((0, Y._)`${d} !== undefined`);
  for (const l of r)
    (Ea.has(l) || l === "array" && o.coerceTypes === "array") && y(l);
  n.else(), qr(e), n.endIf(), n.if((0, Y._)`${d} !== undefined`, () => {
    n.assign(a, d), Ws(e, d);
  });
  function y(l) {
    switch (l) {
      case "string":
        n.elseIf((0, Y._)`${c} == "number" || ${c} == "boolean"`).assign(d, (0, Y._)`"" + ${a}`).elseIf((0, Y._)`${a} === null`).assign(d, (0, Y._)`""`);
        return;
      case "number":
        n.elseIf((0, Y._)`${c} == "boolean" || ${a} === null
              || (${c} == "string" && ${a} && ${a} == +${a})`).assign(d, (0, Y._)`+${a}`);
        return;
      case "integer":
        n.elseIf((0, Y._)`${c} === "boolean" || ${a} === null
              || (${c} === "string" && ${a} && ${a} == +${a} && !(${a} % 1))`).assign(d, (0, Y._)`+${a}`);
        return;
      case "boolean":
        n.elseIf((0, Y._)`${a} === "false" || ${a} === 0 || ${a} === null`).assign(d, !1).elseIf((0, Y._)`${a} === "true" || ${a} === 1`).assign(d, !0);
        return;
      case "null":
        n.elseIf((0, Y._)`${a} === "" || ${a} === 0 || ${a} === false`), n.assign(d, null);
        return;
      case "array":
        n.elseIf((0, Y._)`${c} === "string" || ${c} === "number"
              || ${c} === "boolean" || ${a} === null`).assign(d, (0, Y._)`[${a}]`);
    }
  }
}
function Ws({ gen: e, parentData: t, parentDataProperty: r }, n) {
  e.if((0, Y._)`${t} !== undefined`, () => e.assign((0, Y._)`${t}[${r}]`, n));
}
function Cr(e, t, r, n = _t.Correct) {
  const a = n === _t.Correct ? Y.operators.EQ : Y.operators.NEQ;
  let o;
  switch (e) {
    case "null":
      return (0, Y._)`${t} ${a} null`;
    case "array":
      o = (0, Y._)`Array.isArray(${t})`;
      break;
    case "object":
      o = (0, Y._)`${t} && typeof ${t} == "object" && !Array.isArray(${t})`;
      break;
    case "integer":
      o = c((0, Y._)`!(${t} % 1) && !isNaN(${t})`);
      break;
    case "number":
      o = c();
      break;
    default:
      return (0, Y._)`typeof ${t} ${a} ${e}`;
  }
  return n === _t.Correct ? o : (0, Y.not)(o);
  function c(d = Y.nil) {
    return (0, Y.and)((0, Y._)`typeof ${t} == "number"`, d, r ? (0, Y._)`isFinite(${t})` : Y.nil);
  }
}
$e.checkDataType = Cr;
function Ur(e, t, r, n) {
  if (e.length === 1)
    return Cr(e[0], t, r, n);
  let a;
  const o = (0, ga.toHash)(e);
  if (o.array && o.object) {
    const c = (0, Y._)`typeof ${t} != "object"`;
    a = o.null ? c : (0, Y._)`!${t} || ${c}`, delete o.null, delete o.array, delete o.object;
  } else
    a = Y.nil;
  o.number && delete o.integer;
  for (const c in o)
    a = (0, Y.and)(a, Cr(c, t, r, n));
  return a;
}
$e.checkDataTypes = Ur;
const Bs = {
  message: ({ schema: e }) => `must be ${e}`,
  params: ({ schema: e, schemaValue: t }) => typeof e == "string" ? (0, Y._)`{type: ${e}}` : (0, Y._)`{type: ${t}}`
};
function qr(e) {
  const t = Ys(e);
  (0, Ks.reportError)(t, Bs);
}
$e.reportTypeError = qr;
function Ys(e) {
  const { gen: t, data: r, schema: n } = e, a = (0, ga.schemaRefOrVal)(e, n, "type");
  return {
    gen: t,
    keyword: "type",
    data: r,
    schema: n.type,
    schemaCode: a,
    schemaValue: a,
    parentSchema: n,
    params: {},
    it: e
  };
}
var mr = {};
Object.defineProperty(mr, "__esModule", { value: !0 });
mr.assignDefaults = void 0;
const $t = X, Xs = V;
function Qs(e, t) {
  const { properties: r, items: n } = e.schema;
  if (t === "object" && r)
    for (const a in r)
      Hn(e, a, r[a].default);
  else
    t === "array" && Array.isArray(n) && n.forEach((a, o) => Hn(e, o, a.default));
}
mr.assignDefaults = Qs;
function Hn(e, t, r) {
  const { gen: n, compositeRule: a, data: o, opts: c } = e;
  if (r === void 0)
    return;
  const d = (0, $t._)`${o}${(0, $t.getProperty)(t)}`;
  if (a) {
    (0, Xs.checkStrictMode)(e, `default is ignored for: ${d}`);
    return;
  }
  let y = (0, $t._)`${d} === undefined`;
  c.useDefaults === "empty" && (y = (0, $t._)`${y} || ${d} === null || ${d} === ""`), n.if(y, (0, $t._)`${d} = ${(0, $t.stringify)(r)}`);
}
var Le = {}, Z = {};
Object.defineProperty(Z, "__esModule", { value: !0 });
Z.validateUnion = Z.validateArray = Z.usePattern = Z.callValidateCode = Z.schemaProperties = Z.allSchemaProperties = Z.noPropertyInData = Z.propertyInData = Z.isOwnProperty = Z.hasPropFunc = Z.reportMissingProp = Z.checkMissingProp = Z.checkReportMissingProp = void 0;
const ie = X, Kr = V, Ye = ke, Zs = V;
function xs(e, t) {
  const { gen: r, data: n, it: a } = e;
  r.if(Hr(r, n, t, a.opts.ownProperties), () => {
    e.setParams({ missingProperty: (0, ie._)`${t}` }, !0), e.error();
  });
}
Z.checkReportMissingProp = xs;
function eo({ gen: e, data: t, it: { opts: r } }, n, a) {
  return (0, ie.or)(...n.map((o) => (0, ie.and)(Hr(e, t, o, r.ownProperties), (0, ie._)`${a} = ${o}`)));
}
Z.checkMissingProp = eo;
function to(e, t) {
  e.setParams({ missingProperty: t }, !0), e.error();
}
Z.reportMissingProp = to;
function ba(e) {
  return e.scopeValue("func", {
    // eslint-disable-next-line @typescript-eslint/unbound-method
    ref: Object.prototype.hasOwnProperty,
    code: (0, ie._)`Object.prototype.hasOwnProperty`
  });
}
Z.hasPropFunc = ba;
function Lr(e, t, r) {
  return (0, ie._)`${ba(e)}.call(${t}, ${r})`;
}
Z.isOwnProperty = Lr;
function ro(e, t, r, n) {
  const a = (0, ie._)`${t}${(0, ie.getProperty)(r)} !== undefined`;
  return n ? (0, ie._)`${a} && ${Lr(e, t, r)}` : a;
}
Z.propertyInData = ro;
function Hr(e, t, r, n) {
  const a = (0, ie._)`${t}${(0, ie.getProperty)(r)} === undefined`;
  return n ? (0, ie.or)(a, (0, ie.not)(Lr(e, t, r))) : a;
}
Z.noPropertyInData = Hr;
function Sa(e) {
  return e ? Object.keys(e).filter((t) => t !== "__proto__") : [];
}
Z.allSchemaProperties = Sa;
function no(e, t) {
  return Sa(t).filter((r) => !(0, Kr.alwaysValidSchema)(e, t[r]));
}
Z.schemaProperties = no;
function ao({ schemaCode: e, data: t, it: { gen: r, topSchemaRef: n, schemaPath: a, errorPath: o }, it: c }, d, y, l) {
  const $ = l ? (0, ie._)`${e}, ${t}, ${n}${a}` : t, _ = [
    [Ye.default.instancePath, (0, ie.strConcat)(Ye.default.instancePath, o)],
    [Ye.default.parentData, c.parentData],
    [Ye.default.parentDataProperty, c.parentDataProperty],
    [Ye.default.rootData, Ye.default.rootData]
  ];
  c.opts.dynamicRef && _.push([Ye.default.dynamicAnchors, Ye.default.dynamicAnchors]);
  const C = (0, ie._)`${$}, ${r.object(..._)}`;
  return y !== ie.nil ? (0, ie._)`${d}.call(${y}, ${C})` : (0, ie._)`${d}(${C})`;
}
Z.callValidateCode = ao;
const so = (0, ie._)`new RegExp`;
function oo({ gen: e, it: { opts: t } }, r) {
  const n = t.unicodeRegExp ? "u" : "", { regExp: a } = t.code, o = a(r, n);
  return e.scopeValue("pattern", {
    key: o.toString(),
    ref: o,
    code: (0, ie._)`${a.code === "new RegExp" ? so : (0, Zs.useFunc)(e, a)}(${r}, ${n})`
  });
}
Z.usePattern = oo;
function io(e) {
  const { gen: t, data: r, keyword: n, it: a } = e, o = t.name("valid");
  if (a.allErrors) {
    const d = t.let("valid", !0);
    return c(() => t.assign(d, !1)), d;
  }
  return t.var(o, !0), c(() => t.break()), o;
  function c(d) {
    const y = t.const("len", (0, ie._)`${r}.length`);
    t.forRange("i", 0, y, (l) => {
      e.subschema({
        keyword: n,
        dataProp: l,
        dataPropType: Kr.Type.Num
      }, o), t.if((0, ie.not)(o), d);
    });
  }
}
Z.validateArray = io;
function co(e) {
  const { gen: t, schema: r, keyword: n, it: a } = e;
  if (!Array.isArray(r))
    throw new Error("ajv implementation error");
  if (r.some((y) => (0, Kr.alwaysValidSchema)(a, y)) && !a.opts.unevaluated)
    return;
  const c = t.let("valid", !1), d = t.name("_valid");
  t.block(() => r.forEach((y, l) => {
    const $ = e.subschema({
      keyword: n,
      schemaProp: l,
      compositeRule: !0
    }, d);
    t.assign(c, (0, ie._)`${c} || ${d}`), e.mergeValidEvaluated($, d) || t.if((0, ie.not)(c));
  })), e.result(c, () => e.reset(), () => e.error(!0));
}
Z.validateUnion = co;
Object.defineProperty(Le, "__esModule", { value: !0 });
Le.validateKeywordUsage = Le.validSchemaType = Le.funcKeywordCode = Le.macroKeywordCode = void 0;
const ge = X, st = ke, uo = Z, lo = St;
function fo(e, t) {
  const { gen: r, keyword: n, schema: a, parentSchema: o, it: c } = e, d = t.macro.call(c.self, a, o, c), y = Pa(r, n, d);
  c.opts.validateSchema !== !1 && c.self.validateSchema(d, !0);
  const l = r.name("valid");
  e.subschema({
    schema: d,
    schemaPath: ge.nil,
    errSchemaPath: `${c.errSchemaPath}/${n}`,
    topSchemaRef: y,
    compositeRule: !0
  }, l), e.pass(l, () => e.error(!0));
}
Le.macroKeywordCode = fo;
function ho(e, t) {
  var r;
  const { gen: n, keyword: a, schema: o, parentSchema: c, $data: d, it: y } = e;
  po(y, t);
  const l = !d && t.compile ? t.compile.call(y.self, o, c, y) : t.validate, $ = Pa(n, a, l), _ = n.let("valid");
  e.block$data(_, C), e.ok((r = t.valid) !== null && r !== void 0 ? r : _);
  function C() {
    if (t.errors === !1)
      O(), t.modifying && Gn(e), g(() => e.error());
    else {
      const m = t.async ? T() : P();
      t.modifying && Gn(e), g(() => mo(e, m));
    }
  }
  function T() {
    const m = n.let("ruleErrs", null);
    return n.try(() => O((0, ge._)`await `), (h) => n.assign(_, !1).if((0, ge._)`${h} instanceof ${y.ValidationError}`, () => n.assign(m, (0, ge._)`${h}.errors`), () => n.throw(h))), m;
  }
  function P() {
    const m = (0, ge._)`${$}.errors`;
    return n.assign(m, null), O(ge.nil), m;
  }
  function O(m = t.async ? (0, ge._)`await ` : ge.nil) {
    const h = y.opts.passContext ? st.default.this : st.default.self, R = !("compile" in t && !d || t.schema === !1);
    n.assign(_, (0, ge._)`${m}${(0, uo.callValidateCode)(e, $, h, R)}`, t.modifying);
  }
  function g(m) {
    var h;
    n.if((0, ge.not)((h = t.valid) !== null && h !== void 0 ? h : _), m);
  }
}
Le.funcKeywordCode = ho;
function Gn(e) {
  const { gen: t, data: r, it: n } = e;
  t.if(n.parentData, () => t.assign(r, (0, ge._)`${n.parentData}[${n.parentDataProperty}]`));
}
function mo(e, t) {
  const { gen: r } = e;
  r.if((0, ge._)`Array.isArray(${t})`, () => {
    r.assign(st.default.vErrors, (0, ge._)`${st.default.vErrors} === null ? ${t} : ${st.default.vErrors}.concat(${t})`).assign(st.default.errors, (0, ge._)`${st.default.vErrors}.length`), (0, lo.extendErrors)(e);
  }, () => e.error());
}
function po({ schemaEnv: e }, t) {
  if (t.async && !e.$async)
    throw new Error("async keyword in sync schema");
}
function Pa(e, t, r) {
  if (r === void 0)
    throw new Error(`keyword "${t}" failed to compile`);
  return e.scopeValue("keyword", typeof r == "function" ? { ref: r } : { ref: r, code: (0, ge.stringify)(r) });
}
function $o(e, t, r = !1) {
  return !t.length || t.some((n) => n === "array" ? Array.isArray(e) : n === "object" ? e && typeof e == "object" && !Array.isArray(e) : typeof e == n || r && typeof e > "u");
}
Le.validSchemaType = $o;
function yo({ schema: e, opts: t, self: r, errSchemaPath: n }, a, o) {
  if (Array.isArray(a.keyword) ? !a.keyword.includes(o) : a.keyword !== o)
    throw new Error("ajv implementation error");
  const c = a.dependencies;
  if (c != null && c.some((d) => !Object.prototype.hasOwnProperty.call(e, d)))
    throw new Error(`parent schema must have dependencies of ${o}: ${c.join(",")}`);
  if (a.validateSchema && !a.validateSchema(e[o])) {
    const y = `keyword "${o}" value is invalid at path "${n}": ` + r.errorsText(a.validateSchema.errors);
    if (t.validateSchema === "log")
      r.logger.error(y);
    else
      throw new Error(y);
  }
}
Le.validateKeywordUsage = yo;
var Ze = {};
Object.defineProperty(Ze, "__esModule", { value: !0 });
Ze.extendSubschemaMode = Ze.extendSubschemaData = Ze.getSubschema = void 0;
const Ke = X, Oa = V;
function vo(e, { keyword: t, schemaProp: r, schema: n, schemaPath: a, errSchemaPath: o, topSchemaRef: c }) {
  if (t !== void 0 && n !== void 0)
    throw new Error('both "keyword" and "schema" passed, only one allowed');
  if (t !== void 0) {
    const d = e.schema[t];
    return r === void 0 ? {
      schema: d,
      schemaPath: (0, Ke._)`${e.schemaPath}${(0, Ke.getProperty)(t)}`,
      errSchemaPath: `${e.errSchemaPath}/${t}`
    } : {
      schema: d[r],
      schemaPath: (0, Ke._)`${e.schemaPath}${(0, Ke.getProperty)(t)}${(0, Ke.getProperty)(r)}`,
      errSchemaPath: `${e.errSchemaPath}/${t}/${(0, Oa.escapeFragment)(r)}`
    };
  }
  if (n !== void 0) {
    if (a === void 0 || o === void 0 || c === void 0)
      throw new Error('"schemaPath", "errSchemaPath" and "topSchemaRef" are required with "schema"');
    return {
      schema: n,
      schemaPath: a,
      topSchemaRef: c,
      errSchemaPath: o
    };
  }
  throw new Error('either "keyword" or "schema" must be passed');
}
Ze.getSubschema = vo;
function _o(e, t, { dataProp: r, dataPropType: n, data: a, dataTypes: o, propertyName: c }) {
  if (a !== void 0 && r !== void 0)
    throw new Error('both "data" and "dataProp" passed, only one allowed');
  const { gen: d } = t;
  if (r !== void 0) {
    const { errorPath: l, dataPathArr: $, opts: _ } = t, C = d.let("data", (0, Ke._)`${t.data}${(0, Ke.getProperty)(r)}`, !0);
    y(C), e.errorPath = (0, Ke.str)`${l}${(0, Oa.getErrorPath)(r, n, _.jsPropertySyntax)}`, e.parentDataProperty = (0, Ke._)`${r}`, e.dataPathArr = [...$, e.parentDataProperty];
  }
  if (a !== void 0) {
    const l = a instanceof Ke.Name ? a : d.let("data", a, !0);
    y(l), c !== void 0 && (e.propertyName = c);
  }
  o && (e.dataTypes = o);
  function y(l) {
    e.data = l, e.dataLevel = t.dataLevel + 1, e.dataTypes = [], t.definedProperties = /* @__PURE__ */ new Set(), e.parentData = t.data, e.dataNames = [...t.dataNames, l];
  }
}
Ze.extendSubschemaData = _o;
function go(e, { jtdDiscriminator: t, jtdMetadata: r, compositeRule: n, createErrors: a, allErrors: o }) {
  n !== void 0 && (e.compositeRule = n), a !== void 0 && (e.createErrors = a), o !== void 0 && (e.allErrors = o), e.jtdDiscriminator = t, e.jtdMetadata = r;
}
Ze.extendSubschemaMode = go;
var ve = {}, Na = function e(t, r) {
  if (t === r)
    return !0;
  if (t && r && typeof t == "object" && typeof r == "object") {
    if (t.constructor !== r.constructor)
      return !1;
    var n, a, o;
    if (Array.isArray(t)) {
      if (n = t.length, n != r.length)
        return !1;
      for (a = n; a-- !== 0; )
        if (!e(t[a], r[a]))
          return !1;
      return !0;
    }
    if (t.constructor === RegExp)
      return t.source === r.source && t.flags === r.flags;
    if (t.valueOf !== Object.prototype.valueOf)
      return t.valueOf() === r.valueOf();
    if (t.toString !== Object.prototype.toString)
      return t.toString() === r.toString();
    if (o = Object.keys(t), n = o.length, n !== Object.keys(r).length)
      return !1;
    for (a = n; a-- !== 0; )
      if (!Object.prototype.hasOwnProperty.call(r, o[a]))
        return !1;
    for (a = n; a-- !== 0; ) {
      var c = o[a];
      if (!e(t[c], r[c]))
        return !1;
    }
    return !0;
  }
  return t !== t && r !== r;
}, Ta = { exports: {} }, Qe = Ta.exports = function(e, t, r) {
  typeof t == "function" && (r = t, t = {}), r = t.cb || r;
  var n = typeof r == "function" ? r : r.pre || function() {
  }, a = r.post || function() {
  };
  sr(t, n, a, e, "", e);
};
Qe.keywords = {
  additionalItems: !0,
  items: !0,
  contains: !0,
  additionalProperties: !0,
  propertyNames: !0,
  not: !0,
  if: !0,
  then: !0,
  else: !0
};
Qe.arrayKeywords = {
  items: !0,
  allOf: !0,
  anyOf: !0,
  oneOf: !0
};
Qe.propsKeywords = {
  $defs: !0,
  definitions: !0,
  properties: !0,
  patternProperties: !0,
  dependencies: !0
};
Qe.skipKeywords = {
  default: !0,
  enum: !0,
  const: !0,
  required: !0,
  maximum: !0,
  minimum: !0,
  exclusiveMaximum: !0,
  exclusiveMinimum: !0,
  multipleOf: !0,
  maxLength: !0,
  minLength: !0,
  pattern: !0,
  format: !0,
  maxItems: !0,
  minItems: !0,
  uniqueItems: !0,
  maxProperties: !0,
  minProperties: !0
};
function sr(e, t, r, n, a, o, c, d, y, l) {
  if (n && typeof n == "object" && !Array.isArray(n)) {
    t(n, a, o, c, d, y, l);
    for (var $ in n) {
      var _ = n[$];
      if (Array.isArray(_)) {
        if ($ in Qe.arrayKeywords)
          for (var C = 0; C < _.length; C++)
            sr(e, t, r, _[C], a + "/" + $ + "/" + C, o, a, $, n, C);
      } else if ($ in Qe.propsKeywords) {
        if (_ && typeof _ == "object")
          for (var T in _)
            sr(e, t, r, _[T], a + "/" + $ + "/" + wo(T), o, a, $, n, T);
      } else
        ($ in Qe.keywords || e.allKeys && !($ in Qe.skipKeywords)) && sr(e, t, r, _, a + "/" + $, o, a, $, n);
    }
    r(n, a, o, c, d, y, l);
  }
}
function wo(e) {
  return e.replace(/~/g, "~0").replace(/\//g, "~1");
}
var Eo = Ta.exports;
Object.defineProperty(ve, "__esModule", { value: !0 });
ve.getSchemaRefs = ve.resolveUrl = ve.normalizeId = ve._getFullPath = ve.getFullPath = ve.inlineRef = void 0;
const bo = V, So = Na, Po = Eo, Oo = /* @__PURE__ */ new Set([
  "type",
  "format",
  "pattern",
  "maxLength",
  "minLength",
  "maxProperties",
  "minProperties",
  "maxItems",
  "minItems",
  "maximum",
  "minimum",
  "uniqueItems",
  "multipleOf",
  "required",
  "enum",
  "const"
]);
function No(e, t = !0) {
  return typeof e == "boolean" ? !0 : t === !0 ? !Rr(e) : t ? Ca(e) <= t : !1;
}
ve.inlineRef = No;
const To = /* @__PURE__ */ new Set([
  "$ref",
  "$recursiveRef",
  "$recursiveAnchor",
  "$dynamicRef",
  "$dynamicAnchor"
]);
function Rr(e) {
  for (const t in e) {
    if (To.has(t))
      return !0;
    const r = e[t];
    if (Array.isArray(r) && r.some(Rr) || typeof r == "object" && Rr(r))
      return !0;
  }
  return !1;
}
function Ca(e) {
  let t = 0;
  for (const r in e) {
    if (r === "$ref")
      return 1 / 0;
    if (t++, !Oo.has(r) && (typeof e[r] == "object" && (0, bo.eachItem)(e[r], (n) => t += Ca(n)), t === 1 / 0))
      return 1 / 0;
  }
  return t;
}
function Ra(e, t = "", r) {
  r !== !1 && (t = gt(t));
  const n = e.parse(t);
  return ja(e, n);
}
ve.getFullPath = Ra;
function ja(e, t) {
  return e.serialize(t).split("#")[0] + "#";
}
ve._getFullPath = ja;
const Co = /#\/?$/;
function gt(e) {
  return e ? e.replace(Co, "") : "";
}
ve.normalizeId = gt;
function Ro(e, t, r) {
  return r = gt(r), e.resolve(t, r);
}
ve.resolveUrl = Ro;
const jo = /^[a-z_][-a-z0-9._]*$/i;
function Io(e, t) {
  if (typeof e == "boolean")
    return {};
  const { schemaId: r, uriResolver: n } = this.opts, a = gt(e[r] || t), o = { "": a }, c = Ra(n, a, !1), d = {}, y = /* @__PURE__ */ new Set();
  return Po(e, { allKeys: !0 }, (_, C, T, P) => {
    if (P === void 0)
      return;
    const O = c + C;
    let g = o[P];
    typeof _[r] == "string" && (g = m.call(this, _[r])), h.call(this, _.$anchor), h.call(this, _.$dynamicAnchor), o[C] = g;
    function m(R) {
      const k = this.opts.uriResolver.resolve;
      if (R = gt(g ? k(g, R) : R), y.has(R))
        throw $(R);
      y.add(R);
      let A = this.refs[R];
      return typeof A == "string" && (A = this.refs[A]), typeof A == "object" ? l(_, A.schema, R) : R !== gt(O) && (R[0] === "#" ? (l(_, d[R], R), d[R] = _) : this.refs[R] = O), R;
    }
    function h(R) {
      if (typeof R == "string") {
        if (!jo.test(R))
          throw new Error(`invalid anchor "${R}"`);
        m.call(this, `#${R}`);
      }
    }
  }), d;
  function l(_, C, T) {
    if (C !== void 0 && !So(_, C))
      throw $(T);
  }
  function $(_) {
    return new Error(`reference "${_}" resolves to more than one schema`);
  }
}
ve.getSchemaRefs = Io;
Object.defineProperty(Ce, "__esModule", { value: !0 });
Ce.getData = Ce.KeywordCxt = Ce.validateFunctionCode = void 0;
const Ia = wt, Jn = $e, Gr = Ge, ur = $e, ko = mr, Ut = Le, gr = Ze, U = X, J = ke, Do = ve, Je = V, Vt = St;
function Ao(e) {
  if (Aa(e) && (Ma(e), Da(e))) {
    Fo(e);
    return;
  }
  ka(e, () => (0, Ia.topBoolOrEmptySchema)(e));
}
Ce.validateFunctionCode = Ao;
function ka({ gen: e, validateName: t, schema: r, schemaEnv: n, opts: a }, o) {
  a.code.es5 ? e.func(t, (0, U._)`${J.default.data}, ${J.default.valCxt}`, n.$async, () => {
    e.code((0, U._)`"use strict"; ${Wn(r, a)}`), Vo(e, a), e.code(o);
  }) : e.func(t, (0, U._)`${J.default.data}, ${Mo(a)}`, n.$async, () => e.code(Wn(r, a)).code(o));
}
function Mo(e) {
  return (0, U._)`{${J.default.instancePath}="", ${J.default.parentData}, ${J.default.parentDataProperty}, ${J.default.rootData}=${J.default.data}${e.dynamicRef ? (0, U._)`, ${J.default.dynamicAnchors}={}` : U.nil}}={}`;
}
function Vo(e, t) {
  e.if(J.default.valCxt, () => {
    e.var(J.default.instancePath, (0, U._)`${J.default.valCxt}.${J.default.instancePath}`), e.var(J.default.parentData, (0, U._)`${J.default.valCxt}.${J.default.parentData}`), e.var(J.default.parentDataProperty, (0, U._)`${J.default.valCxt}.${J.default.parentDataProperty}`), e.var(J.default.rootData, (0, U._)`${J.default.valCxt}.${J.default.rootData}`), t.dynamicRef && e.var(J.default.dynamicAnchors, (0, U._)`${J.default.valCxt}.${J.default.dynamicAnchors}`);
  }, () => {
    e.var(J.default.instancePath, (0, U._)`""`), e.var(J.default.parentData, (0, U._)`undefined`), e.var(J.default.parentDataProperty, (0, U._)`undefined`), e.var(J.default.rootData, J.default.data), t.dynamicRef && e.var(J.default.dynamicAnchors, (0, U._)`{}`);
  });
}
function Fo(e) {
  const { schema: t, opts: r, gen: n } = e;
  ka(e, () => {
    r.$comment && t.$comment && Fa(e), Lo(e), n.let(J.default.vErrors, null), n.let(J.default.errors, 0), r.unevaluated && zo(e), Va(e), Jo(e);
  });
}
function zo(e) {
  const { gen: t, validateName: r } = e;
  e.evaluated = t.const("evaluated", (0, U._)`${r}.evaluated`), t.if((0, U._)`${e.evaluated}.dynamicProps`, () => t.assign((0, U._)`${e.evaluated}.props`, (0, U._)`undefined`)), t.if((0, U._)`${e.evaluated}.dynamicItems`, () => t.assign((0, U._)`${e.evaluated}.items`, (0, U._)`undefined`));
}
function Wn(e, t) {
  const r = typeof e == "object" && e[t.schemaId];
  return r && (t.code.source || t.code.process) ? (0, U._)`/*# sourceURL=${r} */` : U.nil;
}
function Uo(e, t) {
  if (Aa(e) && (Ma(e), Da(e))) {
    qo(e, t);
    return;
  }
  (0, Ia.boolOrEmptySchema)(e, t);
}
function Da({ schema: e, self: t }) {
  if (typeof e == "boolean")
    return !e;
  for (const r in e)
    if (t.RULES.all[r])
      return !0;
  return !1;
}
function Aa(e) {
  return typeof e.schema != "boolean";
}
function qo(e, t) {
  const { schema: r, gen: n, opts: a } = e;
  a.$comment && r.$comment && Fa(e), Ho(e), Go(e);
  const o = n.const("_errs", J.default.errors);
  Va(e, o), n.var(t, (0, U._)`${o} === ${J.default.errors}`);
}
function Ma(e) {
  (0, Je.checkUnknownRules)(e), Ko(e);
}
function Va(e, t) {
  if (e.opts.jtd)
    return Bn(e, [], !1, t);
  const r = (0, Jn.getSchemaTypes)(e.schema), n = (0, Jn.coerceAndCheckDataType)(e, r);
  Bn(e, r, !n, t);
}
function Ko(e) {
  const { schema: t, errSchemaPath: r, opts: n, self: a } = e;
  t.$ref && n.ignoreKeywordsWithRef && (0, Je.schemaHasRulesButRef)(t, a.RULES) && a.logger.warn(`$ref: keywords ignored in schema at path "${r}"`);
}
function Lo(e) {
  const { schema: t, opts: r } = e;
  t.default !== void 0 && r.useDefaults && r.strictSchema && (0, Je.checkStrictMode)(e, "default is ignored in the schema root");
}
function Ho(e) {
  const t = e.schema[e.opts.schemaId];
  t && (e.baseId = (0, Do.resolveUrl)(e.opts.uriResolver, e.baseId, t));
}
function Go(e) {
  if (e.schema.$async && !e.schemaEnv.$async)
    throw new Error("async schema in sync schema");
}
function Fa({ gen: e, schemaEnv: t, schema: r, errSchemaPath: n, opts: a }) {
  const o = r.$comment;
  if (a.$comment === !0)
    e.code((0, U._)`${J.default.self}.logger.log(${o})`);
  else if (typeof a.$comment == "function") {
    const c = (0, U.str)`${n}/$comment`, d = e.scopeValue("root", { ref: t.root });
    e.code((0, U._)`${J.default.self}.opts.$comment(${o}, ${c}, ${d}.schema)`);
  }
}
function Jo(e) {
  const { gen: t, schemaEnv: r, validateName: n, ValidationError: a, opts: o } = e;
  r.$async ? t.if((0, U._)`${J.default.errors} === 0`, () => t.return(J.default.data), () => t.throw((0, U._)`new ${a}(${J.default.vErrors})`)) : (t.assign((0, U._)`${n}.errors`, J.default.vErrors), o.unevaluated && Wo(e), t.return((0, U._)`${J.default.errors} === 0`));
}
function Wo({ gen: e, evaluated: t, props: r, items: n }) {
  r instanceof U.Name && e.assign((0, U._)`${t}.props`, r), n instanceof U.Name && e.assign((0, U._)`${t}.items`, n);
}
function Bn(e, t, r, n) {
  const { gen: a, schema: o, data: c, allErrors: d, opts: y, self: l } = e, { RULES: $ } = l;
  if (o.$ref && (y.ignoreKeywordsWithRef || !(0, Je.schemaHasRulesButRef)(o, $))) {
    a.block(() => qa(e, "$ref", $.all.$ref.definition));
    return;
  }
  y.jtd || Bo(e, t), a.block(() => {
    for (const C of $.rules)
      _(C);
    _($.post);
  });
  function _(C) {
    (0, Gr.shouldUseGroup)(o, C) && (C.type ? (a.if((0, ur.checkDataType)(C.type, c, y.strictNumbers)), Yn(e, C), t.length === 1 && t[0] === C.type && r && (a.else(), (0, ur.reportTypeError)(e)), a.endIf()) : Yn(e, C), d || a.if((0, U._)`${J.default.errors} === ${n || 0}`));
  }
}
function Yn(e, t) {
  const { gen: r, schema: n, opts: { useDefaults: a } } = e;
  a && (0, ko.assignDefaults)(e, t.type), r.block(() => {
    for (const o of t.rules)
      (0, Gr.shouldUseRule)(n, o) && qa(e, o.keyword, o.definition, t.type);
  });
}
function Bo(e, t) {
  e.schemaEnv.meta || !e.opts.strictTypes || (Yo(e, t), e.opts.allowUnionTypes || Xo(e, t), Qo(e, e.dataTypes));
}
function Yo(e, t) {
  if (t.length) {
    if (!e.dataTypes.length) {
      e.dataTypes = t;
      return;
    }
    t.forEach((r) => {
      za(e.dataTypes, r) || Jr(e, `type "${r}" not allowed by context "${e.dataTypes.join(",")}"`);
    }), xo(e, t);
  }
}
function Xo(e, t) {
  t.length > 1 && !(t.length === 2 && t.includes("null")) && Jr(e, "use allowUnionTypes to allow union type keyword");
}
function Qo(e, t) {
  const r = e.self.RULES.all;
  for (const n in r) {
    const a = r[n];
    if (typeof a == "object" && (0, Gr.shouldUseRule)(e.schema, a)) {
      const { type: o } = a.definition;
      o.length && !o.some((c) => Zo(t, c)) && Jr(e, `missing type "${o.join(",")}" for keyword "${n}"`);
    }
  }
}
function Zo(e, t) {
  return e.includes(t) || t === "number" && e.includes("integer");
}
function za(e, t) {
  return e.includes(t) || t === "integer" && e.includes("number");
}
function xo(e, t) {
  const r = [];
  for (const n of e.dataTypes)
    za(t, n) ? r.push(n) : t.includes("integer") && n === "number" && r.push("integer");
  e.dataTypes = r;
}
function Jr(e, t) {
  const r = e.schemaEnv.baseId + e.errSchemaPath;
  t += ` at "${r}" (strictTypes)`, (0, Je.checkStrictMode)(e, t, e.opts.strictTypes);
}
class Ua {
  constructor(t, r, n) {
    if ((0, Ut.validateKeywordUsage)(t, r, n), this.gen = t.gen, this.allErrors = t.allErrors, this.keyword = n, this.data = t.data, this.schema = t.schema[n], this.$data = r.$data && t.opts.$data && this.schema && this.schema.$data, this.schemaValue = (0, Je.schemaRefOrVal)(t, this.schema, n, this.$data), this.schemaType = r.schemaType, this.parentSchema = t.schema, this.params = {}, this.it = t, this.def = r, this.$data)
      this.schemaCode = t.gen.const("vSchema", Ka(this.$data, t));
    else if (this.schemaCode = this.schemaValue, !(0, Ut.validSchemaType)(this.schema, r.schemaType, r.allowUndefined))
      throw new Error(`${n} value must be ${JSON.stringify(r.schemaType)}`);
    ("code" in r ? r.trackErrors : r.errors !== !1) && (this.errsCount = t.gen.const("_errs", J.default.errors));
  }
  result(t, r, n) {
    this.failResult((0, U.not)(t), r, n);
  }
  failResult(t, r, n) {
    this.gen.if(t), n ? n() : this.error(), r ? (this.gen.else(), r(), this.allErrors && this.gen.endIf()) : this.allErrors ? this.gen.endIf() : this.gen.else();
  }
  pass(t, r) {
    this.failResult((0, U.not)(t), void 0, r);
  }
  fail(t) {
    if (t === void 0) {
      this.error(), this.allErrors || this.gen.if(!1);
      return;
    }
    this.gen.if(t), this.error(), this.allErrors ? this.gen.endIf() : this.gen.else();
  }
  fail$data(t) {
    if (!this.$data)
      return this.fail(t);
    const { schemaCode: r } = this;
    this.fail((0, U._)`${r} !== undefined && (${(0, U.or)(this.invalid$data(), t)})`);
  }
  error(t, r, n) {
    if (r) {
      this.setParams(r), this._error(t, n), this.setParams({});
      return;
    }
    this._error(t, n);
  }
  _error(t, r) {
    (t ? Vt.reportExtraError : Vt.reportError)(this, this.def.error, r);
  }
  $dataError() {
    (0, Vt.reportError)(this, this.def.$dataError || Vt.keyword$DataError);
  }
  reset() {
    if (this.errsCount === void 0)
      throw new Error('add "trackErrors" to keyword definition');
    (0, Vt.resetErrorsCount)(this.gen, this.errsCount);
  }
  ok(t) {
    this.allErrors || this.gen.if(t);
  }
  setParams(t, r) {
    r ? Object.assign(this.params, t) : this.params = t;
  }
  block$data(t, r, n = U.nil) {
    this.gen.block(() => {
      this.check$data(t, n), r();
    });
  }
  check$data(t = U.nil, r = U.nil) {
    if (!this.$data)
      return;
    const { gen: n, schemaCode: a, schemaType: o, def: c } = this;
    n.if((0, U.or)((0, U._)`${a} === undefined`, r)), t !== U.nil && n.assign(t, !0), (o.length || c.validateSchema) && (n.elseIf(this.invalid$data()), this.$dataError(), t !== U.nil && n.assign(t, !1)), n.else();
  }
  invalid$data() {
    const { gen: t, schemaCode: r, schemaType: n, def: a, it: o } = this;
    return (0, U.or)(c(), d());
    function c() {
      if (n.length) {
        if (!(r instanceof U.Name))
          throw new Error("ajv implementation error");
        const y = Array.isArray(n) ? n : [n];
        return (0, U._)`${(0, ur.checkDataTypes)(y, r, o.opts.strictNumbers, ur.DataType.Wrong)}`;
      }
      return U.nil;
    }
    function d() {
      if (a.validateSchema) {
        const y = t.scopeValue("validate$data", { ref: a.validateSchema });
        return (0, U._)`!${y}(${r})`;
      }
      return U.nil;
    }
  }
  subschema(t, r) {
    const n = (0, gr.getSubschema)(this.it, t);
    (0, gr.extendSubschemaData)(n, this.it, t), (0, gr.extendSubschemaMode)(n, t);
    const a = { ...this.it, ...n, items: void 0, props: void 0 };
    return Uo(a, r), a;
  }
  mergeEvaluated(t, r) {
    const { it: n, gen: a } = this;
    n.opts.unevaluated && (n.props !== !0 && t.props !== void 0 && (n.props = Je.mergeEvaluated.props(a, t.props, n.props, r)), n.items !== !0 && t.items !== void 0 && (n.items = Je.mergeEvaluated.items(a, t.items, n.items, r)));
  }
  mergeValidEvaluated(t, r) {
    const { it: n, gen: a } = this;
    if (n.opts.unevaluated && (n.props !== !0 || n.items !== !0))
      return a.if(r, () => this.mergeEvaluated(t, U.Name)), !0;
  }
}
Ce.KeywordCxt = Ua;
function qa(e, t, r, n) {
  const a = new Ua(e, r, t);
  "code" in r ? r.code(a, n) : a.$data && r.validate ? (0, Ut.funcKeywordCode)(a, r) : "macro" in r ? (0, Ut.macroKeywordCode)(a, r) : (r.compile || r.validate) && (0, Ut.funcKeywordCode)(a, r);
}
const ei = /^\/(?:[^~]|~0|~1)*$/, ti = /^([0-9]+)(#|\/(?:[^~]|~0|~1)*)?$/;
function Ka(e, { dataLevel: t, dataNames: r, dataPathArr: n }) {
  let a, o;
  if (e === "")
    return J.default.rootData;
  if (e[0] === "/") {
    if (!ei.test(e))
      throw new Error(`Invalid JSON-pointer: ${e}`);
    a = e, o = J.default.rootData;
  } else {
    const l = ti.exec(e);
    if (!l)
      throw new Error(`Invalid JSON-pointer: ${e}`);
    const $ = +l[1];
    if (a = l[2], a === "#") {
      if ($ >= t)
        throw new Error(y("property/index", $));
      return n[t - $];
    }
    if ($ > t)
      throw new Error(y("data", $));
    if (o = r[t - $], !a)
      return o;
  }
  let c = o;
  const d = a.split("/");
  for (const l of d)
    l && (o = (0, U._)`${o}${(0, U.getProperty)((0, Je.unescapeJsonPointer)(l))}`, c = (0, U._)`${c} && ${o}`);
  return c;
  function y(l, $) {
    return `Cannot access ${l} ${$} levels up, current level is ${t}`;
  }
}
Ce.getData = Ka;
var Gt = {};
Object.defineProperty(Gt, "__esModule", { value: !0 });
class ri extends Error {
  constructor(t) {
    super("validation failed"), this.errors = t, this.ajv = this.validation = !0;
  }
}
Gt.default = ri;
var Jt = {};
Object.defineProperty(Jt, "__esModule", { value: !0 });
const wr = ve;
class ni extends Error {
  constructor(t, r, n, a) {
    super(a || `can't resolve reference ${n} from id ${r}`), this.missingRef = (0, wr.resolveUrl)(t, r, n), this.missingSchema = (0, wr.normalizeId)((0, wr.getFullPath)(t, this.missingRef));
  }
}
Jt.default = ni;
var Se = {};
Object.defineProperty(Se, "__esModule", { value: !0 });
Se.resolveSchema = Se.getCompilingSchema = Se.resolveRef = Se.compileSchema = Se.SchemaEnv = void 0;
const Re = X, ai = Gt, at = ke, Ie = ve, Xn = V, si = Ce;
class pr {
  constructor(t) {
    var r;
    this.refs = {}, this.dynamicAnchors = {};
    let n;
    typeof t.schema == "object" && (n = t.schema), this.schema = t.schema, this.schemaId = t.schemaId, this.root = t.root || this, this.baseId = (r = t.baseId) !== null && r !== void 0 ? r : (0, Ie.normalizeId)(n == null ? void 0 : n[t.schemaId || "$id"]), this.schemaPath = t.schemaPath, this.localRefs = t.localRefs, this.meta = t.meta, this.$async = n == null ? void 0 : n.$async, this.refs = {};
  }
}
Se.SchemaEnv = pr;
function Wr(e) {
  const t = La.call(this, e);
  if (t)
    return t;
  const r = (0, Ie.getFullPath)(this.opts.uriResolver, e.root.baseId), { es5: n, lines: a } = this.opts.code, { ownProperties: o } = this.opts, c = new Re.CodeGen(this.scope, { es5: n, lines: a, ownProperties: o });
  let d;
  e.$async && (d = c.scopeValue("Error", {
    ref: ai.default,
    code: (0, Re._)`require("ajv/dist/runtime/validation_error").default`
  }));
  const y = c.scopeName("validate");
  e.validateName = y;
  const l = {
    gen: c,
    allErrors: this.opts.allErrors,
    data: at.default.data,
    parentData: at.default.parentData,
    parentDataProperty: at.default.parentDataProperty,
    dataNames: [at.default.data],
    dataPathArr: [Re.nil],
    // TODO can its length be used as dataLevel if nil is removed?
    dataLevel: 0,
    dataTypes: [],
    definedProperties: /* @__PURE__ */ new Set(),
    topSchemaRef: c.scopeValue("schema", this.opts.code.source === !0 ? { ref: e.schema, code: (0, Re.stringify)(e.schema) } : { ref: e.schema }),
    validateName: y,
    ValidationError: d,
    schema: e.schema,
    schemaEnv: e,
    rootId: r,
    baseId: e.baseId || r,
    schemaPath: Re.nil,
    errSchemaPath: e.schemaPath || (this.opts.jtd ? "" : "#"),
    errorPath: (0, Re._)`""`,
    opts: this.opts,
    self: this
  };
  let $;
  try {
    this._compilations.add(e), (0, si.validateFunctionCode)(l), c.optimize(this.opts.code.optimize);
    const _ = c.toString();
    $ = `${c.scopeRefs(at.default.scope)}return ${_}`, this.opts.code.process && ($ = this.opts.code.process($, e));
    const T = new Function(`${at.default.self}`, `${at.default.scope}`, $)(this, this.scope.get());
    if (this.scope.value(y, { ref: T }), T.errors = null, T.schema = e.schema, T.schemaEnv = e, e.$async && (T.$async = !0), this.opts.code.source === !0 && (T.source = { validateName: y, validateCode: _, scopeValues: c._values }), this.opts.unevaluated) {
      const { props: P, items: O } = l;
      T.evaluated = {
        props: P instanceof Re.Name ? void 0 : P,
        items: O instanceof Re.Name ? void 0 : O,
        dynamicProps: P instanceof Re.Name,
        dynamicItems: O instanceof Re.Name
      }, T.source && (T.source.evaluated = (0, Re.stringify)(T.evaluated));
    }
    return e.validate = T, e;
  } catch (_) {
    throw delete e.validate, delete e.validateName, $ && this.logger.error("Error compiling schema, function code:", $), _;
  } finally {
    this._compilations.delete(e);
  }
}
Se.compileSchema = Wr;
function oi(e, t, r) {
  var n;
  r = (0, Ie.resolveUrl)(this.opts.uriResolver, t, r);
  const a = e.refs[r];
  if (a)
    return a;
  let o = ui.call(this, e, r);
  if (o === void 0) {
    const c = (n = e.localRefs) === null || n === void 0 ? void 0 : n[r], { schemaId: d } = this.opts;
    c && (o = new pr({ schema: c, schemaId: d, root: e, baseId: t }));
  }
  if (o !== void 0)
    return e.refs[r] = ii.call(this, o);
}
Se.resolveRef = oi;
function ii(e) {
  return (0, Ie.inlineRef)(e.schema, this.opts.inlineRefs) ? e.schema : e.validate ? e : Wr.call(this, e);
}
function La(e) {
  for (const t of this._compilations)
    if (ci(t, e))
      return t;
}
Se.getCompilingSchema = La;
function ci(e, t) {
  return e.schema === t.schema && e.root === t.root && e.baseId === t.baseId;
}
function ui(e, t) {
  let r;
  for (; typeof (r = this.refs[t]) == "string"; )
    t = r;
  return r || this.schemas[t] || $r.call(this, e, t);
}
function $r(e, t) {
  const r = this.opts.uriResolver.parse(t), n = (0, Ie._getFullPath)(this.opts.uriResolver, r);
  let a = (0, Ie.getFullPath)(this.opts.uriResolver, e.baseId, void 0);
  if (Object.keys(e.schema).length > 0 && n === a)
    return Er.call(this, r, e);
  const o = (0, Ie.normalizeId)(n), c = this.refs[o] || this.schemas[o];
  if (typeof c == "string") {
    const d = $r.call(this, e, c);
    return typeof (d == null ? void 0 : d.schema) != "object" ? void 0 : Er.call(this, r, d);
  }
  if (typeof (c == null ? void 0 : c.schema) == "object") {
    if (c.validate || Wr.call(this, c), o === (0, Ie.normalizeId)(t)) {
      const { schema: d } = c, { schemaId: y } = this.opts, l = d[y];
      return l && (a = (0, Ie.resolveUrl)(this.opts.uriResolver, a, l)), new pr({ schema: d, schemaId: y, root: e, baseId: a });
    }
    return Er.call(this, r, c);
  }
}
Se.resolveSchema = $r;
const di = /* @__PURE__ */ new Set([
  "properties",
  "patternProperties",
  "enum",
  "dependencies",
  "definitions"
]);
function Er(e, { baseId: t, schema: r, root: n }) {
  var a;
  if (((a = e.fragment) === null || a === void 0 ? void 0 : a[0]) !== "/")
    return;
  for (const d of e.fragment.slice(1).split("/")) {
    if (typeof r == "boolean")
      return;
    const y = r[(0, Xn.unescapeFragment)(d)];
    if (y === void 0)
      return;
    r = y;
    const l = typeof r == "object" && r[this.opts.schemaId];
    !di.has(d) && l && (t = (0, Ie.resolveUrl)(this.opts.uriResolver, t, l));
  }
  let o;
  if (typeof r != "boolean" && r.$ref && !(0, Xn.schemaHasRulesButRef)(r, this.RULES)) {
    const d = (0, Ie.resolveUrl)(this.opts.uriResolver, t, r.$ref);
    o = $r.call(this, n, d);
  }
  const { schemaId: c } = this.opts;
  if (o = o || new pr({ schema: r, schemaId: c, root: n, baseId: t }), o.schema !== o.root.schema)
    return o;
}
const li = "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#", fi = "Meta-schema for $data reference (JSON AnySchema extension proposal)", hi = "object", mi = [
  "$data"
], pi = {
  $data: {
    type: "string",
    anyOf: [
      {
        format: "relative-json-pointer"
      },
      {
        format: "json-pointer"
      }
    ]
  }
}, $i = !1, yi = {
  $id: li,
  description: fi,
  type: hi,
  required: mi,
  properties: pi,
  additionalProperties: $i
};
var Br = {}, jr = { exports: {} };
/** @license URI.js v4.4.1 (c) 2011 Gary Court. License: http://github.com/garycourt/uri-js */
(function(e, t) {
  (function(r, n) {
    n(t);
  })(ys, function(r) {
    function n() {
      for (var f = arguments.length, i = Array(f), p = 0; p < f; p++)
        i[p] = arguments[p];
      if (i.length > 1) {
        i[0] = i[0].slice(0, -1);
        for (var N = i.length - 1, S = 1; S < N; ++S)
          i[S] = i[S].slice(1, -1);
        return i[N] = i[N].slice(1), i.join("");
      } else
        return i[0];
    }
    function a(f) {
      return "(?:" + f + ")";
    }
    function o(f) {
      return f === void 0 ? "undefined" : f === null ? "null" : Object.prototype.toString.call(f).split(" ").pop().split("]").shift().toLowerCase();
    }
    function c(f) {
      return f.toUpperCase();
    }
    function d(f) {
      return f != null ? f instanceof Array ? f : typeof f.length != "number" || f.split || f.setInterval || f.call ? [f] : Array.prototype.slice.call(f) : [];
    }
    function y(f, i) {
      var p = f;
      if (i)
        for (var N in i)
          p[N] = i[N];
      return p;
    }
    function l(f) {
      var i = "[A-Za-z]", p = "[0-9]", N = n(p, "[A-Fa-f]"), S = a(a("%[EFef]" + N + "%" + N + N + "%" + N + N) + "|" + a("%[89A-Fa-f]" + N + "%" + N + N) + "|" + a("%" + N + N)), q = "[\\:\\/\\?\\#\\[\\]\\@]", L = "[\\!\\$\\&\\'\\(\\)\\*\\+\\,\\;\\=]", ee = n(q, L), oe = f ? "[\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]" : "[]", fe = f ? "[\\uE000-\\uF8FF]" : "[]", x = n(i, p, "[\\-\\.\\_\\~]", oe);
      a(i + n(i, p, "[\\+\\-\\.]") + "*"), a(a(S + "|" + n(x, L, "[\\:]")) + "*");
      var se = a(a("25[0-5]") + "|" + a("2[0-4]" + p) + "|" + a("1" + p + p) + "|" + a("0?[1-9]" + p) + "|0?0?" + p), he = a(se + "\\." + se + "\\." + se + "\\." + se), W = a(N + "{1,4}"), ue = a(a(W + "\\:" + W) + "|" + he), pe = a(a(W + "\\:") + "{6}" + ue), de = a("\\:\\:" + a(W + "\\:") + "{5}" + ue), Be = a(a(W) + "?\\:\\:" + a(W + "\\:") + "{4}" + ue), ze = a(a(a(W + "\\:") + "{0,1}" + W) + "?\\:\\:" + a(W + "\\:") + "{3}" + ue), Ue = a(a(a(W + "\\:") + "{0,2}" + W) + "?\\:\\:" + a(W + "\\:") + "{2}" + ue), pt = a(a(a(W + "\\:") + "{0,3}" + W) + "?\\:\\:" + W + "\\:" + ue), rt = a(a(a(W + "\\:") + "{0,4}" + W) + "?\\:\\:" + ue), Ne = a(a(a(W + "\\:") + "{0,5}" + W) + "?\\:\\:" + W), qe = a(a(a(W + "\\:") + "{0,6}" + W) + "?\\:\\:"), nt = a([pe, de, Be, ze, Ue, pt, rt, Ne, qe].join("|")), He = a(a(x + "|" + S) + "+");
      a("[vV]" + N + "+\\." + n(x, L, "[\\:]") + "+"), a(a(S + "|" + n(x, L)) + "*");
      var Dt = a(S + "|" + n(x, L, "[\\:\\@]"));
      return a(a(S + "|" + n(x, L, "[\\@]")) + "+"), a(a(Dt + "|" + n("[\\/\\?]", fe)) + "*"), {
        NOT_SCHEME: new RegExp(n("[^]", i, p, "[\\+\\-\\.]"), "g"),
        NOT_USERINFO: new RegExp(n("[^\\%\\:]", x, L), "g"),
        NOT_HOST: new RegExp(n("[^\\%\\[\\]\\:]", x, L), "g"),
        NOT_PATH: new RegExp(n("[^\\%\\/\\:\\@]", x, L), "g"),
        NOT_PATH_NOSCHEME: new RegExp(n("[^\\%\\/\\@]", x, L), "g"),
        NOT_QUERY: new RegExp(n("[^\\%]", x, L, "[\\:\\@\\/\\?]", fe), "g"),
        NOT_FRAGMENT: new RegExp(n("[^\\%]", x, L, "[\\:\\@\\/\\?]"), "g"),
        ESCAPE: new RegExp(n("[^]", x, L), "g"),
        UNRESERVED: new RegExp(x, "g"),
        OTHER_CHARS: new RegExp(n("[^\\%]", x, ee), "g"),
        PCT_ENCODED: new RegExp(S, "g"),
        IPV4ADDRESS: new RegExp("^(" + he + ")$"),
        IPV6ADDRESS: new RegExp("^\\[?(" + nt + ")" + a(a("\\%25|\\%(?!" + N + "{2})") + "(" + He + ")") + "?\\]?$")
        //RFC 6874, with relaxed parsing rules
      };
    }
    var $ = l(!1), _ = l(!0), C = /* @__PURE__ */ function() {
      function f(i, p) {
        var N = [], S = !0, q = !1, L = void 0;
        try {
          for (var ee = i[Symbol.iterator](), oe; !(S = (oe = ee.next()).done) && (N.push(oe.value), !(p && N.length === p)); S = !0)
            ;
        } catch (fe) {
          q = !0, L = fe;
        } finally {
          try {
            !S && ee.return && ee.return();
          } finally {
            if (q)
              throw L;
          }
        }
        return N;
      }
      return function(i, p) {
        if (Array.isArray(i))
          return i;
        if (Symbol.iterator in Object(i))
          return f(i, p);
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      };
    }(), T = function(f) {
      if (Array.isArray(f)) {
        for (var i = 0, p = Array(f.length); i < f.length; i++)
          p[i] = f[i];
        return p;
      } else
        return Array.from(f);
    }, P = 2147483647, O = 36, g = 1, m = 26, h = 38, R = 700, k = 72, A = 128, B = "-", te = /^xn--/, K = /[^\0-\x7E]/, M = /[\x2E\u3002\uFF0E\uFF61]/g, z = {
      overflow: "Overflow: input needs wider integers to process",
      "not-basic": "Illegal input >= 0x80 (not a basic code point)",
      "invalid-input": "Invalid input"
    }, Q = O - g, H = Math.floor, ae = String.fromCharCode;
    function le(f) {
      throw new RangeError(z[f]);
    }
    function we(f, i) {
      for (var p = [], N = f.length; N--; )
        p[N] = i(f[N]);
      return p;
    }
    function De(f, i) {
      var p = f.split("@"), N = "";
      p.length > 1 && (N = p[0] + "@", f = p[1]), f = f.replace(M, ".");
      var S = f.split("."), q = we(S, i).join(".");
      return N + q;
    }
    function We(f) {
      for (var i = [], p = 0, N = f.length; p < N; ) {
        var S = f.charCodeAt(p++);
        if (S >= 55296 && S <= 56319 && p < N) {
          var q = f.charCodeAt(p++);
          (q & 64512) == 56320 ? i.push(((S & 1023) << 10) + (q & 1023) + 65536) : (i.push(S), p--);
        } else
          i.push(S);
      }
      return i;
    }
    var xe = function(i) {
      return String.fromCodePoint.apply(String, T(i));
    }, Ae = function(i) {
      return i - 48 < 10 ? i - 22 : i - 65 < 26 ? i - 65 : i - 97 < 26 ? i - 97 : O;
    }, D = function(i, p) {
      return i + 22 + 75 * (i < 26) - ((p != 0) << 5);
    }, w = function(i, p, N) {
      var S = 0;
      for (
        i = N ? H(i / R) : i >> 1, i += H(i / p);
        /* no initialization */
        i > Q * m >> 1;
        S += O
      )
        i = H(i / Q);
      return H(S + (Q + 1) * i / (i + h));
    }, E = function(i) {
      var p = [], N = i.length, S = 0, q = A, L = k, ee = i.lastIndexOf(B);
      ee < 0 && (ee = 0);
      for (var oe = 0; oe < ee; ++oe)
        i.charCodeAt(oe) >= 128 && le("not-basic"), p.push(i.charCodeAt(oe));
      for (var fe = ee > 0 ? ee + 1 : 0; fe < N; ) {
        for (
          var x = S, se = 1, he = O;
          ;
          /* no condition */
          he += O
        ) {
          fe >= N && le("invalid-input");
          var W = Ae(i.charCodeAt(fe++));
          (W >= O || W > H((P - S) / se)) && le("overflow"), S += W * se;
          var ue = he <= L ? g : he >= L + m ? m : he - L;
          if (W < ue)
            break;
          var pe = O - ue;
          se > H(P / pe) && le("overflow"), se *= pe;
        }
        var de = p.length + 1;
        L = w(S - x, de, x == 0), H(S / de) > P - q && le("overflow"), q += H(S / de), S %= de, p.splice(S++, 0, q);
      }
      return String.fromCodePoint.apply(String, p);
    }, v = function(i) {
      var p = [];
      i = We(i);
      var N = i.length, S = A, q = 0, L = k, ee = !0, oe = !1, fe = void 0;
      try {
        for (var x = i[Symbol.iterator](), se; !(ee = (se = x.next()).done); ee = !0) {
          var he = se.value;
          he < 128 && p.push(ae(he));
        }
      } catch (At) {
        oe = !0, fe = At;
      } finally {
        try {
          !ee && x.return && x.return();
        } finally {
          if (oe)
            throw fe;
        }
      }
      var W = p.length, ue = W;
      for (W && p.push(B); ue < N; ) {
        var pe = P, de = !0, Be = !1, ze = void 0;
        try {
          for (var Ue = i[Symbol.iterator](), pt; !(de = (pt = Ue.next()).done); de = !0) {
            var rt = pt.value;
            rt >= S && rt < pe && (pe = rt);
          }
        } catch (At) {
          Be = !0, ze = At;
        } finally {
          try {
            !de && Ue.return && Ue.return();
          } finally {
            if (Be)
              throw ze;
          }
        }
        var Ne = ue + 1;
        pe - S > H((P - q) / Ne) && le("overflow"), q += (pe - S) * Ne, S = pe;
        var qe = !0, nt = !1, He = void 0;
        try {
          for (var Dt = i[Symbol.iterator](), Mn; !(qe = (Mn = Dt.next()).done); qe = !0) {
            var Vn = Mn.value;
            if (Vn < S && ++q > P && le("overflow"), Vn == S) {
              for (
                var Yt = q, Xt = O;
                ;
                /* no condition */
                Xt += O
              ) {
                var Qt = Xt <= L ? g : Xt >= L + m ? m : Xt - L;
                if (Yt < Qt)
                  break;
                var Fn = Yt - Qt, zn = O - Qt;
                p.push(ae(D(Qt + Fn % zn, 0))), Yt = H(Fn / zn);
              }
              p.push(ae(D(Yt, 0))), L = w(q, Ne, ue == W), q = 0, ++ue;
            }
          }
        } catch (At) {
          nt = !0, He = At;
        } finally {
          try {
            !qe && Dt.return && Dt.return();
          } finally {
            if (nt)
              throw He;
          }
        }
        ++q, ++S;
      }
      return p.join("");
    }, s = function(i) {
      return De(i, function(p) {
        return te.test(p) ? E(p.slice(4).toLowerCase()) : p;
      });
    }, u = function(i) {
      return De(i, function(p) {
        return K.test(p) ? "xn--" + v(p) : p;
      });
    }, b = {
      /**
       * A string representing the current Punycode.js version number.
       * @memberOf punycode
       * @type String
       */
      version: "2.1.0",
      /**
       * An object of methods to convert from JavaScript's internal character
       * representation (UCS-2) to Unicode code points, and back.
       * @see <https://mathiasbynens.be/notes/javascript-encoding>
       * @memberOf punycode
       * @type Object
       */
      ucs2: {
        decode: We,
        encode: xe
      },
      decode: E,
      encode: v,
      toASCII: u,
      toUnicode: s
    }, I = {};
    function j(f) {
      var i = f.charCodeAt(0), p = void 0;
      return i < 16 ? p = "%0" + i.toString(16).toUpperCase() : i < 128 ? p = "%" + i.toString(16).toUpperCase() : i < 2048 ? p = "%" + (i >> 6 | 192).toString(16).toUpperCase() + "%" + (i & 63 | 128).toString(16).toUpperCase() : p = "%" + (i >> 12 | 224).toString(16).toUpperCase() + "%" + (i >> 6 & 63 | 128).toString(16).toUpperCase() + "%" + (i & 63 | 128).toString(16).toUpperCase(), p;
    }
    function F(f) {
      for (var i = "", p = 0, N = f.length; p < N; ) {
        var S = parseInt(f.substr(p + 1, 2), 16);
        if (S < 128)
          i += String.fromCharCode(S), p += 3;
        else if (S >= 194 && S < 224) {
          if (N - p >= 6) {
            var q = parseInt(f.substr(p + 4, 2), 16);
            i += String.fromCharCode((S & 31) << 6 | q & 63);
          } else
            i += f.substr(p, 6);
          p += 6;
        } else if (S >= 224) {
          if (N - p >= 9) {
            var L = parseInt(f.substr(p + 4, 2), 16), ee = parseInt(f.substr(p + 7, 2), 16);
            i += String.fromCharCode((S & 15) << 12 | (L & 63) << 6 | ee & 63);
          } else
            i += f.substr(p, 9);
          p += 9;
        } else
          i += f.substr(p, 3), p += 3;
      }
      return i;
    }
    function G(f, i) {
      function p(N) {
        var S = F(N);
        return S.match(i.UNRESERVED) ? S : N;
      }
      return f.scheme && (f.scheme = String(f.scheme).replace(i.PCT_ENCODED, p).toLowerCase().replace(i.NOT_SCHEME, "")), f.userinfo !== void 0 && (f.userinfo = String(f.userinfo).replace(i.PCT_ENCODED, p).replace(i.NOT_USERINFO, j).replace(i.PCT_ENCODED, c)), f.host !== void 0 && (f.host = String(f.host).replace(i.PCT_ENCODED, p).toLowerCase().replace(i.NOT_HOST, j).replace(i.PCT_ENCODED, c)), f.path !== void 0 && (f.path = String(f.path).replace(i.PCT_ENCODED, p).replace(f.scheme ? i.NOT_PATH : i.NOT_PATH_NOSCHEME, j).replace(i.PCT_ENCODED, c)), f.query !== void 0 && (f.query = String(f.query).replace(i.PCT_ENCODED, p).replace(i.NOT_QUERY, j).replace(i.PCT_ENCODED, c)), f.fragment !== void 0 && (f.fragment = String(f.fragment).replace(i.PCT_ENCODED, p).replace(i.NOT_FRAGMENT, j).replace(i.PCT_ENCODED, c)), f;
    }
    function re(f) {
      return f.replace(/^0*(.*)/, "$1") || "0";
    }
    function ce(f, i) {
      var p = f.match(i.IPV4ADDRESS) || [], N = C(p, 2), S = N[1];
      return S ? S.split(".").map(re).join(".") : f;
    }
    function Me(f, i) {
      var p = f.match(i.IPV6ADDRESS) || [], N = C(p, 3), S = N[1], q = N[2];
      if (S) {
        for (var L = S.toLowerCase().split("::").reverse(), ee = C(L, 2), oe = ee[0], fe = ee[1], x = fe ? fe.split(":").map(re) : [], se = oe.split(":").map(re), he = i.IPV4ADDRESS.test(se[se.length - 1]), W = he ? 7 : 8, ue = se.length - W, pe = Array(W), de = 0; de < W; ++de)
          pe[de] = x[de] || se[ue + de] || "";
        he && (pe[W - 1] = ce(pe[W - 1], i));
        var Be = pe.reduce(function(Ne, qe, nt) {
          if (!qe || qe === "0") {
            var He = Ne[Ne.length - 1];
            He && He.index + He.length === nt ? He.length++ : Ne.push({ index: nt, length: 1 });
          }
          return Ne;
        }, []), ze = Be.sort(function(Ne, qe) {
          return qe.length - Ne.length;
        })[0], Ue = void 0;
        if (ze && ze.length > 1) {
          var pt = pe.slice(0, ze.index), rt = pe.slice(ze.index + ze.length);
          Ue = pt.join(":") + "::" + rt.join(":");
        } else
          Ue = pe.join(":");
        return q && (Ue += "%" + q), Ue;
      } else
        return f;
    }
    var Nt = /^(?:([^:\/?#]+):)?(?:\/\/((?:([^\/?#@]*)@)?(\[[^\/?#\]]+\]|[^\/?#:]*)(?:\:(\d*))?))?([^?#]*)(?:\?([^#]*))?(?:#((?:.|\n|\r)*))?/i, Tt = "".match(/(){0}/)[1] === void 0;
    function Pe(f) {
      var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, p = {}, N = i.iri !== !1 ? _ : $;
      i.reference === "suffix" && (f = (i.scheme ? i.scheme + ":" : "") + "//" + f);
      var S = f.match(Nt);
      if (S) {
        Tt ? (p.scheme = S[1], p.userinfo = S[3], p.host = S[4], p.port = parseInt(S[5], 10), p.path = S[6] || "", p.query = S[7], p.fragment = S[8], isNaN(p.port) && (p.port = S[5])) : (p.scheme = S[1] || void 0, p.userinfo = f.indexOf("@") !== -1 ? S[3] : void 0, p.host = f.indexOf("//") !== -1 ? S[4] : void 0, p.port = parseInt(S[5], 10), p.path = S[6] || "", p.query = f.indexOf("?") !== -1 ? S[7] : void 0, p.fragment = f.indexOf("#") !== -1 ? S[8] : void 0, isNaN(p.port) && (p.port = f.match(/\/\/(?:.|\n)*\:(?:\/|\?|\#|$)/) ? S[4] : void 0)), p.host && (p.host = Me(ce(p.host, N), N)), p.scheme === void 0 && p.userinfo === void 0 && p.host === void 0 && p.port === void 0 && !p.path && p.query === void 0 ? p.reference = "same-document" : p.scheme === void 0 ? p.reference = "relative" : p.fragment === void 0 ? p.reference = "absolute" : p.reference = "uri", i.reference && i.reference !== "suffix" && i.reference !== p.reference && (p.error = p.error || "URI is not a " + i.reference + " reference.");
        var q = I[(i.scheme || p.scheme || "").toLowerCase()];
        if (!i.unicodeSupport && (!q || !q.unicodeSupport)) {
          if (p.host && (i.domainHost || q && q.domainHost))
            try {
              p.host = b.toASCII(p.host.replace(N.PCT_ENCODED, F).toLowerCase());
            } catch (L) {
              p.error = p.error || "Host's domain name can not be converted to ASCII via punycode: " + L;
            }
          G(p, $);
        } else
          G(p, N);
        q && q.parse && q.parse(p, i);
      } else
        p.error = p.error || "URI can not be parsed.";
      return p;
    }
    function Ct(f, i) {
      var p = i.iri !== !1 ? _ : $, N = [];
      return f.userinfo !== void 0 && (N.push(f.userinfo), N.push("@")), f.host !== void 0 && N.push(Me(ce(String(f.host), p), p).replace(p.IPV6ADDRESS, function(S, q, L) {
        return "[" + q + (L ? "%25" + L : "") + "]";
      })), (typeof f.port == "number" || typeof f.port == "string") && (N.push(":"), N.push(String(f.port))), N.length ? N.join("") : void 0;
    }
    var dt = /^\.\.?\//, lt = /^\/\.(\/|$)/, ft = /^\/\.\.(\/|$)/, Rt = /^\/?(?:.|\n)*?(?=\/|$)/;
    function Ve(f) {
      for (var i = []; f.length; )
        if (f.match(dt))
          f = f.replace(dt, "");
        else if (f.match(lt))
          f = f.replace(lt, "/");
        else if (f.match(ft))
          f = f.replace(ft, "/"), i.pop();
        else if (f === "." || f === "..")
          f = "";
        else {
          var p = f.match(Rt);
          if (p) {
            var N = p[0];
            f = f.slice(N.length), i.push(N);
          } else
            throw new Error("Unexpected dot segment condition");
        }
      return i.join("");
    }
    function Ee(f) {
      var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, p = i.iri ? _ : $, N = [], S = I[(i.scheme || f.scheme || "").toLowerCase()];
      if (S && S.serialize && S.serialize(f, i), f.host && !p.IPV6ADDRESS.test(f.host)) {
        if (i.domainHost || S && S.domainHost)
          try {
            f.host = i.iri ? b.toUnicode(f.host) : b.toASCII(f.host.replace(p.PCT_ENCODED, F).toLowerCase());
          } catch (ee) {
            f.error = f.error || "Host's domain name can not be converted to " + (i.iri ? "Unicode" : "ASCII") + " via punycode: " + ee;
          }
      }
      G(f, p), i.reference !== "suffix" && f.scheme && (N.push(f.scheme), N.push(":"));
      var q = Ct(f, i);
      if (q !== void 0 && (i.reference !== "suffix" && N.push("//"), N.push(q), f.path && f.path.charAt(0) !== "/" && N.push("/")), f.path !== void 0) {
        var L = f.path;
        !i.absolutePath && (!S || !S.absolutePath) && (L = Ve(L)), q === void 0 && (L = L.replace(/^\/\//, "/%2F")), N.push(L);
      }
      return f.query !== void 0 && (N.push("?"), N.push(f.query)), f.fragment !== void 0 && (N.push("#"), N.push(f.fragment)), N.join("");
    }
    function ht(f, i) {
      var p = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, N = arguments[3], S = {};
      return N || (f = Pe(Ee(f, p), p), i = Pe(Ee(i, p), p)), p = p || {}, !p.tolerant && i.scheme ? (S.scheme = i.scheme, S.userinfo = i.userinfo, S.host = i.host, S.port = i.port, S.path = Ve(i.path || ""), S.query = i.query) : (i.userinfo !== void 0 || i.host !== void 0 || i.port !== void 0 ? (S.userinfo = i.userinfo, S.host = i.host, S.port = i.port, S.path = Ve(i.path || ""), S.query = i.query) : (i.path ? (i.path.charAt(0) === "/" ? S.path = Ve(i.path) : ((f.userinfo !== void 0 || f.host !== void 0 || f.port !== void 0) && !f.path ? S.path = "/" + i.path : f.path ? S.path = f.path.slice(0, f.path.lastIndexOf("/") + 1) + i.path : S.path = i.path, S.path = Ve(S.path)), S.query = i.query) : (S.path = f.path, i.query !== void 0 ? S.query = i.query : S.query = f.query), S.userinfo = f.userinfo, S.host = f.host, S.port = f.port), S.scheme = f.scheme), S.fragment = i.fragment, S;
    }
    function jt(f, i, p) {
      var N = y({ scheme: "null" }, p);
      return Ee(ht(Pe(f, N), Pe(i, N), N, !0), N);
    }
    function et(f, i) {
      return typeof f == "string" ? f = Ee(Pe(f, i), i) : o(f) === "object" && (f = Pe(Ee(f, i), i)), f;
    }
    function It(f, i, p) {
      return typeof f == "string" ? f = Ee(Pe(f, p), p) : o(f) === "object" && (f = Ee(f, p)), typeof i == "string" ? i = Ee(Pe(i, p), p) : o(i) === "object" && (i = Ee(i, p)), f === i;
    }
    function Bt(f, i) {
      return f && f.toString().replace(!i || !i.iri ? $.ESCAPE : _.ESCAPE, j);
    }
    function Oe(f, i) {
      return f && f.toString().replace(!i || !i.iri ? $.PCT_ENCODED : _.PCT_ENCODED, F);
    }
    var tt = {
      scheme: "http",
      domainHost: !0,
      parse: function(i, p) {
        return i.host || (i.error = i.error || "HTTP URIs must have a host."), i;
      },
      serialize: function(i, p) {
        var N = String(i.scheme).toLowerCase() === "https";
        return (i.port === (N ? 443 : 80) || i.port === "") && (i.port = void 0), i.path || (i.path = "/"), i;
      }
    }, Tn = {
      scheme: "https",
      domainHost: tt.domainHost,
      parse: tt.parse,
      serialize: tt.serialize
    };
    function Cn(f) {
      return typeof f.secure == "boolean" ? f.secure : String(f.scheme).toLowerCase() === "wss";
    }
    var kt = {
      scheme: "ws",
      domainHost: !0,
      parse: function(i, p) {
        var N = i;
        return N.secure = Cn(N), N.resourceName = (N.path || "/") + (N.query ? "?" + N.query : ""), N.path = void 0, N.query = void 0, N;
      },
      serialize: function(i, p) {
        if ((i.port === (Cn(i) ? 443 : 80) || i.port === "") && (i.port = void 0), typeof i.secure == "boolean" && (i.scheme = i.secure ? "wss" : "ws", i.secure = void 0), i.resourceName) {
          var N = i.resourceName.split("?"), S = C(N, 2), q = S[0], L = S[1];
          i.path = q && q !== "/" ? q : void 0, i.query = L, i.resourceName = void 0;
        }
        return i.fragment = void 0, i;
      }
    }, Rn = {
      scheme: "wss",
      domainHost: kt.domainHost,
      parse: kt.parse,
      serialize: kt.serialize
    }, ts = {}, jn = "[A-Za-z0-9\\-\\.\\_\\~\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]", Fe = "[0-9A-Fa-f]", rs = a(a("%[EFef]" + Fe + "%" + Fe + Fe + "%" + Fe + Fe) + "|" + a("%[89A-Fa-f]" + Fe + "%" + Fe + Fe) + "|" + a("%" + Fe + Fe)), ns = "[A-Za-z0-9\\!\\$\\%\\'\\*\\+\\-\\^\\_\\`\\{\\|\\}\\~]", as = "[\\!\\$\\%\\'\\(\\)\\*\\+\\,\\-\\.0-9\\<\\>A-Z\\x5E-\\x7E]", ss = n(as, '[\\"\\\\]'), os = "[\\!\\$\\'\\(\\)\\*\\+\\,\\;\\:\\@]", is = new RegExp(jn, "g"), mt = new RegExp(rs, "g"), cs = new RegExp(n("[^]", ns, "[\\.]", '[\\"]', ss), "g"), In = new RegExp(n("[^]", jn, os), "g"), us = In;
    function _r(f) {
      var i = F(f);
      return i.match(is) ? i : f;
    }
    var kn = {
      scheme: "mailto",
      parse: function(i, p) {
        var N = i, S = N.to = N.path ? N.path.split(",") : [];
        if (N.path = void 0, N.query) {
          for (var q = !1, L = {}, ee = N.query.split("&"), oe = 0, fe = ee.length; oe < fe; ++oe) {
            var x = ee[oe].split("=");
            switch (x[0]) {
              case "to":
                for (var se = x[1].split(","), he = 0, W = se.length; he < W; ++he)
                  S.push(se[he]);
                break;
              case "subject":
                N.subject = Oe(x[1], p);
                break;
              case "body":
                N.body = Oe(x[1], p);
                break;
              default:
                q = !0, L[Oe(x[0], p)] = Oe(x[1], p);
                break;
            }
          }
          q && (N.headers = L);
        }
        N.query = void 0;
        for (var ue = 0, pe = S.length; ue < pe; ++ue) {
          var de = S[ue].split("@");
          if (de[0] = Oe(de[0]), p.unicodeSupport)
            de[1] = Oe(de[1], p).toLowerCase();
          else
            try {
              de[1] = b.toASCII(Oe(de[1], p).toLowerCase());
            } catch (Be) {
              N.error = N.error || "Email address's domain name can not be converted to ASCII via punycode: " + Be;
            }
          S[ue] = de.join("@");
        }
        return N;
      },
      serialize: function(i, p) {
        var N = i, S = d(i.to);
        if (S) {
          for (var q = 0, L = S.length; q < L; ++q) {
            var ee = String(S[q]), oe = ee.lastIndexOf("@"), fe = ee.slice(0, oe).replace(mt, _r).replace(mt, c).replace(cs, j), x = ee.slice(oe + 1);
            try {
              x = p.iri ? b.toUnicode(x) : b.toASCII(Oe(x, p).toLowerCase());
            } catch (ue) {
              N.error = N.error || "Email address's domain name can not be converted to " + (p.iri ? "Unicode" : "ASCII") + " via punycode: " + ue;
            }
            S[q] = fe + "@" + x;
          }
          N.path = S.join(",");
        }
        var se = i.headers = i.headers || {};
        i.subject && (se.subject = i.subject), i.body && (se.body = i.body);
        var he = [];
        for (var W in se)
          se[W] !== ts[W] && he.push(W.replace(mt, _r).replace(mt, c).replace(In, j) + "=" + se[W].replace(mt, _r).replace(mt, c).replace(us, j));
        return he.length && (N.query = he.join("&")), N;
      }
    }, ds = /^([^\:]+)\:(.*)/, Dn = {
      scheme: "urn",
      parse: function(i, p) {
        var N = i.path && i.path.match(ds), S = i;
        if (N) {
          var q = p.scheme || S.scheme || "urn", L = N[1].toLowerCase(), ee = N[2], oe = q + ":" + (p.nid || L), fe = I[oe];
          S.nid = L, S.nss = ee, S.path = void 0, fe && (S = fe.parse(S, p));
        } else
          S.error = S.error || "URN can not be parsed.";
        return S;
      },
      serialize: function(i, p) {
        var N = p.scheme || i.scheme || "urn", S = i.nid, q = N + ":" + (p.nid || S), L = I[q];
        L && (i = L.serialize(i, p));
        var ee = i, oe = i.nss;
        return ee.path = (S || p.nid) + ":" + oe, ee;
      }
    }, ls = /^[0-9A-Fa-f]{8}(?:\-[0-9A-Fa-f]{4}){3}\-[0-9A-Fa-f]{12}$/, An = {
      scheme: "urn:uuid",
      parse: function(i, p) {
        var N = i;
        return N.uuid = N.nss, N.nss = void 0, !p.tolerant && (!N.uuid || !N.uuid.match(ls)) && (N.error = N.error || "UUID is not valid."), N;
      },
      serialize: function(i, p) {
        var N = i;
        return N.nss = (i.uuid || "").toLowerCase(), N;
      }
    };
    I[tt.scheme] = tt, I[Tn.scheme] = Tn, I[kt.scheme] = kt, I[Rn.scheme] = Rn, I[kn.scheme] = kn, I[Dn.scheme] = Dn, I[An.scheme] = An, r.SCHEMES = I, r.pctEncChar = j, r.pctDecChars = F, r.parse = Pe, r.removeDotSegments = Ve, r.serialize = Ee, r.resolveComponents = ht, r.resolve = jt, r.normalize = et, r.equal = It, r.escapeComponent = Bt, r.unescapeComponent = Oe, Object.defineProperty(r, "__esModule", { value: !0 });
  });
})(jr, jr.exports);
var vi = jr.exports;
Object.defineProperty(Br, "__esModule", { value: !0 });
const Ha = vi;
Ha.code = 'require("ajv/dist/runtime/uri").default';
Br.default = Ha;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.CodeGen = e.Name = e.nil = e.stringify = e.str = e._ = e.KeywordCxt = void 0;
  var t = Ce;
  Object.defineProperty(e, "KeywordCxt", { enumerable: !0, get: function() {
    return t.KeywordCxt;
  } });
  var r = X;
  Object.defineProperty(e, "_", { enumerable: !0, get: function() {
    return r._;
  } }), Object.defineProperty(e, "str", { enumerable: !0, get: function() {
    return r.str;
  } }), Object.defineProperty(e, "stringify", { enumerable: !0, get: function() {
    return r.stringify;
  } }), Object.defineProperty(e, "nil", { enumerable: !0, get: function() {
    return r.nil;
  } }), Object.defineProperty(e, "Name", { enumerable: !0, get: function() {
    return r.Name;
  } }), Object.defineProperty(e, "CodeGen", { enumerable: !0, get: function() {
    return r.CodeGen;
  } });
  const n = Gt, a = Jt, o = ct, c = Se, d = X, y = ve, l = $e, $ = V, _ = yi, C = Br, T = (D, w) => new RegExp(D, w);
  T.code = "new RegExp";
  const P = ["removeAdditional", "useDefaults", "coerceTypes"], O = /* @__PURE__ */ new Set([
    "validate",
    "serialize",
    "parse",
    "wrapper",
    "root",
    "schema",
    "keyword",
    "pattern",
    "formats",
    "validate$data",
    "func",
    "obj",
    "Error"
  ]), g = {
    errorDataPath: "",
    format: "`validateFormats: false` can be used instead.",
    nullable: '"nullable" keyword is supported by default.',
    jsonPointers: "Deprecated jsPropertySyntax can be used instead.",
    extendRefs: "Deprecated ignoreKeywordsWithRef can be used instead.",
    missingRefs: "Pass empty schema with $id that should be ignored to ajv.addSchema.",
    processCode: "Use option `code: {process: (code, schemaEnv: object) => string}`",
    sourceCode: "Use option `code: {source: true}`",
    strictDefaults: "It is default now, see option `strict`.",
    strictKeywords: "It is default now, see option `strict`.",
    uniqueItems: '"uniqueItems" keyword is always validated.',
    unknownFormats: "Disable strict mode or pass `true` to `ajv.addFormat` (or `formats` option).",
    cache: "Map is used as cache, schema object as key.",
    serialize: "Map is used as cache, schema object as key.",
    ajvErrors: "It is default now."
  }, m = {
    ignoreKeywordsWithRef: "",
    jsPropertySyntax: "",
    unicode: '"minLength"/"maxLength" account for unicode characters by default.'
  }, h = 200;
  function R(D) {
    var w, E, v, s, u, b, I, j, F, G, re, ce, Me, Nt, Tt, Pe, Ct, dt, lt, ft, Rt, Ve, Ee, ht, jt;
    const et = D.strict, It = (w = D.code) === null || w === void 0 ? void 0 : w.optimize, Bt = It === !0 || It === void 0 ? 1 : It || 0, Oe = (v = (E = D.code) === null || E === void 0 ? void 0 : E.regExp) !== null && v !== void 0 ? v : T, tt = (s = D.uriResolver) !== null && s !== void 0 ? s : C.default;
    return {
      strictSchema: (b = (u = D.strictSchema) !== null && u !== void 0 ? u : et) !== null && b !== void 0 ? b : !0,
      strictNumbers: (j = (I = D.strictNumbers) !== null && I !== void 0 ? I : et) !== null && j !== void 0 ? j : !0,
      strictTypes: (G = (F = D.strictTypes) !== null && F !== void 0 ? F : et) !== null && G !== void 0 ? G : "log",
      strictTuples: (ce = (re = D.strictTuples) !== null && re !== void 0 ? re : et) !== null && ce !== void 0 ? ce : "log",
      strictRequired: (Nt = (Me = D.strictRequired) !== null && Me !== void 0 ? Me : et) !== null && Nt !== void 0 ? Nt : !1,
      code: D.code ? { ...D.code, optimize: Bt, regExp: Oe } : { optimize: Bt, regExp: Oe },
      loopRequired: (Tt = D.loopRequired) !== null && Tt !== void 0 ? Tt : h,
      loopEnum: (Pe = D.loopEnum) !== null && Pe !== void 0 ? Pe : h,
      meta: (Ct = D.meta) !== null && Ct !== void 0 ? Ct : !0,
      messages: (dt = D.messages) !== null && dt !== void 0 ? dt : !0,
      inlineRefs: (lt = D.inlineRefs) !== null && lt !== void 0 ? lt : !0,
      schemaId: (ft = D.schemaId) !== null && ft !== void 0 ? ft : "$id",
      addUsedSchema: (Rt = D.addUsedSchema) !== null && Rt !== void 0 ? Rt : !0,
      validateSchema: (Ve = D.validateSchema) !== null && Ve !== void 0 ? Ve : !0,
      validateFormats: (Ee = D.validateFormats) !== null && Ee !== void 0 ? Ee : !0,
      unicodeRegExp: (ht = D.unicodeRegExp) !== null && ht !== void 0 ? ht : !0,
      int32range: (jt = D.int32range) !== null && jt !== void 0 ? jt : !0,
      uriResolver: tt
    };
  }
  class k {
    constructor(w = {}) {
      this.schemas = {}, this.refs = {}, this.formats = {}, this._compilations = /* @__PURE__ */ new Set(), this._loading = {}, this._cache = /* @__PURE__ */ new Map(), w = this.opts = { ...w, ...R(w) };
      const { es5: E, lines: v } = this.opts.code;
      this.scope = new d.ValueScope({ scope: {}, prefixes: O, es5: E, lines: v }), this.logger = H(w.logger);
      const s = w.validateFormats;
      w.validateFormats = !1, this.RULES = (0, o.getRules)(), A.call(this, g, w, "NOT SUPPORTED"), A.call(this, m, w, "DEPRECATED", "warn"), this._metaOpts = z.call(this), w.formats && K.call(this), this._addVocabularies(), this._addDefaultMetaSchema(), w.keywords && M.call(this, w.keywords), typeof w.meta == "object" && this.addMetaSchema(w.meta), te.call(this), w.validateFormats = s;
    }
    _addVocabularies() {
      this.addKeyword("$async");
    }
    _addDefaultMetaSchema() {
      const { $data: w, meta: E, schemaId: v } = this.opts;
      let s = _;
      v === "id" && (s = { ..._ }, s.id = s.$id, delete s.$id), E && w && this.addMetaSchema(s, s[v], !1);
    }
    defaultMeta() {
      const { meta: w, schemaId: E } = this.opts;
      return this.opts.defaultMeta = typeof w == "object" ? w[E] || w : void 0;
    }
    validate(w, E) {
      let v;
      if (typeof w == "string") {
        if (v = this.getSchema(w), !v)
          throw new Error(`no schema with key or ref "${w}"`);
      } else
        v = this.compile(w);
      const s = v(E);
      return "$async" in v || (this.errors = v.errors), s;
    }
    compile(w, E) {
      const v = this._addSchema(w, E);
      return v.validate || this._compileSchemaEnv(v);
    }
    compileAsync(w, E) {
      if (typeof this.opts.loadSchema != "function")
        throw new Error("options.loadSchema should be a function");
      const { loadSchema: v } = this.opts;
      return s.call(this, w, E);
      async function s(G, re) {
        await u.call(this, G.$schema);
        const ce = this._addSchema(G, re);
        return ce.validate || b.call(this, ce);
      }
      async function u(G) {
        G && !this.getSchema(G) && await s.call(this, { $ref: G }, !0);
      }
      async function b(G) {
        try {
          return this._compileSchemaEnv(G);
        } catch (re) {
          if (!(re instanceof a.default))
            throw re;
          return I.call(this, re), await j.call(this, re.missingSchema), b.call(this, G);
        }
      }
      function I({ missingSchema: G, missingRef: re }) {
        if (this.refs[G])
          throw new Error(`AnySchema ${G} is loaded but ${re} cannot be resolved`);
      }
      async function j(G) {
        const re = await F.call(this, G);
        this.refs[G] || await u.call(this, re.$schema), this.refs[G] || this.addSchema(re, G, E);
      }
      async function F(G) {
        const re = this._loading[G];
        if (re)
          return re;
        try {
          return await (this._loading[G] = v(G));
        } finally {
          delete this._loading[G];
        }
      }
    }
    // Adds schema to the instance
    addSchema(w, E, v, s = this.opts.validateSchema) {
      if (Array.isArray(w)) {
        for (const b of w)
          this.addSchema(b, void 0, v, s);
        return this;
      }
      let u;
      if (typeof w == "object") {
        const { schemaId: b } = this.opts;
        if (u = w[b], u !== void 0 && typeof u != "string")
          throw new Error(`schema ${b} must be string`);
      }
      return E = (0, y.normalizeId)(E || u), this._checkUnique(E), this.schemas[E] = this._addSchema(w, v, E, s, !0), this;
    }
    // Add schema that will be used to validate other schemas
    // options in META_IGNORE_OPTIONS are alway set to false
    addMetaSchema(w, E, v = this.opts.validateSchema) {
      return this.addSchema(w, E, !0, v), this;
    }
    //  Validate schema against its meta-schema
    validateSchema(w, E) {
      if (typeof w == "boolean")
        return !0;
      let v;
      if (v = w.$schema, v !== void 0 && typeof v != "string")
        throw new Error("$schema must be a string");
      if (v = v || this.opts.defaultMeta || this.defaultMeta(), !v)
        return this.logger.warn("meta-schema not available"), this.errors = null, !0;
      const s = this.validate(v, w);
      if (!s && E) {
        const u = "schema is invalid: " + this.errorsText();
        if (this.opts.validateSchema === "log")
          this.logger.error(u);
        else
          throw new Error(u);
      }
      return s;
    }
    // Get compiled schema by `key` or `ref`.
    // (`key` that was passed to `addSchema` or full schema reference - `schema.$id` or resolved id)
    getSchema(w) {
      let E;
      for (; typeof (E = B.call(this, w)) == "string"; )
        w = E;
      if (E === void 0) {
        const { schemaId: v } = this.opts, s = new c.SchemaEnv({ schema: {}, schemaId: v });
        if (E = c.resolveSchema.call(this, s, w), !E)
          return;
        this.refs[w] = E;
      }
      return E.validate || this._compileSchemaEnv(E);
    }
    // Remove cached schema(s).
    // If no parameter is passed all schemas but meta-schemas are removed.
    // If RegExp is passed all schemas with key/id matching pattern but meta-schemas are removed.
    // Even if schema is referenced by other schemas it still can be removed as other schemas have local references.
    removeSchema(w) {
      if (w instanceof RegExp)
        return this._removeAllSchemas(this.schemas, w), this._removeAllSchemas(this.refs, w), this;
      switch (typeof w) {
        case "undefined":
          return this._removeAllSchemas(this.schemas), this._removeAllSchemas(this.refs), this._cache.clear(), this;
        case "string": {
          const E = B.call(this, w);
          return typeof E == "object" && this._cache.delete(E.schema), delete this.schemas[w], delete this.refs[w], this;
        }
        case "object": {
          const E = w;
          this._cache.delete(E);
          let v = w[this.opts.schemaId];
          return v && (v = (0, y.normalizeId)(v), delete this.schemas[v], delete this.refs[v]), this;
        }
        default:
          throw new Error("ajv.removeSchema: invalid parameter");
      }
    }
    // add "vocabulary" - a collection of keywords
    addVocabulary(w) {
      for (const E of w)
        this.addKeyword(E);
      return this;
    }
    addKeyword(w, E) {
      let v;
      if (typeof w == "string")
        v = w, typeof E == "object" && (this.logger.warn("these parameters are deprecated, see docs for addKeyword"), E.keyword = v);
      else if (typeof w == "object" && E === void 0) {
        if (E = w, v = E.keyword, Array.isArray(v) && !v.length)
          throw new Error("addKeywords: keyword must be string or non-empty array");
      } else
        throw new Error("invalid addKeywords parameters");
      if (le.call(this, v, E), !E)
        return (0, $.eachItem)(v, (u) => we.call(this, u)), this;
      We.call(this, E);
      const s = {
        ...E,
        type: (0, l.getJSONTypes)(E.type),
        schemaType: (0, l.getJSONTypes)(E.schemaType)
      };
      return (0, $.eachItem)(v, s.type.length === 0 ? (u) => we.call(this, u, s) : (u) => s.type.forEach((b) => we.call(this, u, s, b))), this;
    }
    getKeyword(w) {
      const E = this.RULES.all[w];
      return typeof E == "object" ? E.definition : !!E;
    }
    // Remove keyword
    removeKeyword(w) {
      const { RULES: E } = this;
      delete E.keywords[w], delete E.all[w];
      for (const v of E.rules) {
        const s = v.rules.findIndex((u) => u.keyword === w);
        s >= 0 && v.rules.splice(s, 1);
      }
      return this;
    }
    // Add format
    addFormat(w, E) {
      return typeof E == "string" && (E = new RegExp(E)), this.formats[w] = E, this;
    }
    errorsText(w = this.errors, { separator: E = ", ", dataVar: v = "data" } = {}) {
      return !w || w.length === 0 ? "No errors" : w.map((s) => `${v}${s.instancePath} ${s.message}`).reduce((s, u) => s + E + u);
    }
    $dataMetaSchema(w, E) {
      const v = this.RULES.all;
      w = JSON.parse(JSON.stringify(w));
      for (const s of E) {
        const u = s.split("/").slice(1);
        let b = w;
        for (const I of u)
          b = b[I];
        for (const I in v) {
          const j = v[I];
          if (typeof j != "object")
            continue;
          const { $data: F } = j.definition, G = b[I];
          F && G && (b[I] = Ae(G));
        }
      }
      return w;
    }
    _removeAllSchemas(w, E) {
      for (const v in w) {
        const s = w[v];
        (!E || E.test(v)) && (typeof s == "string" ? delete w[v] : s && !s.meta && (this._cache.delete(s.schema), delete w[v]));
      }
    }
    _addSchema(w, E, v, s = this.opts.validateSchema, u = this.opts.addUsedSchema) {
      let b;
      const { schemaId: I } = this.opts;
      if (typeof w == "object")
        b = w[I];
      else {
        if (this.opts.jtd)
          throw new Error("schema must be object");
        if (typeof w != "boolean")
          throw new Error("schema must be object or boolean");
      }
      let j = this._cache.get(w);
      if (j !== void 0)
        return j;
      v = (0, y.normalizeId)(b || v);
      const F = y.getSchemaRefs.call(this, w, v);
      return j = new c.SchemaEnv({ schema: w, schemaId: I, meta: E, baseId: v, localRefs: F }), this._cache.set(j.schema, j), u && !v.startsWith("#") && (v && this._checkUnique(v), this.refs[v] = j), s && this.validateSchema(w, !0), j;
    }
    _checkUnique(w) {
      if (this.schemas[w] || this.refs[w])
        throw new Error(`schema with key or id "${w}" already exists`);
    }
    _compileSchemaEnv(w) {
      if (w.meta ? this._compileMetaSchema(w) : c.compileSchema.call(this, w), !w.validate)
        throw new Error("ajv implementation error");
      return w.validate;
    }
    _compileMetaSchema(w) {
      const E = this.opts;
      this.opts = this._metaOpts;
      try {
        c.compileSchema.call(this, w);
      } finally {
        this.opts = E;
      }
    }
  }
  k.ValidationError = n.default, k.MissingRefError = a.default, e.default = k;
  function A(D, w, E, v = "error") {
    for (const s in D) {
      const u = s;
      u in w && this.logger[v](`${E}: option ${s}. ${D[u]}`);
    }
  }
  function B(D) {
    return D = (0, y.normalizeId)(D), this.schemas[D] || this.refs[D];
  }
  function te() {
    const D = this.opts.schemas;
    if (D)
      if (Array.isArray(D))
        this.addSchema(D);
      else
        for (const w in D)
          this.addSchema(D[w], w);
  }
  function K() {
    for (const D in this.opts.formats) {
      const w = this.opts.formats[D];
      w && this.addFormat(D, w);
    }
  }
  function M(D) {
    if (Array.isArray(D)) {
      this.addVocabulary(D);
      return;
    }
    this.logger.warn("keywords option as map is deprecated, pass array");
    for (const w in D) {
      const E = D[w];
      E.keyword || (E.keyword = w), this.addKeyword(E);
    }
  }
  function z() {
    const D = { ...this.opts };
    for (const w of P)
      delete D[w];
    return D;
  }
  const Q = { log() {
  }, warn() {
  }, error() {
  } };
  function H(D) {
    if (D === !1)
      return Q;
    if (D === void 0)
      return console;
    if (D.log && D.warn && D.error)
      return D;
    throw new Error("logger must implement log, warn and error methods");
  }
  const ae = /^[a-z_$][a-z0-9_$:-]*$/i;
  function le(D, w) {
    const { RULES: E } = this;
    if ((0, $.eachItem)(D, (v) => {
      if (E.keywords[v])
        throw new Error(`Keyword ${v} is already defined`);
      if (!ae.test(v))
        throw new Error(`Keyword ${v} has invalid name`);
    }), !!w && w.$data && !("code" in w || "validate" in w))
      throw new Error('$data keyword must have "code" or "validate" function');
  }
  function we(D, w, E) {
    var v;
    const s = w == null ? void 0 : w.post;
    if (E && s)
      throw new Error('keyword with "post" flag cannot have "type"');
    const { RULES: u } = this;
    let b = s ? u.post : u.rules.find(({ type: j }) => j === E);
    if (b || (b = { type: E, rules: [] }, u.rules.push(b)), u.keywords[D] = !0, !w)
      return;
    const I = {
      keyword: D,
      definition: {
        ...w,
        type: (0, l.getJSONTypes)(w.type),
        schemaType: (0, l.getJSONTypes)(w.schemaType)
      }
    };
    w.before ? De.call(this, b, I, w.before) : b.rules.push(I), u.all[D] = I, (v = w.implements) === null || v === void 0 || v.forEach((j) => this.addKeyword(j));
  }
  function De(D, w, E) {
    const v = D.rules.findIndex((s) => s.keyword === E);
    v >= 0 ? D.rules.splice(v, 0, w) : (D.rules.push(w), this.logger.warn(`rule ${E} is not defined`));
  }
  function We(D) {
    let { metaSchema: w } = D;
    w !== void 0 && (D.$data && this.opts.$data && (w = Ae(w)), D.validateSchema = this.compile(w, !0));
  }
  const xe = {
    $ref: "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#"
  };
  function Ae(D) {
    return { anyOf: [D, xe] };
  }
})(la);
var Yr = {}, Xr = {}, Qr = {};
Object.defineProperty(Qr, "__esModule", { value: !0 });
const _i = {
  keyword: "id",
  code() {
    throw new Error('NOT SUPPORTED: keyword "id", use "$id" for schema ID');
  }
};
Qr.default = _i;
var ut = {};
Object.defineProperty(ut, "__esModule", { value: !0 });
ut.callRef = ut.getValidate = void 0;
const gi = Jt, Qn = Z, be = X, yt = ke, Zn = Se, xt = V, wi = {
  keyword: "$ref",
  schemaType: "string",
  code(e) {
    const { gen: t, schema: r, it: n } = e, { baseId: a, schemaEnv: o, validateName: c, opts: d, self: y } = n, { root: l } = o;
    if ((r === "#" || r === "#/") && a === l.baseId)
      return _();
    const $ = Zn.resolveRef.call(y, l, a, r);
    if ($ === void 0)
      throw new gi.default(n.opts.uriResolver, a, r);
    if ($ instanceof Zn.SchemaEnv)
      return C($);
    return T($);
    function _() {
      if (o === l)
        return or(e, c, o, o.$async);
      const P = t.scopeValue("root", { ref: l });
      return or(e, (0, be._)`${P}.validate`, l, l.$async);
    }
    function C(P) {
      const O = Ga(e, P);
      or(e, O, P, P.$async);
    }
    function T(P) {
      const O = t.scopeValue("schema", d.code.source === !0 ? { ref: P, code: (0, be.stringify)(P) } : { ref: P }), g = t.name("valid"), m = e.subschema({
        schema: P,
        dataTypes: [],
        schemaPath: be.nil,
        topSchemaRef: O,
        errSchemaPath: r
      }, g);
      e.mergeEvaluated(m), e.ok(g);
    }
  }
};
function Ga(e, t) {
  const { gen: r } = e;
  return t.validate ? r.scopeValue("validate", { ref: t.validate }) : (0, be._)`${r.scopeValue("wrapper", { ref: t })}.validate`;
}
ut.getValidate = Ga;
function or(e, t, r, n) {
  const { gen: a, it: o } = e, { allErrors: c, schemaEnv: d, opts: y } = o, l = y.passContext ? yt.default.this : be.nil;
  n ? $() : _();
  function $() {
    if (!d.$async)
      throw new Error("async schema referenced by sync schema");
    const P = a.let("valid");
    a.try(() => {
      a.code((0, be._)`await ${(0, Qn.callValidateCode)(e, t, l)}`), T(t), c || a.assign(P, !0);
    }, (O) => {
      a.if((0, be._)`!(${O} instanceof ${o.ValidationError})`, () => a.throw(O)), C(O), c || a.assign(P, !1);
    }), e.ok(P);
  }
  function _() {
    e.result((0, Qn.callValidateCode)(e, t, l), () => T(t), () => C(t));
  }
  function C(P) {
    const O = (0, be._)`${P}.errors`;
    a.assign(yt.default.vErrors, (0, be._)`${yt.default.vErrors} === null ? ${O} : ${yt.default.vErrors}.concat(${O})`), a.assign(yt.default.errors, (0, be._)`${yt.default.vErrors}.length`);
  }
  function T(P) {
    var O;
    if (!o.opts.unevaluated)
      return;
    const g = (O = r == null ? void 0 : r.validate) === null || O === void 0 ? void 0 : O.evaluated;
    if (o.props !== !0)
      if (g && !g.dynamicProps)
        g.props !== void 0 && (o.props = xt.mergeEvaluated.props(a, g.props, o.props));
      else {
        const m = a.var("props", (0, be._)`${P}.evaluated.props`);
        o.props = xt.mergeEvaluated.props(a, m, o.props, be.Name);
      }
    if (o.items !== !0)
      if (g && !g.dynamicItems)
        g.items !== void 0 && (o.items = xt.mergeEvaluated.items(a, g.items, o.items));
      else {
        const m = a.var("items", (0, be._)`${P}.evaluated.items`);
        o.items = xt.mergeEvaluated.items(a, m, o.items, be.Name);
      }
  }
}
ut.callRef = or;
ut.default = wi;
Object.defineProperty(Xr, "__esModule", { value: !0 });
const Ei = Qr, bi = ut, Si = [
  "$schema",
  "$id",
  "$defs",
  "$vocabulary",
  { keyword: "$comment" },
  "definitions",
  Ei.default,
  bi.default
];
Xr.default = Si;
var Zr = {}, xr = {};
Object.defineProperty(xr, "__esModule", { value: !0 });
const dr = X, Xe = dr.operators, lr = {
  maximum: { okStr: "<=", ok: Xe.LTE, fail: Xe.GT },
  minimum: { okStr: ">=", ok: Xe.GTE, fail: Xe.LT },
  exclusiveMaximum: { okStr: "<", ok: Xe.LT, fail: Xe.GTE },
  exclusiveMinimum: { okStr: ">", ok: Xe.GT, fail: Xe.LTE }
}, Pi = {
  message: ({ keyword: e, schemaCode: t }) => (0, dr.str)`must be ${lr[e].okStr} ${t}`,
  params: ({ keyword: e, schemaCode: t }) => (0, dr._)`{comparison: ${lr[e].okStr}, limit: ${t}}`
}, Oi = {
  keyword: Object.keys(lr),
  type: "number",
  schemaType: "number",
  $data: !0,
  error: Pi,
  code(e) {
    const { keyword: t, data: r, schemaCode: n } = e;
    e.fail$data((0, dr._)`${r} ${lr[t].fail} ${n} || isNaN(${r})`);
  }
};
xr.default = Oi;
var en = {};
Object.defineProperty(en, "__esModule", { value: !0 });
const qt = X, Ni = {
  message: ({ schemaCode: e }) => (0, qt.str)`must be multiple of ${e}`,
  params: ({ schemaCode: e }) => (0, qt._)`{multipleOf: ${e}}`
}, Ti = {
  keyword: "multipleOf",
  type: "number",
  schemaType: "number",
  $data: !0,
  error: Ni,
  code(e) {
    const { gen: t, data: r, schemaCode: n, it: a } = e, o = a.opts.multipleOfPrecision, c = t.let("res"), d = o ? (0, qt._)`Math.abs(Math.round(${c}) - ${c}) > 1e-${o}` : (0, qt._)`${c} !== parseInt(${c})`;
    e.fail$data((0, qt._)`(${n} === 0 || (${c} = ${r}/${n}, ${d}))`);
  }
};
en.default = Ti;
var tn = {}, rn = {};
Object.defineProperty(rn, "__esModule", { value: !0 });
function Ja(e) {
  const t = e.length;
  let r = 0, n = 0, a;
  for (; n < t; )
    r++, a = e.charCodeAt(n++), a >= 55296 && a <= 56319 && n < t && (a = e.charCodeAt(n), (a & 64512) === 56320 && n++);
  return r;
}
rn.default = Ja;
Ja.code = 'require("ajv/dist/runtime/ucs2length").default';
Object.defineProperty(tn, "__esModule", { value: !0 });
const ot = X, Ci = V, Ri = rn, ji = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxLength" ? "more" : "fewer";
    return (0, ot.str)`must NOT have ${r} than ${t} characters`;
  },
  params: ({ schemaCode: e }) => (0, ot._)`{limit: ${e}}`
}, Ii = {
  keyword: ["maxLength", "minLength"],
  type: "string",
  schemaType: "number",
  $data: !0,
  error: ji,
  code(e) {
    const { keyword: t, data: r, schemaCode: n, it: a } = e, o = t === "maxLength" ? ot.operators.GT : ot.operators.LT, c = a.opts.unicode === !1 ? (0, ot._)`${r}.length` : (0, ot._)`${(0, Ci.useFunc)(e.gen, Ri.default)}(${r})`;
    e.fail$data((0, ot._)`${c} ${o} ${n}`);
  }
};
tn.default = Ii;
var nn = {};
Object.defineProperty(nn, "__esModule", { value: !0 });
const ki = Z, fr = X, Di = {
  message: ({ schemaCode: e }) => (0, fr.str)`must match pattern "${e}"`,
  params: ({ schemaCode: e }) => (0, fr._)`{pattern: ${e}}`
}, Ai = {
  keyword: "pattern",
  type: "string",
  schemaType: "string",
  $data: !0,
  error: Di,
  code(e) {
    const { data: t, $data: r, schema: n, schemaCode: a, it: o } = e, c = o.opts.unicodeRegExp ? "u" : "", d = r ? (0, fr._)`(new RegExp(${a}, ${c}))` : (0, ki.usePattern)(e, n);
    e.fail$data((0, fr._)`!${d}.test(${t})`);
  }
};
nn.default = Ai;
var an = {};
Object.defineProperty(an, "__esModule", { value: !0 });
const Kt = X, Mi = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxProperties" ? "more" : "fewer";
    return (0, Kt.str)`must NOT have ${r} than ${t} properties`;
  },
  params: ({ schemaCode: e }) => (0, Kt._)`{limit: ${e}}`
}, Vi = {
  keyword: ["maxProperties", "minProperties"],
  type: "object",
  schemaType: "number",
  $data: !0,
  error: Mi,
  code(e) {
    const { keyword: t, data: r, schemaCode: n } = e, a = t === "maxProperties" ? Kt.operators.GT : Kt.operators.LT;
    e.fail$data((0, Kt._)`Object.keys(${r}).length ${a} ${n}`);
  }
};
an.default = Vi;
var sn = {};
Object.defineProperty(sn, "__esModule", { value: !0 });
const Ft = Z, Lt = X, Fi = V, zi = {
  message: ({ params: { missingProperty: e } }) => (0, Lt.str)`must have required property '${e}'`,
  params: ({ params: { missingProperty: e } }) => (0, Lt._)`{missingProperty: ${e}}`
}, Ui = {
  keyword: "required",
  type: "object",
  schemaType: "array",
  $data: !0,
  error: zi,
  code(e) {
    const { gen: t, schema: r, schemaCode: n, data: a, $data: o, it: c } = e, { opts: d } = c;
    if (!o && r.length === 0)
      return;
    const y = r.length >= d.loopRequired;
    if (c.allErrors ? l() : $(), d.strictRequired) {
      const T = e.parentSchema.properties, { definedProperties: P } = e.it;
      for (const O of r)
        if ((T == null ? void 0 : T[O]) === void 0 && !P.has(O)) {
          const g = c.schemaEnv.baseId + c.errSchemaPath, m = `required property "${O}" is not defined at "${g}" (strictRequired)`;
          (0, Fi.checkStrictMode)(c, m, c.opts.strictRequired);
        }
    }
    function l() {
      if (y || o)
        e.block$data(Lt.nil, _);
      else
        for (const T of r)
          (0, Ft.checkReportMissingProp)(e, T);
    }
    function $() {
      const T = t.let("missing");
      if (y || o) {
        const P = t.let("valid", !0);
        e.block$data(P, () => C(T, P)), e.ok(P);
      } else
        t.if((0, Ft.checkMissingProp)(e, r, T)), (0, Ft.reportMissingProp)(e, T), t.else();
    }
    function _() {
      t.forOf("prop", n, (T) => {
        e.setParams({ missingProperty: T }), t.if((0, Ft.noPropertyInData)(t, a, T, d.ownProperties), () => e.error());
      });
    }
    function C(T, P) {
      e.setParams({ missingProperty: T }), t.forOf(T, n, () => {
        t.assign(P, (0, Ft.propertyInData)(t, a, T, d.ownProperties)), t.if((0, Lt.not)(P), () => {
          e.error(), t.break();
        });
      }, Lt.nil);
    }
  }
};
sn.default = Ui;
var on = {};
Object.defineProperty(on, "__esModule", { value: !0 });
const Ht = X, qi = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxItems" ? "more" : "fewer";
    return (0, Ht.str)`must NOT have ${r} than ${t} items`;
  },
  params: ({ schemaCode: e }) => (0, Ht._)`{limit: ${e}}`
}, Ki = {
  keyword: ["maxItems", "minItems"],
  type: "array",
  schemaType: "number",
  $data: !0,
  error: qi,
  code(e) {
    const { keyword: t, data: r, schemaCode: n } = e, a = t === "maxItems" ? Ht.operators.GT : Ht.operators.LT;
    e.fail$data((0, Ht._)`${r}.length ${a} ${n}`);
  }
};
on.default = Ki;
var cn = {}, Wt = {};
Object.defineProperty(Wt, "__esModule", { value: !0 });
const Wa = Na;
Wa.code = 'require("ajv/dist/runtime/equal").default';
Wt.default = Wa;
Object.defineProperty(cn, "__esModule", { value: !0 });
const br = $e, ye = X, Li = V, Hi = Wt, Gi = {
  message: ({ params: { i: e, j: t } }) => (0, ye.str)`must NOT have duplicate items (items ## ${t} and ${e} are identical)`,
  params: ({ params: { i: e, j: t } }) => (0, ye._)`{i: ${e}, j: ${t}}`
}, Ji = {
  keyword: "uniqueItems",
  type: "array",
  schemaType: "boolean",
  $data: !0,
  error: Gi,
  code(e) {
    const { gen: t, data: r, $data: n, schema: a, parentSchema: o, schemaCode: c, it: d } = e;
    if (!n && !a)
      return;
    const y = t.let("valid"), l = o.items ? (0, br.getSchemaTypes)(o.items) : [];
    e.block$data(y, $, (0, ye._)`${c} === false`), e.ok(y);
    function $() {
      const P = t.let("i", (0, ye._)`${r}.length`), O = t.let("j");
      e.setParams({ i: P, j: O }), t.assign(y, !0), t.if((0, ye._)`${P} > 1`, () => (_() ? C : T)(P, O));
    }
    function _() {
      return l.length > 0 && !l.some((P) => P === "object" || P === "array");
    }
    function C(P, O) {
      const g = t.name("item"), m = (0, br.checkDataTypes)(l, g, d.opts.strictNumbers, br.DataType.Wrong), h = t.const("indices", (0, ye._)`{}`);
      t.for((0, ye._)`;${P}--;`, () => {
        t.let(g, (0, ye._)`${r}[${P}]`), t.if(m, (0, ye._)`continue`), l.length > 1 && t.if((0, ye._)`typeof ${g} == "string"`, (0, ye._)`${g} += "_"`), t.if((0, ye._)`typeof ${h}[${g}] == "number"`, () => {
          t.assign(O, (0, ye._)`${h}[${g}]`), e.error(), t.assign(y, !1).break();
        }).code((0, ye._)`${h}[${g}] = ${P}`);
      });
    }
    function T(P, O) {
      const g = (0, Li.useFunc)(t, Hi.default), m = t.name("outer");
      t.label(m).for((0, ye._)`;${P}--;`, () => t.for((0, ye._)`${O} = ${P}; ${O}--;`, () => t.if((0, ye._)`${g}(${r}[${P}], ${r}[${O}])`, () => {
        e.error(), t.assign(y, !1).break(m);
      })));
    }
  }
};
cn.default = Ji;
var un = {};
Object.defineProperty(un, "__esModule", { value: !0 });
const Ir = X, Wi = V, Bi = Wt, Yi = {
  message: "must be equal to constant",
  params: ({ schemaCode: e }) => (0, Ir._)`{allowedValue: ${e}}`
}, Xi = {
  keyword: "const",
  $data: !0,
  error: Yi,
  code(e) {
    const { gen: t, data: r, $data: n, schemaCode: a, schema: o } = e;
    n || o && typeof o == "object" ? e.fail$data((0, Ir._)`!${(0, Wi.useFunc)(t, Bi.default)}(${r}, ${a})`) : e.fail((0, Ir._)`${o} !== ${r}`);
  }
};
un.default = Xi;
var dn = {};
Object.defineProperty(dn, "__esModule", { value: !0 });
const zt = X, Qi = V, Zi = Wt, xi = {
  message: "must be equal to one of the allowed values",
  params: ({ schemaCode: e }) => (0, zt._)`{allowedValues: ${e}}`
}, ec = {
  keyword: "enum",
  schemaType: "array",
  $data: !0,
  error: xi,
  code(e) {
    const { gen: t, data: r, $data: n, schema: a, schemaCode: o, it: c } = e;
    if (!n && a.length === 0)
      throw new Error("enum must have non-empty array");
    const d = a.length >= c.opts.loopEnum;
    let y;
    const l = () => y ?? (y = (0, Qi.useFunc)(t, Zi.default));
    let $;
    if (d || n)
      $ = t.let("valid"), e.block$data($, _);
    else {
      if (!Array.isArray(a))
        throw new Error("ajv implementation error");
      const T = t.const("vSchema", o);
      $ = (0, zt.or)(...a.map((P, O) => C(T, O)));
    }
    e.pass($);
    function _() {
      t.assign($, !1), t.forOf("v", o, (T) => t.if((0, zt._)`${l()}(${r}, ${T})`, () => t.assign($, !0).break()));
    }
    function C(T, P) {
      const O = a[P];
      return typeof O == "object" && O !== null ? (0, zt._)`${l()}(${r}, ${T}[${P}])` : (0, zt._)`${r} === ${O}`;
    }
  }
};
dn.default = ec;
Object.defineProperty(Zr, "__esModule", { value: !0 });
const tc = xr, rc = en, nc = tn, ac = nn, sc = an, oc = sn, ic = on, cc = cn, uc = un, dc = dn, lc = [
  // number
  tc.default,
  rc.default,
  // string
  nc.default,
  ac.default,
  // object
  sc.default,
  oc.default,
  // array
  ic.default,
  cc.default,
  // any
  { keyword: "type", schemaType: ["string", "array"] },
  { keyword: "nullable", schemaType: "boolean" },
  uc.default,
  dc.default
];
Zr.default = lc;
var ln = {}, Pt = {};
Object.defineProperty(Pt, "__esModule", { value: !0 });
Pt.validateAdditionalItems = void 0;
const it = X, kr = V, fc = {
  message: ({ params: { len: e } }) => (0, it.str)`must NOT have more than ${e} items`,
  params: ({ params: { len: e } }) => (0, it._)`{limit: ${e}}`
}, hc = {
  keyword: "additionalItems",
  type: "array",
  schemaType: ["boolean", "object"],
  before: "uniqueItems",
  error: fc,
  code(e) {
    const { parentSchema: t, it: r } = e, { items: n } = t;
    if (!Array.isArray(n)) {
      (0, kr.checkStrictMode)(r, '"additionalItems" is ignored when "items" is not an array of schemas');
      return;
    }
    Ba(e, n);
  }
};
function Ba(e, t) {
  const { gen: r, schema: n, data: a, keyword: o, it: c } = e;
  c.items = !0;
  const d = r.const("len", (0, it._)`${a}.length`);
  if (n === !1)
    e.setParams({ len: t.length }), e.pass((0, it._)`${d} <= ${t.length}`);
  else if (typeof n == "object" && !(0, kr.alwaysValidSchema)(c, n)) {
    const l = r.var("valid", (0, it._)`${d} <= ${t.length}`);
    r.if((0, it.not)(l), () => y(l)), e.ok(l);
  }
  function y(l) {
    r.forRange("i", t.length, d, ($) => {
      e.subschema({ keyword: o, dataProp: $, dataPropType: kr.Type.Num }, l), c.allErrors || r.if((0, it.not)(l), () => r.break());
    });
  }
}
Pt.validateAdditionalItems = Ba;
Pt.default = hc;
var fn = {}, Ot = {};
Object.defineProperty(Ot, "__esModule", { value: !0 });
Ot.validateTuple = void 0;
const xn = X, ir = V, mc = Z, pc = {
  keyword: "items",
  type: "array",
  schemaType: ["object", "array", "boolean"],
  before: "uniqueItems",
  code(e) {
    const { schema: t, it: r } = e;
    if (Array.isArray(t))
      return Ya(e, "additionalItems", t);
    r.items = !0, !(0, ir.alwaysValidSchema)(r, t) && e.ok((0, mc.validateArray)(e));
  }
};
function Ya(e, t, r = e.schema) {
  const { gen: n, parentSchema: a, data: o, keyword: c, it: d } = e;
  $(a), d.opts.unevaluated && r.length && d.items !== !0 && (d.items = ir.mergeEvaluated.items(n, r.length, d.items));
  const y = n.name("valid"), l = n.const("len", (0, xn._)`${o}.length`);
  r.forEach((_, C) => {
    (0, ir.alwaysValidSchema)(d, _) || (n.if((0, xn._)`${l} > ${C}`, () => e.subschema({
      keyword: c,
      schemaProp: C,
      dataProp: C
    }, y)), e.ok(y));
  });
  function $(_) {
    const { opts: C, errSchemaPath: T } = d, P = r.length, O = P === _.minItems && (P === _.maxItems || _[t] === !1);
    if (C.strictTuples && !O) {
      const g = `"${c}" is ${P}-tuple, but minItems or maxItems/${t} are not specified or different at path "${T}"`;
      (0, ir.checkStrictMode)(d, g, C.strictTuples);
    }
  }
}
Ot.validateTuple = Ya;
Ot.default = pc;
Object.defineProperty(fn, "__esModule", { value: !0 });
const $c = Ot, yc = {
  keyword: "prefixItems",
  type: "array",
  schemaType: ["array"],
  before: "uniqueItems",
  code: (e) => (0, $c.validateTuple)(e, "items")
};
fn.default = yc;
var hn = {};
Object.defineProperty(hn, "__esModule", { value: !0 });
const ea = X, vc = V, _c = Z, gc = Pt, wc = {
  message: ({ params: { len: e } }) => (0, ea.str)`must NOT have more than ${e} items`,
  params: ({ params: { len: e } }) => (0, ea._)`{limit: ${e}}`
}, Ec = {
  keyword: "items",
  type: "array",
  schemaType: ["object", "boolean"],
  before: "uniqueItems",
  error: wc,
  code(e) {
    const { schema: t, parentSchema: r, it: n } = e, { prefixItems: a } = r;
    n.items = !0, !(0, vc.alwaysValidSchema)(n, t) && (a ? (0, gc.validateAdditionalItems)(e, a) : e.ok((0, _c.validateArray)(e)));
  }
};
hn.default = Ec;
var mn = {};
Object.defineProperty(mn, "__esModule", { value: !0 });
const Te = X, er = V, bc = {
  message: ({ params: { min: e, max: t } }) => t === void 0 ? (0, Te.str)`must contain at least ${e} valid item(s)` : (0, Te.str)`must contain at least ${e} and no more than ${t} valid item(s)`,
  params: ({ params: { min: e, max: t } }) => t === void 0 ? (0, Te._)`{minContains: ${e}}` : (0, Te._)`{minContains: ${e}, maxContains: ${t}}`
}, Sc = {
  keyword: "contains",
  type: "array",
  schemaType: ["object", "boolean"],
  before: "uniqueItems",
  trackErrors: !0,
  error: bc,
  code(e) {
    const { gen: t, schema: r, parentSchema: n, data: a, it: o } = e;
    let c, d;
    const { minContains: y, maxContains: l } = n;
    o.opts.next ? (c = y === void 0 ? 1 : y, d = l) : c = 1;
    const $ = t.const("len", (0, Te._)`${a}.length`);
    if (e.setParams({ min: c, max: d }), d === void 0 && c === 0) {
      (0, er.checkStrictMode)(o, '"minContains" == 0 without "maxContains": "contains" keyword ignored');
      return;
    }
    if (d !== void 0 && c > d) {
      (0, er.checkStrictMode)(o, '"minContains" > "maxContains" is always invalid'), e.fail();
      return;
    }
    if ((0, er.alwaysValidSchema)(o, r)) {
      let O = (0, Te._)`${$} >= ${c}`;
      d !== void 0 && (O = (0, Te._)`${O} && ${$} <= ${d}`), e.pass(O);
      return;
    }
    o.items = !0;
    const _ = t.name("valid");
    d === void 0 && c === 1 ? T(_, () => t.if(_, () => t.break())) : c === 0 ? (t.let(_, !0), d !== void 0 && t.if((0, Te._)`${a}.length > 0`, C)) : (t.let(_, !1), C()), e.result(_, () => e.reset());
    function C() {
      const O = t.name("_valid"), g = t.let("count", 0);
      T(O, () => t.if(O, () => P(g)));
    }
    function T(O, g) {
      t.forRange("i", 0, $, (m) => {
        e.subschema({
          keyword: "contains",
          dataProp: m,
          dataPropType: er.Type.Num,
          compositeRule: !0
        }, O), g();
      });
    }
    function P(O) {
      t.code((0, Te._)`${O}++`), d === void 0 ? t.if((0, Te._)`${O} >= ${c}`, () => t.assign(_, !0).break()) : (t.if((0, Te._)`${O} > ${d}`, () => t.assign(_, !1).break()), c === 1 ? t.assign(_, !0) : t.if((0, Te._)`${O} >= ${c}`, () => t.assign(_, !0)));
    }
  }
};
mn.default = Sc;
var Xa = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.validateSchemaDeps = e.validatePropertyDeps = e.error = void 0;
  const t = X, r = V, n = Z;
  e.error = {
    message: ({ params: { property: y, depsCount: l, deps: $ } }) => {
      const _ = l === 1 ? "property" : "properties";
      return (0, t.str)`must have ${_} ${$} when property ${y} is present`;
    },
    params: ({ params: { property: y, depsCount: l, deps: $, missingProperty: _ } }) => (0, t._)`{property: ${y},
    missingProperty: ${_},
    depsCount: ${l},
    deps: ${$}}`
    // TODO change to reference
  };
  const a = {
    keyword: "dependencies",
    type: "object",
    schemaType: "object",
    error: e.error,
    code(y) {
      const [l, $] = o(y);
      c(y, l), d(y, $);
    }
  };
  function o({ schema: y }) {
    const l = {}, $ = {};
    for (const _ in y) {
      if (_ === "__proto__")
        continue;
      const C = Array.isArray(y[_]) ? l : $;
      C[_] = y[_];
    }
    return [l, $];
  }
  function c(y, l = y.schema) {
    const { gen: $, data: _, it: C } = y;
    if (Object.keys(l).length === 0)
      return;
    const T = $.let("missing");
    for (const P in l) {
      const O = l[P];
      if (O.length === 0)
        continue;
      const g = (0, n.propertyInData)($, _, P, C.opts.ownProperties);
      y.setParams({
        property: P,
        depsCount: O.length,
        deps: O.join(", ")
      }), C.allErrors ? $.if(g, () => {
        for (const m of O)
          (0, n.checkReportMissingProp)(y, m);
      }) : ($.if((0, t._)`${g} && (${(0, n.checkMissingProp)(y, O, T)})`), (0, n.reportMissingProp)(y, T), $.else());
    }
  }
  e.validatePropertyDeps = c;
  function d(y, l = y.schema) {
    const { gen: $, data: _, keyword: C, it: T } = y, P = $.name("valid");
    for (const O in l)
      (0, r.alwaysValidSchema)(T, l[O]) || ($.if(
        (0, n.propertyInData)($, _, O, T.opts.ownProperties),
        () => {
          const g = y.subschema({ keyword: C, schemaProp: O }, P);
          y.mergeValidEvaluated(g, P);
        },
        () => $.var(P, !0)
        // TODO var
      ), y.ok(P));
  }
  e.validateSchemaDeps = d, e.default = a;
})(Xa);
var pn = {};
Object.defineProperty(pn, "__esModule", { value: !0 });
const Qa = X, Pc = V, Oc = {
  message: "property name must be valid",
  params: ({ params: e }) => (0, Qa._)`{propertyName: ${e.propertyName}}`
}, Nc = {
  keyword: "propertyNames",
  type: "object",
  schemaType: ["object", "boolean"],
  error: Oc,
  code(e) {
    const { gen: t, schema: r, data: n, it: a } = e;
    if ((0, Pc.alwaysValidSchema)(a, r))
      return;
    const o = t.name("valid");
    t.forIn("key", n, (c) => {
      e.setParams({ propertyName: c }), e.subschema({
        keyword: "propertyNames",
        data: c,
        dataTypes: ["string"],
        propertyName: c,
        compositeRule: !0
      }, o), t.if((0, Qa.not)(o), () => {
        e.error(!0), a.allErrors || t.break();
      });
    }), e.ok(o);
  }
};
pn.default = Nc;
var yr = {};
Object.defineProperty(yr, "__esModule", { value: !0 });
const tr = Z, je = X, Tc = ke, rr = V, Cc = {
  message: "must NOT have additional properties",
  params: ({ params: e }) => (0, je._)`{additionalProperty: ${e.additionalProperty}}`
}, Rc = {
  keyword: "additionalProperties",
  type: ["object"],
  schemaType: ["boolean", "object"],
  allowUndefined: !0,
  trackErrors: !0,
  error: Cc,
  code(e) {
    const { gen: t, schema: r, parentSchema: n, data: a, errsCount: o, it: c } = e;
    if (!o)
      throw new Error("ajv implementation error");
    const { allErrors: d, opts: y } = c;
    if (c.props = !0, y.removeAdditional !== "all" && (0, rr.alwaysValidSchema)(c, r))
      return;
    const l = (0, tr.allSchemaProperties)(n.properties), $ = (0, tr.allSchemaProperties)(n.patternProperties);
    _(), e.ok((0, je._)`${o} === ${Tc.default.errors}`);
    function _() {
      t.forIn("key", a, (g) => {
        !l.length && !$.length ? P(g) : t.if(C(g), () => P(g));
      });
    }
    function C(g) {
      let m;
      if (l.length > 8) {
        const h = (0, rr.schemaRefOrVal)(c, n.properties, "properties");
        m = (0, tr.isOwnProperty)(t, h, g);
      } else
        l.length ? m = (0, je.or)(...l.map((h) => (0, je._)`${g} === ${h}`)) : m = je.nil;
      return $.length && (m = (0, je.or)(m, ...$.map((h) => (0, je._)`${(0, tr.usePattern)(e, h)}.test(${g})`))), (0, je.not)(m);
    }
    function T(g) {
      t.code((0, je._)`delete ${a}[${g}]`);
    }
    function P(g) {
      if (y.removeAdditional === "all" || y.removeAdditional && r === !1) {
        T(g);
        return;
      }
      if (r === !1) {
        e.setParams({ additionalProperty: g }), e.error(), d || t.break();
        return;
      }
      if (typeof r == "object" && !(0, rr.alwaysValidSchema)(c, r)) {
        const m = t.name("valid");
        y.removeAdditional === "failing" ? (O(g, m, !1), t.if((0, je.not)(m), () => {
          e.reset(), T(g);
        })) : (O(g, m), d || t.if((0, je.not)(m), () => t.break()));
      }
    }
    function O(g, m, h) {
      const R = {
        keyword: "additionalProperties",
        dataProp: g,
        dataPropType: rr.Type.Str
      };
      h === !1 && Object.assign(R, {
        compositeRule: !0,
        createErrors: !1,
        allErrors: !1
      }), e.subschema(R, m);
    }
  }
};
yr.default = Rc;
var $n = {};
Object.defineProperty($n, "__esModule", { value: !0 });
const jc = Ce, ta = Z, Sr = V, ra = yr, Ic = {
  keyword: "properties",
  type: "object",
  schemaType: "object",
  code(e) {
    const { gen: t, schema: r, parentSchema: n, data: a, it: o } = e;
    o.opts.removeAdditional === "all" && n.additionalProperties === void 0 && ra.default.code(new jc.KeywordCxt(o, ra.default, "additionalProperties"));
    const c = (0, ta.allSchemaProperties)(r);
    for (const _ of c)
      o.definedProperties.add(_);
    o.opts.unevaluated && c.length && o.props !== !0 && (o.props = Sr.mergeEvaluated.props(t, (0, Sr.toHash)(c), o.props));
    const d = c.filter((_) => !(0, Sr.alwaysValidSchema)(o, r[_]));
    if (d.length === 0)
      return;
    const y = t.name("valid");
    for (const _ of d)
      l(_) ? $(_) : (t.if((0, ta.propertyInData)(t, a, _, o.opts.ownProperties)), $(_), o.allErrors || t.else().var(y, !0), t.endIf()), e.it.definedProperties.add(_), e.ok(y);
    function l(_) {
      return o.opts.useDefaults && !o.compositeRule && r[_].default !== void 0;
    }
    function $(_) {
      e.subschema({
        keyword: "properties",
        schemaProp: _,
        dataProp: _
      }, y);
    }
  }
};
$n.default = Ic;
var yn = {};
Object.defineProperty(yn, "__esModule", { value: !0 });
const na = Z, nr = X, aa = V, sa = V, kc = {
  keyword: "patternProperties",
  type: "object",
  schemaType: "object",
  code(e) {
    const { gen: t, schema: r, data: n, parentSchema: a, it: o } = e, { opts: c } = o, d = (0, na.allSchemaProperties)(r), y = d.filter((O) => (0, aa.alwaysValidSchema)(o, r[O]));
    if (d.length === 0 || y.length === d.length && (!o.opts.unevaluated || o.props === !0))
      return;
    const l = c.strictSchema && !c.allowMatchingProperties && a.properties, $ = t.name("valid");
    o.props !== !0 && !(o.props instanceof nr.Name) && (o.props = (0, sa.evaluatedPropsToName)(t, o.props));
    const { props: _ } = o;
    C();
    function C() {
      for (const O of d)
        l && T(O), o.allErrors ? P(O) : (t.var($, !0), P(O), t.if($));
    }
    function T(O) {
      for (const g in l)
        new RegExp(O).test(g) && (0, aa.checkStrictMode)(o, `property ${g} matches pattern ${O} (use allowMatchingProperties)`);
    }
    function P(O) {
      t.forIn("key", n, (g) => {
        t.if((0, nr._)`${(0, na.usePattern)(e, O)}.test(${g})`, () => {
          const m = y.includes(O);
          m || e.subschema({
            keyword: "patternProperties",
            schemaProp: O,
            dataProp: g,
            dataPropType: sa.Type.Str
          }, $), o.opts.unevaluated && _ !== !0 ? t.assign((0, nr._)`${_}[${g}]`, !0) : !m && !o.allErrors && t.if((0, nr.not)($), () => t.break());
        });
      });
    }
  }
};
yn.default = kc;
var vn = {};
Object.defineProperty(vn, "__esModule", { value: !0 });
const Dc = V, Ac = {
  keyword: "not",
  schemaType: ["object", "boolean"],
  trackErrors: !0,
  code(e) {
    const { gen: t, schema: r, it: n } = e;
    if ((0, Dc.alwaysValidSchema)(n, r)) {
      e.fail();
      return;
    }
    const a = t.name("valid");
    e.subschema({
      keyword: "not",
      compositeRule: !0,
      createErrors: !1,
      allErrors: !1
    }, a), e.failResult(a, () => e.reset(), () => e.error());
  },
  error: { message: "must NOT be valid" }
};
vn.default = Ac;
var _n = {};
Object.defineProperty(_n, "__esModule", { value: !0 });
const Mc = Z, Vc = {
  keyword: "anyOf",
  schemaType: "array",
  trackErrors: !0,
  code: Mc.validateUnion,
  error: { message: "must match a schema in anyOf" }
};
_n.default = Vc;
var gn = {};
Object.defineProperty(gn, "__esModule", { value: !0 });
const cr = X, Fc = V, zc = {
  message: "must match exactly one schema in oneOf",
  params: ({ params: e }) => (0, cr._)`{passingSchemas: ${e.passing}}`
}, Uc = {
  keyword: "oneOf",
  schemaType: "array",
  trackErrors: !0,
  error: zc,
  code(e) {
    const { gen: t, schema: r, parentSchema: n, it: a } = e;
    if (!Array.isArray(r))
      throw new Error("ajv implementation error");
    if (a.opts.discriminator && n.discriminator)
      return;
    const o = r, c = t.let("valid", !1), d = t.let("passing", null), y = t.name("_valid");
    e.setParams({ passing: d }), t.block(l), e.result(c, () => e.reset(), () => e.error(!0));
    function l() {
      o.forEach(($, _) => {
        let C;
        (0, Fc.alwaysValidSchema)(a, $) ? t.var(y, !0) : C = e.subschema({
          keyword: "oneOf",
          schemaProp: _,
          compositeRule: !0
        }, y), _ > 0 && t.if((0, cr._)`${y} && ${c}`).assign(c, !1).assign(d, (0, cr._)`[${d}, ${_}]`).else(), t.if(y, () => {
          t.assign(c, !0), t.assign(d, _), C && e.mergeEvaluated(C, cr.Name);
        });
      });
    }
  }
};
gn.default = Uc;
var wn = {};
Object.defineProperty(wn, "__esModule", { value: !0 });
const qc = V, Kc = {
  keyword: "allOf",
  schemaType: "array",
  code(e) {
    const { gen: t, schema: r, it: n } = e;
    if (!Array.isArray(r))
      throw new Error("ajv implementation error");
    const a = t.name("valid");
    r.forEach((o, c) => {
      if ((0, qc.alwaysValidSchema)(n, o))
        return;
      const d = e.subschema({ keyword: "allOf", schemaProp: c }, a);
      e.ok(a), e.mergeEvaluated(d);
    });
  }
};
wn.default = Kc;
var En = {};
Object.defineProperty(En, "__esModule", { value: !0 });
const hr = X, Za = V, Lc = {
  message: ({ params: e }) => (0, hr.str)`must match "${e.ifClause}" schema`,
  params: ({ params: e }) => (0, hr._)`{failingKeyword: ${e.ifClause}}`
}, Hc = {
  keyword: "if",
  schemaType: ["object", "boolean"],
  trackErrors: !0,
  error: Lc,
  code(e) {
    const { gen: t, parentSchema: r, it: n } = e;
    r.then === void 0 && r.else === void 0 && (0, Za.checkStrictMode)(n, '"if" without "then" and "else" is ignored');
    const a = oa(n, "then"), o = oa(n, "else");
    if (!a && !o)
      return;
    const c = t.let("valid", !0), d = t.name("_valid");
    if (y(), e.reset(), a && o) {
      const $ = t.let("ifClause");
      e.setParams({ ifClause: $ }), t.if(d, l("then", $), l("else", $));
    } else
      a ? t.if(d, l("then")) : t.if((0, hr.not)(d), l("else"));
    e.pass(c, () => e.error(!0));
    function y() {
      const $ = e.subschema({
        keyword: "if",
        compositeRule: !0,
        createErrors: !1,
        allErrors: !1
      }, d);
      e.mergeEvaluated($);
    }
    function l($, _) {
      return () => {
        const C = e.subschema({ keyword: $ }, d);
        t.assign(c, d), e.mergeValidEvaluated(C, c), _ ? t.assign(_, (0, hr._)`${$}`) : e.setParams({ ifClause: $ });
      };
    }
  }
};
function oa(e, t) {
  const r = e.schema[t];
  return r !== void 0 && !(0, Za.alwaysValidSchema)(e, r);
}
En.default = Hc;
var bn = {};
Object.defineProperty(bn, "__esModule", { value: !0 });
const Gc = V, Jc = {
  keyword: ["then", "else"],
  schemaType: ["object", "boolean"],
  code({ keyword: e, parentSchema: t, it: r }) {
    t.if === void 0 && (0, Gc.checkStrictMode)(r, `"${e}" without "if" is ignored`);
  }
};
bn.default = Jc;
Object.defineProperty(ln, "__esModule", { value: !0 });
const Wc = Pt, Bc = fn, Yc = Ot, Xc = hn, Qc = mn, Zc = Xa, xc = pn, eu = yr, tu = $n, ru = yn, nu = vn, au = _n, su = gn, ou = wn, iu = En, cu = bn;
function uu(e = !1) {
  const t = [
    // any
    nu.default,
    au.default,
    su.default,
    ou.default,
    iu.default,
    cu.default,
    // object
    xc.default,
    eu.default,
    Zc.default,
    tu.default,
    ru.default
  ];
  return e ? t.push(Bc.default, Xc.default) : t.push(Wc.default, Yc.default), t.push(Qc.default), t;
}
ln.default = uu;
var Sn = {}, Pn = {};
Object.defineProperty(Pn, "__esModule", { value: !0 });
const me = X, du = {
  message: ({ schemaCode: e }) => (0, me.str)`must match format "${e}"`,
  params: ({ schemaCode: e }) => (0, me._)`{format: ${e}}`
}, lu = {
  keyword: "format",
  type: ["number", "string"],
  schemaType: "string",
  $data: !0,
  error: du,
  code(e, t) {
    const { gen: r, data: n, $data: a, schema: o, schemaCode: c, it: d } = e, { opts: y, errSchemaPath: l, schemaEnv: $, self: _ } = d;
    if (!y.validateFormats)
      return;
    a ? C() : T();
    function C() {
      const P = r.scopeValue("formats", {
        ref: _.formats,
        code: y.code.formats
      }), O = r.const("fDef", (0, me._)`${P}[${c}]`), g = r.let("fType"), m = r.let("format");
      r.if((0, me._)`typeof ${O} == "object" && !(${O} instanceof RegExp)`, () => r.assign(g, (0, me._)`${O}.type || "string"`).assign(m, (0, me._)`${O}.validate`), () => r.assign(g, (0, me._)`"string"`).assign(m, O)), e.fail$data((0, me.or)(h(), R()));
      function h() {
        return y.strictSchema === !1 ? me.nil : (0, me._)`${c} && !${m}`;
      }
      function R() {
        const k = $.$async ? (0, me._)`(${O}.async ? await ${m}(${n}) : ${m}(${n}))` : (0, me._)`${m}(${n})`, A = (0, me._)`(typeof ${m} == "function" ? ${k} : ${m}.test(${n}))`;
        return (0, me._)`${m} && ${m} !== true && ${g} === ${t} && !${A}`;
      }
    }
    function T() {
      const P = _.formats[o];
      if (!P) {
        h();
        return;
      }
      if (P === !0)
        return;
      const [O, g, m] = R(P);
      O === t && e.pass(k());
      function h() {
        if (y.strictSchema === !1) {
          _.logger.warn(A());
          return;
        }
        throw new Error(A());
        function A() {
          return `unknown format "${o}" ignored in schema at path "${l}"`;
        }
      }
      function R(A) {
        const B = A instanceof RegExp ? (0, me.regexpCode)(A) : y.code.formats ? (0, me._)`${y.code.formats}${(0, me.getProperty)(o)}` : void 0, te = r.scopeValue("formats", { key: o, ref: A, code: B });
        return typeof A == "object" && !(A instanceof RegExp) ? [A.type || "string", A.validate, (0, me._)`${te}.validate`] : ["string", A, te];
      }
      function k() {
        if (typeof P == "object" && !(P instanceof RegExp) && P.async) {
          if (!$.$async)
            throw new Error("async format in sync schema");
          return (0, me._)`await ${m}(${n})`;
        }
        return typeof g == "function" ? (0, me._)`${m}(${n})` : (0, me._)`${m}.test(${n})`;
      }
    }
  }
};
Pn.default = lu;
Object.defineProperty(Sn, "__esModule", { value: !0 });
const fu = Pn, hu = [fu.default];
Sn.default = hu;
var bt = {};
Object.defineProperty(bt, "__esModule", { value: !0 });
bt.contentVocabulary = bt.metadataVocabulary = void 0;
bt.metadataVocabulary = [
  "title",
  "description",
  "default",
  "deprecated",
  "readOnly",
  "writeOnly",
  "examples"
];
bt.contentVocabulary = [
  "contentMediaType",
  "contentEncoding",
  "contentSchema"
];
Object.defineProperty(Yr, "__esModule", { value: !0 });
const mu = Xr, pu = Zr, $u = ln, yu = Sn, ia = bt, vu = [
  mu.default,
  pu.default,
  (0, $u.default)(),
  yu.default,
  ia.metadataVocabulary,
  ia.contentVocabulary
];
Yr.default = vu;
var On = {}, vr = {};
Object.defineProperty(vr, "__esModule", { value: !0 });
vr.DiscrError = void 0;
var ca;
(function(e) {
  e.Tag = "tag", e.Mapping = "mapping";
})(ca || (vr.DiscrError = ca = {}));
Object.defineProperty(On, "__esModule", { value: !0 });
const vt = X, Dr = vr, ua = Se, _u = V, gu = {
  message: ({ params: { discrError: e, tagName: t } }) => e === Dr.DiscrError.Tag ? `tag "${t}" must be string` : `value of tag "${t}" must be in oneOf`,
  params: ({ params: { discrError: e, tag: t, tagName: r } }) => (0, vt._)`{error: ${e}, tag: ${r}, tagValue: ${t}}`
}, wu = {
  keyword: "discriminator",
  type: "object",
  schemaType: "object",
  error: gu,
  code(e) {
    const { gen: t, data: r, schema: n, parentSchema: a, it: o } = e, { oneOf: c } = a;
    if (!o.opts.discriminator)
      throw new Error("discriminator: requires discriminator option");
    const d = n.propertyName;
    if (typeof d != "string")
      throw new Error("discriminator: requires propertyName");
    if (n.mapping)
      throw new Error("discriminator: mapping is not supported");
    if (!c)
      throw new Error("discriminator: requires oneOf keyword");
    const y = t.let("valid", !1), l = t.const("tag", (0, vt._)`${r}${(0, vt.getProperty)(d)}`);
    t.if((0, vt._)`typeof ${l} == "string"`, () => $(), () => e.error(!1, { discrError: Dr.DiscrError.Tag, tag: l, tagName: d })), e.ok(y);
    function $() {
      const T = C();
      t.if(!1);
      for (const P in T)
        t.elseIf((0, vt._)`${l} === ${P}`), t.assign(y, _(T[P]));
      t.else(), e.error(!1, { discrError: Dr.DiscrError.Mapping, tag: l, tagName: d }), t.endIf();
    }
    function _(T) {
      const P = t.name("valid"), O = e.subschema({ keyword: "oneOf", schemaProp: T }, P);
      return e.mergeEvaluated(O, vt.Name), P;
    }
    function C() {
      var T;
      const P = {}, O = m(a);
      let g = !0;
      for (let k = 0; k < c.length; k++) {
        let A = c[k];
        A != null && A.$ref && !(0, _u.schemaHasRulesButRef)(A, o.self.RULES) && (A = ua.resolveRef.call(o.self, o.schemaEnv.root, o.baseId, A == null ? void 0 : A.$ref), A instanceof ua.SchemaEnv && (A = A.schema));
        const B = (T = A == null ? void 0 : A.properties) === null || T === void 0 ? void 0 : T[d];
        if (typeof B != "object")
          throw new Error(`discriminator: oneOf subschemas (or referenced schemas) must have "properties/${d}"`);
        g = g && (O || m(A)), h(B, k);
      }
      if (!g)
        throw new Error(`discriminator: "${d}" must be required`);
      return P;
      function m({ required: k }) {
        return Array.isArray(k) && k.includes(d);
      }
      function h(k, A) {
        if (k.const)
          R(k.const, A);
        else if (k.enum)
          for (const B of k.enum)
            R(B, A);
        else
          throw new Error(`discriminator: "properties/${d}" must have "const" or "enum"`);
      }
      function R(k, A) {
        if (typeof k != "string" || k in P)
          throw new Error(`discriminator: "${d}" values must be unique strings`);
        P[k] = A;
      }
    }
  }
};
On.default = wu;
const Eu = "http://json-schema.org/draft-07/schema#", bu = "http://json-schema.org/draft-07/schema#", Su = "Core schema meta-schema", Pu = {
  schemaArray: {
    type: "array",
    minItems: 1,
    items: {
      $ref: "#"
    }
  },
  nonNegativeInteger: {
    type: "integer",
    minimum: 0
  },
  nonNegativeIntegerDefault0: {
    allOf: [
      {
        $ref: "#/definitions/nonNegativeInteger"
      },
      {
        default: 0
      }
    ]
  },
  simpleTypes: {
    enum: [
      "array",
      "boolean",
      "integer",
      "null",
      "number",
      "object",
      "string"
    ]
  },
  stringArray: {
    type: "array",
    items: {
      type: "string"
    },
    uniqueItems: !0,
    default: []
  }
}, Ou = [
  "object",
  "boolean"
], Nu = {
  $id: {
    type: "string",
    format: "uri-reference"
  },
  $schema: {
    type: "string",
    format: "uri"
  },
  $ref: {
    type: "string",
    format: "uri-reference"
  },
  $comment: {
    type: "string"
  },
  title: {
    type: "string"
  },
  description: {
    type: "string"
  },
  default: !0,
  readOnly: {
    type: "boolean",
    default: !1
  },
  examples: {
    type: "array",
    items: !0
  },
  multipleOf: {
    type: "number",
    exclusiveMinimum: 0
  },
  maximum: {
    type: "number"
  },
  exclusiveMaximum: {
    type: "number"
  },
  minimum: {
    type: "number"
  },
  exclusiveMinimum: {
    type: "number"
  },
  maxLength: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minLength: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  pattern: {
    type: "string",
    format: "regex"
  },
  additionalItems: {
    $ref: "#"
  },
  items: {
    anyOf: [
      {
        $ref: "#"
      },
      {
        $ref: "#/definitions/schemaArray"
      }
    ],
    default: !0
  },
  maxItems: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minItems: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  uniqueItems: {
    type: "boolean",
    default: !1
  },
  contains: {
    $ref: "#"
  },
  maxProperties: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minProperties: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  required: {
    $ref: "#/definitions/stringArray"
  },
  additionalProperties: {
    $ref: "#"
  },
  definitions: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    default: {}
  },
  properties: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    default: {}
  },
  patternProperties: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    propertyNames: {
      format: "regex"
    },
    default: {}
  },
  dependencies: {
    type: "object",
    additionalProperties: {
      anyOf: [
        {
          $ref: "#"
        },
        {
          $ref: "#/definitions/stringArray"
        }
      ]
    }
  },
  propertyNames: {
    $ref: "#"
  },
  const: !0,
  enum: {
    type: "array",
    items: !0,
    minItems: 1,
    uniqueItems: !0
  },
  type: {
    anyOf: [
      {
        $ref: "#/definitions/simpleTypes"
      },
      {
        type: "array",
        items: {
          $ref: "#/definitions/simpleTypes"
        },
        minItems: 1,
        uniqueItems: !0
      }
    ]
  },
  format: {
    type: "string"
  },
  contentMediaType: {
    type: "string"
  },
  contentEncoding: {
    type: "string"
  },
  if: {
    $ref: "#"
  },
  then: {
    $ref: "#"
  },
  else: {
    $ref: "#"
  },
  allOf: {
    $ref: "#/definitions/schemaArray"
  },
  anyOf: {
    $ref: "#/definitions/schemaArray"
  },
  oneOf: {
    $ref: "#/definitions/schemaArray"
  },
  not: {
    $ref: "#"
  }
}, Tu = {
  $schema: Eu,
  $id: bu,
  title: Su,
  definitions: Pu,
  type: Ou,
  properties: Nu,
  default: !0
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 }), t.MissingRefError = t.ValidationError = t.CodeGen = t.Name = t.nil = t.stringify = t.str = t._ = t.KeywordCxt = t.Ajv = void 0;
  const r = la, n = Yr, a = On, o = Tu, c = ["/properties"], d = "http://json-schema.org/draft-07/schema";
  class y extends r.default {
    _addVocabularies() {
      super._addVocabularies(), n.default.forEach((P) => this.addVocabulary(P)), this.opts.discriminator && this.addKeyword(a.default);
    }
    _addDefaultMetaSchema() {
      if (super._addDefaultMetaSchema(), !this.opts.meta)
        return;
      const P = this.opts.$data ? this.$dataMetaSchema(o, c) : o;
      this.addMetaSchema(P, d, !1), this.refs["http://json-schema.org/schema"] = d;
    }
    defaultMeta() {
      return this.opts.defaultMeta = super.defaultMeta() || (this.getSchema(d) ? d : void 0);
    }
  }
  t.Ajv = y, e.exports = t = y, e.exports.Ajv = y, Object.defineProperty(t, "__esModule", { value: !0 }), t.default = y;
  var l = Ce;
  Object.defineProperty(t, "KeywordCxt", { enumerable: !0, get: function() {
    return l.KeywordCxt;
  } });
  var $ = X;
  Object.defineProperty(t, "_", { enumerable: !0, get: function() {
    return $._;
  } }), Object.defineProperty(t, "str", { enumerable: !0, get: function() {
    return $.str;
  } }), Object.defineProperty(t, "stringify", { enumerable: !0, get: function() {
    return $.stringify;
  } }), Object.defineProperty(t, "nil", { enumerable: !0, get: function() {
    return $.nil;
  } }), Object.defineProperty(t, "Name", { enumerable: !0, get: function() {
    return $.Name;
  } }), Object.defineProperty(t, "CodeGen", { enumerable: !0, get: function() {
    return $.CodeGen;
  } });
  var _ = Gt;
  Object.defineProperty(t, "ValidationError", { enumerable: !0, get: function() {
    return _.default;
  } });
  var C = Jt;
  Object.defineProperty(t, "MissingRefError", { enumerable: !0, get: function() {
    return C.default;
  } });
})(Or, Or.exports);
var Nn = Or.exports;
const Cu = /* @__PURE__ */ Vr(Nn);
var Ar = { exports: {} };
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const r = Nn, n = X, a = Et, o = Ce, c = St, d = ke, y = "errorMessage", l = new r.Name("emUsed"), $ = {
    required: "missingProperty",
    dependencies: "property",
    dependentRequired: "property"
  }, _ = /\$\{[^}]+\}/, C = /\$\{([^}]+)\}/g, T = /^""\s*\+\s*|\s*\+\s*""$/g;
  function P(g) {
    return {
      keyword: y,
      schemaType: ["string", "object"],
      post: !0,
      code(m) {
        const { gen: h, data: R, schema: k, schemaValue: A, it: B } = m;
        if (B.createErrors === !1)
          return;
        const te = k, K = n.strConcat(d.default.instancePath, B.errorPath);
        h.if(r._`${d.default.errors} > 0`, () => {
          if (typeof te == "object") {
            const [v, s] = z(te);
            s && Q(s), v && H(v), ae(M(te));
          }
          const E = typeof te == "string" ? te : te._;
          E && le(E), g.keepErrors || we();
        });
        function M({ properties: E, items: v }) {
          const s = {};
          if (E) {
            s.props = {};
            for (const u in E)
              s.props[u] = [];
          }
          if (v) {
            s.items = {};
            for (let u = 0; u < v.length; u++)
              s.items[u] = [];
          }
          return s;
        }
        function z(E) {
          let v, s;
          for (const u in E) {
            if (u === "properties" || u === "items")
              continue;
            const b = E[u];
            if (typeof b == "object") {
              v || (v = {});
              const I = v[u] = {};
              for (const j in b)
                I[j] = [];
            } else
              s || (s = {}), s[u] = [];
          }
          return [v, s];
        }
        function Q(E) {
          const v = h.const("emErrors", r.stringify(E)), s = h.const("templates", Ae(E, k));
          h.forOf("err", d.default.vErrors, (j) => h.if(De(j, v), () => h.code(r._`${v}[${j}.keyword].push(${j})`).assign(r._`${j}.${l}`, !0)));
          const { singleError: u } = g;
          if (u) {
            const j = h.let("message", r._`""`), F = h.let("paramsErrors", r._`[]`);
            b((G) => {
              h.if(j, () => h.code(r._`${j} += ${typeof u == "string" ? u : ";"}`)), h.code(r._`${j} += ${I(G)}`), h.assign(F, r._`${F}.concat(${v}[${G}])`);
            }), c.reportError(m, { message: j, params: r._`{errors: ${F}}` });
          } else
            b((j) => c.reportError(m, {
              message: I(j),
              params: r._`{errors: ${v}[${j}]}`
            }));
          function b(j) {
            h.forIn("key", v, (F) => h.if(r._`${v}[${F}].length`, () => j(F)));
          }
          function I(j) {
            return r._`${j} in ${s} ? ${s}[${j}]() : ${A}[${j}]`;
          }
        }
        function H(E) {
          const v = h.const("emErrors", r.stringify(E)), s = [];
          for (const F in E)
            s.push([
              F,
              Ae(E[F], k[F])
            ]);
          const u = h.const("templates", h.object(...s)), b = h.scopeValue("obj", {
            ref: $,
            code: r.stringify($)
          }), I = h.let("emPropParams"), j = h.let("emParamsErrors");
          h.forOf("err", d.default.vErrors, (F) => h.if(De(F, v), () => {
            h.assign(I, r._`${b}[${F}.keyword]`), h.assign(j, r._`${v}[${F}.keyword][${F}.params[${I}]]`), h.if(j, () => h.code(r._`${j}.push(${F})`).assign(r._`${F}.${l}`, !0));
          })), h.forIn("key", v, (F) => h.forIn("keyProp", r._`${v}[${F}]`, (G) => {
            h.assign(j, r._`${v}[${F}][${G}]`), h.if(r._`${j}.length`, () => {
              const re = h.const("tmpl", r._`${u}[${F}] && ${u}[${F}][${G}]`);
              c.reportError(m, {
                message: r._`${re} ? ${re}() : ${A}[${F}][${G}]`,
                params: r._`{errors: ${j}}`
              });
            });
          }));
        }
        function ae(E) {
          const { props: v, items: s } = E;
          if (!v && !s)
            return;
          const u = r._`typeof ${R} == "object"`, b = r._`Array.isArray(${R})`, I = h.let("emErrors");
          let j, F;
          const G = h.let("templates");
          v && s ? (j = h.let("emChildKwd"), h.if(u), h.if(b, () => {
            re(s, k.items), h.assign(j, r.str`items`);
          }, () => {
            re(v, k.properties), h.assign(j, r.str`properties`);
          }), F = r._`[${j}]`) : s ? (h.if(b), re(s, k.items), F = r._`.items`) : v && (h.if(n.and(u, n.not(b))), re(v, k.properties), F = r._`.properties`), h.forOf("err", d.default.vErrors, (ce) => We(ce, I, (Me) => h.code(r._`${I}[${Me}].push(${ce})`).assign(r._`${ce}.${l}`, !0))), h.forIn("key", I, (ce) => h.if(r._`${I}[${ce}].length`, () => {
            c.reportError(m, {
              message: r._`${ce} in ${G} ? ${G}[${ce}]() : ${A}${F}[${ce}]`,
              params: r._`{errors: ${I}[${ce}]}`
            }), h.assign(r._`${d.default.vErrors}[${d.default.errors}-1].instancePath`, r._`${K} + "/" + ${ce}.replace(/~/g, "~0").replace(/\\//g, "~1")`);
          })), h.endIf();
          function re(ce, Me) {
            h.assign(I, r.stringify(ce)), h.assign(G, Ae(ce, Me));
          }
        }
        function le(E) {
          const v = h.const("emErrs", r._`[]`);
          h.forOf("err", d.default.vErrors, (s) => h.if(xe(s), () => h.code(r._`${v}.push(${s})`).assign(r._`${s}.${l}`, !0))), h.if(r._`${v}.length`, () => c.reportError(m, {
            message: D(E),
            params: r._`{errors: ${v}}`
          }));
        }
        function we() {
          const E = h.const("emErrs", r._`[]`);
          h.forOf("err", d.default.vErrors, (v) => h.if(r._`!${v}.${l}`, () => h.code(r._`${E}.push(${v})`))), h.assign(d.default.vErrors, E).assign(d.default.errors, r._`${E}.length`);
        }
        function De(E, v) {
          return n.and(
            r._`${E}.keyword !== ${y}`,
            r._`!${E}.${l}`,
            r._`${E}.instancePath === ${K}`,
            r._`${E}.keyword in ${v}`,
            // TODO match the end of the string?
            r._`${E}.schemaPath.indexOf(${B.errSchemaPath}) === 0`,
            r._`/^\\/[^\\/]*$/.test(${E}.schemaPath.slice(${B.errSchemaPath.length}))`
          );
        }
        function We(E, v, s) {
          h.if(n.and(r._`${E}.keyword !== ${y}`, r._`!${E}.${l}`, r._`${E}.instancePath.indexOf(${K}) === 0`), () => {
            const u = h.scopeValue("pattern", {
              ref: /^\/([^/]*)(?:\/|$)/,
              code: r._`new RegExp("^\\\/([^/]*)(?:\\\/|$)")`
            }), b = h.const("emMatches", r._`${u}.exec(${E}.instancePath.slice(${K}.length))`), I = h.const("emChild", r._`${b} && ${b}[1].replace(/~1/g, "/").replace(/~0/g, "~")`);
            h.if(r._`${I} !== undefined && ${I} in ${v}`, () => s(I));
          });
        }
        function xe(E) {
          return n.and(r._`${E}.keyword !== ${y}`, r._`!${E}.${l}`, n.or(r._`${E}.instancePath === ${K}`, n.and(r._`${E}.instancePath.indexOf(${K}) === 0`, r._`${E}.instancePath[${K}.length] === "/"`)), r._`${E}.schemaPath.indexOf(${B.errSchemaPath}) === 0`, r._`${E}.schemaPath[${B.errSchemaPath}.length] === "/"`);
        }
        function Ae(E, v) {
          const s = [];
          for (const u in E) {
            const b = v[u];
            _.test(b) && s.push([u, w(b)]);
          }
          return h.object(...s);
        }
        function D(E) {
          return _.test(E) ? new a._Code(a.safeStringify(E).replace(C, (v, s) => `" + JSON.stringify(${o.getData(s, B)}) + "`).replace(T, "")) : r.stringify(E);
        }
        function w(E) {
          return r._`function(){return ${D(E)}}`;
        }
      },
      metaSchema: {
        anyOf: [
          { type: "string" },
          {
            type: "object",
            properties: {
              properties: { $ref: "#/$defs/stringMap" },
              items: { $ref: "#/$defs/stringList" },
              required: { $ref: "#/$defs/stringOrMap" },
              dependencies: { $ref: "#/$defs/stringOrMap" }
            },
            additionalProperties: { type: "string" }
          }
        ],
        $defs: {
          stringMap: {
            type: "object",
            additionalProperties: { type: "string" }
          },
          stringOrMap: {
            anyOf: [{ type: "string" }, { $ref: "#/$defs/stringMap" }]
          },
          stringList: { type: "array", items: { type: "string" } }
        }
      }
    };
  }
  const O = (g, m = {}) => {
    if (!g.opts.allErrors)
      throw new Error("ajv-errors: Ajv option allErrors must be true");
    if (g.opts.jsPropertySyntax)
      throw new Error("ajv-errors: ajv option jsPropertySyntax is not supported");
    return g.addKeyword(P(m));
  };
  t.default = O, e.exports = O, e.exports.default = O;
})(Ar, Ar.exports);
var Ru = Ar.exports;
const ju = /* @__PURE__ */ Vr(Ru);
var Mr = { exports: {} }, xa = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.formatNames = e.fastFormats = e.fullFormats = void 0;
  function t(M, z) {
    return { validate: M, compare: z };
  }
  e.fullFormats = {
    // date: http://tools.ietf.org/html/rfc3339#section-5.6
    date: t(o, c),
    // date-time: http://tools.ietf.org/html/rfc3339#section-5.6
    time: t(y, l),
    "date-time": t(_, C),
    // duration: https://tools.ietf.org/html/rfc3339#appendix-A
    duration: /^P(?!$)((\d+Y)?(\d+M)?(\d+D)?(T(?=\d)(\d+H)?(\d+M)?(\d+S)?)?|(\d+W)?)$/,
    uri: O,
    "uri-reference": /^(?:[a-z][a-z0-9+\-.]*:)?(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'"()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?(?:\?(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i,
    // uri-template: https://tools.ietf.org/html/rfc6570
    "uri-template": /^(?:(?:[^\x00-\x20"'<>%\\^`{|}]|%[0-9a-f]{2})|\{[+#./;?&=,!@|]?(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?(?:,(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?)*\})*$/i,
    // For the source: https://gist.github.com/dperini/729294
    // For test cases: https://mathiasbynens.be/demo/url-regex
    url: /^(?:https?|ftp):\/\/(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u{00a1}-\u{ffff}]+-)*[a-z0-9\u{00a1}-\u{ffff}]+)(?:\.(?:[a-z0-9\u{00a1}-\u{ffff}]+-)*[a-z0-9\u{00a1}-\u{ffff}]+)*(?:\.(?:[a-z\u{00a1}-\u{ffff}]{2,})))(?::\d{2,5})?(?:\/[^\s]*)?$/iu,
    email: /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i,
    hostname: /^(?=.{1,253}\.?$)[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[-0-9a-z]{0,61}[0-9a-z])?)*\.?$/i,
    // optimized https://www.safaribooksonline.com/library/view/regular-expressions-cookbook/9780596802837/ch07s16.html
    ipv4: /^(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)$/,
    ipv6: /^((([0-9a-f]{1,4}:){7}([0-9a-f]{1,4}|:))|(([0-9a-f]{1,4}:){6}(:[0-9a-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){5}(((:[0-9a-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){4}(((:[0-9a-f]{1,4}){1,3})|((:[0-9a-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){3}(((:[0-9a-f]{1,4}){1,4})|((:[0-9a-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){2}(((:[0-9a-f]{1,4}){1,5})|((:[0-9a-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){1}(((:[0-9a-f]{1,4}){1,6})|((:[0-9a-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9a-f]{1,4}){1,7})|((:[0-9a-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))$/i,
    regex: K,
    // uuid: http://tools.ietf.org/html/rfc4122
    uuid: /^(?:urn:uuid:)?[0-9a-f]{8}-(?:[0-9a-f]{4}-){3}[0-9a-f]{12}$/i,
    // JSON-pointer: https://tools.ietf.org/html/rfc6901
    // uri fragment: https://tools.ietf.org/html/rfc3986#appendix-A
    "json-pointer": /^(?:\/(?:[^~/]|~0|~1)*)*$/,
    "json-pointer-uri-fragment": /^#(?:\/(?:[a-z0-9_\-.!$&'()*+,;:=@]|%[0-9a-f]{2}|~0|~1)*)*$/i,
    // relative JSON-pointer: http://tools.ietf.org/html/draft-luff-relative-json-pointer-00
    "relative-json-pointer": /^(?:0|[1-9][0-9]*)(?:#|(?:\/(?:[^~/]|~0|~1)*)*)$/,
    // the following formats are used by the openapi specification: https://spec.openapis.org/oas/v3.0.0#data-types
    // byte: https://github.com/miguelmota/is-base64
    byte: m,
    // signed 32 bit integer
    int32: { type: "number", validate: k },
    // signed 64 bit integer
    int64: { type: "number", validate: A },
    // C-type float
    float: { type: "number", validate: B },
    // C-type double
    double: { type: "number", validate: B },
    // hint to the UI to hide input strings
    password: !0,
    // unchecked string payload
    binary: !0
  }, e.fastFormats = {
    ...e.fullFormats,
    date: t(/^\d\d\d\d-[0-1]\d-[0-3]\d$/, c),
    time: t(/^(?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d(?::?\d\d)?)?$/i, l),
    "date-time": t(/^\d\d\d\d-[0-1]\d-[0-3]\d[t\s](?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d(?::?\d\d)?)$/i, C),
    // uri: https://github.com/mafintosh/is-my-json-valid/blob/master/formats.js
    uri: /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/)?[^\s]*$/i,
    "uri-reference": /^(?:(?:[a-z][a-z0-9+\-.]*:)?\/?\/)?(?:[^\\\s#][^\s#]*)?(?:#[^\\\s]*)?$/i,
    // email (sources from jsen validator):
    // http://stackoverflow.com/questions/201323/using-a-regular-expression-to-validate-an-email-address#answer-8829363
    // http://www.w3.org/TR/html5/forms.html#valid-e-mail-address (search for 'wilful violation')
    email: /^[a-z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?)*$/i
  }, e.formatNames = Object.keys(e.fullFormats);
  function r(M) {
    return M % 4 === 0 && (M % 100 !== 0 || M % 400 === 0);
  }
  const n = /^(\d\d\d\d)-(\d\d)-(\d\d)$/, a = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  function o(M) {
    const z = n.exec(M);
    if (!z)
      return !1;
    const Q = +z[1], H = +z[2], ae = +z[3];
    return H >= 1 && H <= 12 && ae >= 1 && ae <= (H === 2 && r(Q) ? 29 : a[H]);
  }
  function c(M, z) {
    if (M && z)
      return M > z ? 1 : M < z ? -1 : 0;
  }
  const d = /^(\d\d):(\d\d):(\d\d)(\.\d+)?(z|[+-]\d\d(?::?\d\d)?)?$/i;
  function y(M, z) {
    const Q = d.exec(M);
    if (!Q)
      return !1;
    const H = +Q[1], ae = +Q[2], le = +Q[3], we = Q[5];
    return (H <= 23 && ae <= 59 && le <= 59 || H === 23 && ae === 59 && le === 60) && (!z || we !== "");
  }
  function l(M, z) {
    if (!(M && z))
      return;
    const Q = d.exec(M), H = d.exec(z);
    if (Q && H)
      return M = Q[1] + Q[2] + Q[3] + (Q[4] || ""), z = H[1] + H[2] + H[3] + (H[4] || ""), M > z ? 1 : M < z ? -1 : 0;
  }
  const $ = /t|\s/i;
  function _(M) {
    const z = M.split($);
    return z.length === 2 && o(z[0]) && y(z[1], !0);
  }
  function C(M, z) {
    if (!(M && z))
      return;
    const [Q, H] = M.split($), [ae, le] = z.split($), we = c(Q, ae);
    if (we !== void 0)
      return we || l(H, le);
  }
  const T = /\/|:/, P = /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)(?:\?(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i;
  function O(M) {
    return T.test(M) && P.test(M);
  }
  const g = /^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/gm;
  function m(M) {
    return g.lastIndex = 0, g.test(M);
  }
  const h = -(2 ** 31), R = 2 ** 31 - 1;
  function k(M) {
    return Number.isInteger(M) && M <= R && M >= h;
  }
  function A(M) {
    return Number.isInteger(M);
  }
  function B() {
    return !0;
  }
  const te = /[^\\]\\Z/;
  function K(M) {
    if (te.test(M))
      return !1;
    try {
      return new RegExp(M), !0;
    } catch {
      return !1;
    }
  }
})(xa);
var es = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.formatLimitDefinition = void 0;
  const t = Nn, r = X, n = r.operators, a = {
    formatMaximum: { okStr: "<=", ok: n.LTE, fail: n.GT },
    formatMinimum: { okStr: ">=", ok: n.GTE, fail: n.LT },
    formatExclusiveMaximum: { okStr: "<", ok: n.LT, fail: n.GTE },
    formatExclusiveMinimum: { okStr: ">", ok: n.GT, fail: n.LTE }
  }, o = {
    message: ({ keyword: d, schemaCode: y }) => r.str`should be ${a[d].okStr} ${y}`,
    params: ({ keyword: d, schemaCode: y }) => r._`{comparison: ${a[d].okStr}, limit: ${y}}`
  };
  e.formatLimitDefinition = {
    keyword: Object.keys(a),
    type: "string",
    schemaType: "string",
    $data: !0,
    error: o,
    code(d) {
      const { gen: y, data: l, schemaCode: $, keyword: _, it: C } = d, { opts: T, self: P } = C;
      if (!T.validateFormats)
        return;
      const O = new t.KeywordCxt(C, P.RULES.all.format.definition, "format");
      O.$data ? g() : m();
      function g() {
        const R = y.scopeValue("formats", {
          ref: P.formats,
          code: T.code.formats
        }), k = y.const("fmt", r._`${R}[${O.schemaCode}]`);
        d.fail$data(r.or(r._`typeof ${k} != "object"`, r._`${k} instanceof RegExp`, r._`typeof ${k}.compare != "function"`, h(k)));
      }
      function m() {
        const R = O.schema, k = P.formats[R];
        if (!k || k === !0)
          return;
        if (typeof k != "object" || k instanceof RegExp || typeof k.compare != "function")
          throw new Error(`"${_}": format "${R}" does not define "compare" function`);
        const A = y.scopeValue("formats", {
          key: R,
          ref: k,
          code: T.code.formats ? r._`${T.code.formats}${r.getProperty(R)}` : void 0
        });
        d.fail$data(h(A));
      }
      function h(R) {
        return r._`${R}.compare(${l}, ${$}) ${a[_].fail} 0`;
      }
    },
    dependencies: ["format"]
  };
  const c = (d) => (d.addKeyword(e.formatLimitDefinition), d);
  e.default = c;
})(es);
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const r = xa, n = es, a = X, o = new a.Name("fullFormats"), c = new a.Name("fastFormats"), d = (l, $ = { keywords: !0 }) => {
    if (Array.isArray($))
      return y(l, $, r.fullFormats, o), l;
    const [_, C] = $.mode === "fast" ? [r.fastFormats, c] : [r.fullFormats, o], T = $.formats || r.formatNames;
    return y(l, T, _, C), $.keywords && n.default(l), l;
  };
  d.get = (l, $ = "full") => {
    const C = ($ === "fast" ? r.fastFormats : r.fullFormats)[l];
    if (!C)
      throw new Error(`Unknown format "${l}"`);
    return C;
  };
  function y(l, $, _, C) {
    var T, P;
    (T = (P = l.opts.code).formats) !== null && T !== void 0 || (P.formats = a._`require("ajv-formats/dist/formats").${C}`);
    for (const O of $)
      l.addFormat(O, _[O]);
  }
  e.exports = t = d, Object.defineProperty(t, "__esModule", { value: !0 }), t.default = d;
})(Mr, Mr.exports);
var Iu = Mr.exports;
const ku = /* @__PURE__ */ Vr(Iu), da = ku(
  ju(
    new Cu({
      allErrors: !0,
      $data: !0,
      strict: !0,
      strictTypes: !0,
      strictSchema: !0,
      strictRequired: !0,
      strictNumbers: !0,
      strictTuples: !0,
      coerceTypes: !0,
      removeAdditional: !0,
      useDefaults: !0
    })
  )
);
function Du(e, t = 250) {
  const [r, n] = ar(e);
  return Pr(() => {
    const a = setTimeout(() => {
      n(e);
    }, t);
    return () => {
      clearTimeout(a);
    };
  }, [e, t]), r;
}
const Mu = (e, t, r) => {
  var te;
  const n = fs(qn(e)), [a, o] = ar(qn(e)), [c, d] = ar(null), [y, l] = ar(0), $ = Du(c, (r == null ? void 0 : r.debounceTime) || 500);
  (te = r == null ? void 0 : r.customKeywords) != null && te.length && $s(da, r.customKeywords);
  const _ = da.compile(t), C = () => {
    o(n.current);
  }, T = (K) => {
    const M = _({ [K]: a[K].value }), z = _.errors || [], Q = M ? {} : Zt(z, r == null ? void 0 : r.userDefinedMessages), H = A && Q[K] || "";
    o((ae) => ({
      ...ae,
      [K]: {
        ...ae[K],
        error: H
      }
    }));
  }, P = (K) => {
    T(K);
  }, O = (K) => {
    o((M) => {
      const z = { ...M };
      return Object.keys(K).forEach((Q) => {
        var ae;
        const H = Q;
        z[H] = {
          ...z[H],
          value: Mt(K[H]),
          error: ((ae = z[H]) == null ? void 0 : ae.error) || ""
        };
      }), d({
        name: Object.keys(K)[0],
        editId: y
      }), l(y + 1), z;
    });
  }, g = (K) => Object.keys(K).reduce(
    (M, z) => {
      const Q = z;
      return {
        ...M,
        [z]: {
          value: Mt(a[Q].value),
          error: K[z] || ""
        }
      };
    },
    { ...a }
  ), m = () => {
    try {
      const K = Object.keys(a).reduce((M, z) => ({
        ...M,
        [z]: Mt(a[z].value)
      }), {});
      if (!_(K) && _.errors) {
        const M = Zt(
          _.errors,
          r == null ? void 0 : r.userDefinedMessages
        );
        return o(
          g(
            Object.keys(M).reduce((z, Q) => ({
              ...z,
              [Q]: Mt(M[Q])
            }), {})
          )
        ), { isValid: !1, data: null };
      }
      return R(a, n.current) ? { isValid: !0, data: K } : { isValid: !1, data: null };
    } catch {
      return { isValid: !1, data: null };
    }
  }, h = (K, M) => Object.keys(K).some(
    (z) => K[z].value !== M[z].value
  ), R = (K, M) => {
    const z = Object.keys(K).some(
      (H) => K[H].error !== ""
    ), Q = h(K, M);
    return !z && Q;
  }, k = Un(() => R(a, n.current), [a]), A = Un(
    () => h(a, n.current),
    [a]
  ), B = (K) => {
    o(g(Zt(K, r == null ? void 0 : r.userDefinedMessages)));
  };
  return Pr(() => {
    (r == null ? void 0 : r.shouldDebounceAndValidate) === !1 || !$ || T($.name);
  }, [$]), Pr(() => {
    var K;
    (K = r == null ? void 0 : r.errors) != null && K.length && o(g(Zt(r == null ? void 0 : r.errors, r == null ? void 0 : r.userDefinedMessages)));
  }, [r == null ? void 0 : r.errors]), {
    reset: C,
    set: O,
    setErrors: B,
    validate: m,
    onBlur: P,
    isValid: k,
    isDirty: A,
    data: Object.keys(a).reduce((K, M) => ({
      ...K,
      [M]: Mt(a[M].value)
    }), {}),
    state: a
  };
};
export {
  Mu as default
};
